// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package user

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/auth0/auth0_models"
)

// PostUsersReader is a Reader for the PostUsers structure.
type PostUsersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostUsersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewPostUsersCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostUsersUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostUsersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostUsersNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 409:
		result := NewPostUsersConflict()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostUsersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostUsersCreated creates a PostUsersCreated with default headers values
func NewPostUsersCreated() *PostUsersCreated {
	return &PostUsersCreated{}
}

/*PostUsersCreated handles this case with default header values.

New user created
*/
type PostUsersCreated struct {
}

func (o *PostUsersCreated) Error() string {
	return fmt.Sprintf("[POST /api/v2/users-by-email][%d] postUsersCreated ", 201)
}

func (o *PostUsersCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewPostUsersUnauthorized creates a PostUsersUnauthorized with default headers values
func NewPostUsersUnauthorized() *PostUsersUnauthorized {
	return &PostUsersUnauthorized{}
}

/*PostUsersUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostUsersUnauthorized struct {
	Payload *auth0_models.Error
}

func (o *PostUsersUnauthorized) Error() string {
	return fmt.Sprintf("[POST /api/v2/users-by-email][%d] postUsersUnauthorized  %+v", 401, o.Payload)
}

func (o *PostUsersUnauthorized) GetPayload() *auth0_models.Error {
	return o.Payload
}

func (o *PostUsersUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(auth0_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostUsersForbidden creates a PostUsersForbidden with default headers values
func NewPostUsersForbidden() *PostUsersForbidden {
	return &PostUsersForbidden{}
}

/*PostUsersForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostUsersForbidden struct {
	Payload *auth0_models.Error
}

func (o *PostUsersForbidden) Error() string {
	return fmt.Sprintf("[POST /api/v2/users-by-email][%d] postUsersForbidden  %+v", 403, o.Payload)
}

func (o *PostUsersForbidden) GetPayload() *auth0_models.Error {
	return o.Payload
}

func (o *PostUsersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(auth0_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostUsersNotFound creates a PostUsersNotFound with default headers values
func NewPostUsersNotFound() *PostUsersNotFound {
	return &PostUsersNotFound{}
}

/*PostUsersNotFound handles this case with default header values.

Resource was not found
*/
type PostUsersNotFound struct {
	Payload *auth0_models.Error
}

func (o *PostUsersNotFound) Error() string {
	return fmt.Sprintf("[POST /api/v2/users-by-email][%d] postUsersNotFound  %+v", 404, o.Payload)
}

func (o *PostUsersNotFound) GetPayload() *auth0_models.Error {
	return o.Payload
}

func (o *PostUsersNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(auth0_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostUsersConflict creates a PostUsersConflict with default headers values
func NewPostUsersConflict() *PostUsersConflict {
	return &PostUsersConflict{}
}

/*PostUsersConflict handles this case with default header values.

User already exists
*/
type PostUsersConflict struct {
}

func (o *PostUsersConflict) Error() string {
	return fmt.Sprintf("[POST /api/v2/users-by-email][%d] postUsersConflict ", 409)
}

func (o *PostUsersConflict) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewPostUsersInternalServerError creates a PostUsersInternalServerError with default headers values
func NewPostUsersInternalServerError() *PostUsersInternalServerError {
	return &PostUsersInternalServerError{}
}

/*PostUsersInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostUsersInternalServerError struct {
	Payload *auth0_models.Error
}

func (o *PostUsersInternalServerError) Error() string {
	return fmt.Sprintf("[POST /api/v2/users-by-email][%d] postUsersInternalServerError  %+v", 500, o.Payload)
}

func (o *PostUsersInternalServerError) GetPayload() *auth0_models.Error {
	return o.Payload
}

func (o *PostUsersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(auth0_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
