// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package transactions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/blaze/blaze_models"
)

// GetTransactionsReader is a Reader for the GetTransactions structure.
type GetTransactionsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetTransactionsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetTransactionsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetTransactionsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetTransactionsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetTransactionsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetTransactionsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetTransactionsOK creates a GetTransactionsOK with default headers values
func NewGetTransactionsOK() *GetTransactionsOK {
	return &GetTransactionsOK{}
}

/*GetTransactionsOK handles this case with default header values.

Transactions were successfully retrieved
*/
type GetTransactionsOK struct {
	Payload *blaze_models.TransactionsResponse
}

func (o *GetTransactionsOK) Error() string {
	return fmt.Sprintf("[GET /partner/transactions][%d] getTransactionsOK  %+v", 200, o.Payload)
}

func (o *GetTransactionsOK) GetPayload() *blaze_models.TransactionsResponse {
	return o.Payload
}

func (o *GetTransactionsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(blaze_models.TransactionsResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTransactionsUnauthorized creates a GetTransactionsUnauthorized with default headers values
func NewGetTransactionsUnauthorized() *GetTransactionsUnauthorized {
	return &GetTransactionsUnauthorized{}
}

/*GetTransactionsUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetTransactionsUnauthorized struct {
	Payload *blaze_models.Error
}

func (o *GetTransactionsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /partner/transactions][%d] getTransactionsUnauthorized  %+v", 401, o.Payload)
}

func (o *GetTransactionsUnauthorized) GetPayload() *blaze_models.Error {
	return o.Payload
}

func (o *GetTransactionsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(blaze_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTransactionsForbidden creates a GetTransactionsForbidden with default headers values
func NewGetTransactionsForbidden() *GetTransactionsForbidden {
	return &GetTransactionsForbidden{}
}

/*GetTransactionsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetTransactionsForbidden struct {
	Payload *blaze_models.Error
}

func (o *GetTransactionsForbidden) Error() string {
	return fmt.Sprintf("[GET /partner/transactions][%d] getTransactionsForbidden  %+v", 403, o.Payload)
}

func (o *GetTransactionsForbidden) GetPayload() *blaze_models.Error {
	return o.Payload
}

func (o *GetTransactionsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(blaze_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTransactionsNotFound creates a GetTransactionsNotFound with default headers values
func NewGetTransactionsNotFound() *GetTransactionsNotFound {
	return &GetTransactionsNotFound{}
}

/*GetTransactionsNotFound handles this case with default header values.

Resource was not found
*/
type GetTransactionsNotFound struct {
	Payload *blaze_models.Error
}

func (o *GetTransactionsNotFound) Error() string {
	return fmt.Sprintf("[GET /partner/transactions][%d] getTransactionsNotFound  %+v", 404, o.Payload)
}

func (o *GetTransactionsNotFound) GetPayload() *blaze_models.Error {
	return o.Payload
}

func (o *GetTransactionsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(blaze_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTransactionsInternalServerError creates a GetTransactionsInternalServerError with default headers values
func NewGetTransactionsInternalServerError() *GetTransactionsInternalServerError {
	return &GetTransactionsInternalServerError{}
}

/*GetTransactionsInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetTransactionsInternalServerError struct {
	Payload *blaze_models.Error
}

func (o *GetTransactionsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /partner/transactions][%d] getTransactionsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetTransactionsInternalServerError) GetPayload() *blaze_models.Error {
	return o.Payload
}

func (o *GetTransactionsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(blaze_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
