// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package accounts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetAccountsObservableParams creates a new GetAccountsObservableParams object
// with the default values initialized.
func NewGetAccountsObservableParams() *GetAccountsObservableParams {
	var ()
	return &GetAccountsObservableParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetAccountsObservableParamsWithTimeout creates a new GetAccountsObservableParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetAccountsObservableParamsWithTimeout(timeout time.Duration) *GetAccountsObservableParams {
	var ()
	return &GetAccountsObservableParams{

		timeout: timeout,
	}
}

// NewGetAccountsObservableParamsWithContext creates a new GetAccountsObservableParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetAccountsObservableParamsWithContext(ctx context.Context) *GetAccountsObservableParams {
	var ()
	return &GetAccountsObservableParams{

		Context: ctx,
	}
}

// NewGetAccountsObservableParamsWithHTTPClient creates a new GetAccountsObservableParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetAccountsObservableParamsWithHTTPClient(client *http.Client) *GetAccountsObservableParams {
	var ()
	return &GetAccountsObservableParams{
		HTTPClient: client,
	}
}

/*GetAccountsObservableParams contains all the parameters to send to the API endpoint
for the get accounts observable operation typically these are written to a http.Request
*/
type GetAccountsObservableParams struct {

	/*AccountID
	  Taxnexus Record Id of an Account

	*/
	AccountID *string
	/*Active
	  Only retrieve active records?

	*/
	Active *bool
	/*Email
	  Email address used for identity lookup

	*/
	Email *string
	/*Name
	  The Name of this Object

	*/
	Name *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get accounts observable params
func (o *GetAccountsObservableParams) WithTimeout(timeout time.Duration) *GetAccountsObservableParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get accounts observable params
func (o *GetAccountsObservableParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get accounts observable params
func (o *GetAccountsObservableParams) WithContext(ctx context.Context) *GetAccountsObservableParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get accounts observable params
func (o *GetAccountsObservableParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get accounts observable params
func (o *GetAccountsObservableParams) WithHTTPClient(client *http.Client) *GetAccountsObservableParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get accounts observable params
func (o *GetAccountsObservableParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the get accounts observable params
func (o *GetAccountsObservableParams) WithAccountID(accountID *string) *GetAccountsObservableParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the get accounts observable params
func (o *GetAccountsObservableParams) SetAccountID(accountID *string) {
	o.AccountID = accountID
}

// WithActive adds the active to the get accounts observable params
func (o *GetAccountsObservableParams) WithActive(active *bool) *GetAccountsObservableParams {
	o.SetActive(active)
	return o
}

// SetActive adds the active to the get accounts observable params
func (o *GetAccountsObservableParams) SetActive(active *bool) {
	o.Active = active
}

// WithEmail adds the email to the get accounts observable params
func (o *GetAccountsObservableParams) WithEmail(email *string) *GetAccountsObservableParams {
	o.SetEmail(email)
	return o
}

// SetEmail adds the email to the get accounts observable params
func (o *GetAccountsObservableParams) SetEmail(email *string) {
	o.Email = email
}

// WithName adds the name to the get accounts observable params
func (o *GetAccountsObservableParams) WithName(name *string) *GetAccountsObservableParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the get accounts observable params
func (o *GetAccountsObservableParams) SetName(name *string) {
	o.Name = name
}

// WriteToRequest writes these params to a swagger request
func (o *GetAccountsObservableParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccountID != nil {

		// query param accountId
		var qrAccountID string
		if o.AccountID != nil {
			qrAccountID = *o.AccountID
		}
		qAccountID := qrAccountID
		if qAccountID != "" {
			if err := r.SetQueryParam("accountId", qAccountID); err != nil {
				return err
			}
		}

	}

	if o.Active != nil {

		// query param active
		var qrActive bool
		if o.Active != nil {
			qrActive = *o.Active
		}
		qActive := swag.FormatBool(qrActive)
		if qActive != "" {
			if err := r.SetQueryParam("active", qActive); err != nil {
				return err
			}
		}

	}

	if o.Email != nil {

		// query param email
		var qrEmail string
		if o.Email != nil {
			qrEmail = *o.Email
		}
		qEmail := qrEmail
		if qEmail != "" {
			if err := r.SetQueryParam("email", qEmail); err != nil {
				return err
			}
		}

	}

	if o.Name != nil {

		// query param name
		var qrName string
		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {
			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
