// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package companies

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/crm/crm_models"
)

// GetCompaniesReader is a Reader for the GetCompanies structure.
type GetCompaniesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCompaniesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetCompaniesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetCompaniesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetCompaniesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetCompaniesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetCompaniesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetCompaniesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCompaniesOK creates a GetCompaniesOK with default headers values
func NewGetCompaniesOK() *GetCompaniesOK {
	return &GetCompaniesOK{}
}

/*GetCompaniesOK handles this case with default header values.

Taxnexus Response with Company objects
*/
type GetCompaniesOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *crm_models.CompanyResponse
}

func (o *GetCompaniesOK) Error() string {
	return fmt.Sprintf("[GET /companies][%d] getCompaniesOK  %+v", 200, o.Payload)
}

func (o *GetCompaniesOK) GetPayload() *crm_models.CompanyResponse {
	return o.Payload
}

func (o *GetCompaniesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(crm_models.CompanyResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCompaniesUnauthorized creates a GetCompaniesUnauthorized with default headers values
func NewGetCompaniesUnauthorized() *GetCompaniesUnauthorized {
	return &GetCompaniesUnauthorized{}
}

/*GetCompaniesUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetCompaniesUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetCompaniesUnauthorized) Error() string {
	return fmt.Sprintf("[GET /companies][%d] getCompaniesUnauthorized  %+v", 401, o.Payload)
}

func (o *GetCompaniesUnauthorized) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetCompaniesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCompaniesForbidden creates a GetCompaniesForbidden with default headers values
func NewGetCompaniesForbidden() *GetCompaniesForbidden {
	return &GetCompaniesForbidden{}
}

/*GetCompaniesForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetCompaniesForbidden struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetCompaniesForbidden) Error() string {
	return fmt.Sprintf("[GET /companies][%d] getCompaniesForbidden  %+v", 403, o.Payload)
}

func (o *GetCompaniesForbidden) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetCompaniesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCompaniesNotFound creates a GetCompaniesNotFound with default headers values
func NewGetCompaniesNotFound() *GetCompaniesNotFound {
	return &GetCompaniesNotFound{}
}

/*GetCompaniesNotFound handles this case with default header values.

Resource was not found
*/
type GetCompaniesNotFound struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetCompaniesNotFound) Error() string {
	return fmt.Sprintf("[GET /companies][%d] getCompaniesNotFound  %+v", 404, o.Payload)
}

func (o *GetCompaniesNotFound) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetCompaniesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCompaniesUnprocessableEntity creates a GetCompaniesUnprocessableEntity with default headers values
func NewGetCompaniesUnprocessableEntity() *GetCompaniesUnprocessableEntity {
	return &GetCompaniesUnprocessableEntity{}
}

/*GetCompaniesUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetCompaniesUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetCompaniesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /companies][%d] getCompaniesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetCompaniesUnprocessableEntity) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetCompaniesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCompaniesInternalServerError creates a GetCompaniesInternalServerError with default headers values
func NewGetCompaniesInternalServerError() *GetCompaniesInternalServerError {
	return &GetCompaniesInternalServerError{}
}

/*GetCompaniesInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetCompaniesInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetCompaniesInternalServerError) Error() string {
	return fmt.Sprintf("[GET /companies][%d] getCompaniesInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCompaniesInternalServerError) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetCompaniesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
