// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/crm/crm_models"
)

// GetContactsObservableReader is a Reader for the GetContactsObservable structure.
type GetContactsObservableReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetContactsObservableReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetContactsObservableOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetContactsObservableUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetContactsObservableForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetContactsObservableNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetContactsObservableUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetContactsObservableInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetContactsObservableOK creates a GetContactsObservableOK with default headers values
func NewGetContactsObservableOK() *GetContactsObservableOK {
	return &GetContactsObservableOK{}
}

/*GetContactsObservableOK handles this case with default header values.

Taxnexus Response with an array of Contact objects
*/
type GetContactsObservableOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload []*crm_models.Contact
}

func (o *GetContactsObservableOK) Error() string {
	return fmt.Sprintf("[GET /contacts/observable][%d] getContactsObservableOK  %+v", 200, o.Payload)
}

func (o *GetContactsObservableOK) GetPayload() []*crm_models.Contact {
	return o.Payload
}

func (o *GetContactsObservableOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetContactsObservableUnauthorized creates a GetContactsObservableUnauthorized with default headers values
func NewGetContactsObservableUnauthorized() *GetContactsObservableUnauthorized {
	return &GetContactsObservableUnauthorized{}
}

/*GetContactsObservableUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetContactsObservableUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetContactsObservableUnauthorized) Error() string {
	return fmt.Sprintf("[GET /contacts/observable][%d] getContactsObservableUnauthorized  %+v", 401, o.Payload)
}

func (o *GetContactsObservableUnauthorized) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetContactsObservableUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetContactsObservableForbidden creates a GetContactsObservableForbidden with default headers values
func NewGetContactsObservableForbidden() *GetContactsObservableForbidden {
	return &GetContactsObservableForbidden{}
}

/*GetContactsObservableForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetContactsObservableForbidden struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetContactsObservableForbidden) Error() string {
	return fmt.Sprintf("[GET /contacts/observable][%d] getContactsObservableForbidden  %+v", 403, o.Payload)
}

func (o *GetContactsObservableForbidden) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetContactsObservableForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetContactsObservableNotFound creates a GetContactsObservableNotFound with default headers values
func NewGetContactsObservableNotFound() *GetContactsObservableNotFound {
	return &GetContactsObservableNotFound{}
}

/*GetContactsObservableNotFound handles this case with default header values.

Resource was not found
*/
type GetContactsObservableNotFound struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetContactsObservableNotFound) Error() string {
	return fmt.Sprintf("[GET /contacts/observable][%d] getContactsObservableNotFound  %+v", 404, o.Payload)
}

func (o *GetContactsObservableNotFound) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetContactsObservableNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetContactsObservableUnprocessableEntity creates a GetContactsObservableUnprocessableEntity with default headers values
func NewGetContactsObservableUnprocessableEntity() *GetContactsObservableUnprocessableEntity {
	return &GetContactsObservableUnprocessableEntity{}
}

/*GetContactsObservableUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetContactsObservableUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetContactsObservableUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /contacts/observable][%d] getContactsObservableUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetContactsObservableUnprocessableEntity) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetContactsObservableUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetContactsObservableInternalServerError creates a GetContactsObservableInternalServerError with default headers values
func NewGetContactsObservableInternalServerError() *GetContactsObservableInternalServerError {
	return &GetContactsObservableInternalServerError{}
}

/*GetContactsObservableInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetContactsObservableInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetContactsObservableInternalServerError) Error() string {
	return fmt.Sprintf("[GET /contacts/observable][%d] getContactsObservableInternalServerError  %+v", 500, o.Payload)
}

func (o *GetContactsObservableInternalServerError) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetContactsObservableInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
