// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package leads

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/crm/crm_models"
)

// GetLeadsObservableReader is a Reader for the GetLeadsObservable structure.
type GetLeadsObservableReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetLeadsObservableReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetLeadsObservableOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetLeadsObservableUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetLeadsObservableForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetLeadsObservableNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetLeadsObservableUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetLeadsObservableInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetLeadsObservableOK creates a GetLeadsObservableOK with default headers values
func NewGetLeadsObservableOK() *GetLeadsObservableOK {
	return &GetLeadsObservableOK{}
}

/*GetLeadsObservableOK handles this case with default header values.

Taxnexus Response with an array of Lead objects
*/
type GetLeadsObservableOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload []*crm_models.Lead
}

func (o *GetLeadsObservableOK) Error() string {
	return fmt.Sprintf("[GET /leads/observable][%d] getLeadsObservableOK  %+v", 200, o.Payload)
}

func (o *GetLeadsObservableOK) GetPayload() []*crm_models.Lead {
	return o.Payload
}

func (o *GetLeadsObservableOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetLeadsObservableUnauthorized creates a GetLeadsObservableUnauthorized with default headers values
func NewGetLeadsObservableUnauthorized() *GetLeadsObservableUnauthorized {
	return &GetLeadsObservableUnauthorized{}
}

/*GetLeadsObservableUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetLeadsObservableUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetLeadsObservableUnauthorized) Error() string {
	return fmt.Sprintf("[GET /leads/observable][%d] getLeadsObservableUnauthorized  %+v", 401, o.Payload)
}

func (o *GetLeadsObservableUnauthorized) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetLeadsObservableUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetLeadsObservableForbidden creates a GetLeadsObservableForbidden with default headers values
func NewGetLeadsObservableForbidden() *GetLeadsObservableForbidden {
	return &GetLeadsObservableForbidden{}
}

/*GetLeadsObservableForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetLeadsObservableForbidden struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetLeadsObservableForbidden) Error() string {
	return fmt.Sprintf("[GET /leads/observable][%d] getLeadsObservableForbidden  %+v", 403, o.Payload)
}

func (o *GetLeadsObservableForbidden) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetLeadsObservableForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetLeadsObservableNotFound creates a GetLeadsObservableNotFound with default headers values
func NewGetLeadsObservableNotFound() *GetLeadsObservableNotFound {
	return &GetLeadsObservableNotFound{}
}

/*GetLeadsObservableNotFound handles this case with default header values.

Resource was not found
*/
type GetLeadsObservableNotFound struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetLeadsObservableNotFound) Error() string {
	return fmt.Sprintf("[GET /leads/observable][%d] getLeadsObservableNotFound  %+v", 404, o.Payload)
}

func (o *GetLeadsObservableNotFound) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetLeadsObservableNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetLeadsObservableUnprocessableEntity creates a GetLeadsObservableUnprocessableEntity with default headers values
func NewGetLeadsObservableUnprocessableEntity() *GetLeadsObservableUnprocessableEntity {
	return &GetLeadsObservableUnprocessableEntity{}
}

/*GetLeadsObservableUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetLeadsObservableUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetLeadsObservableUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /leads/observable][%d] getLeadsObservableUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetLeadsObservableUnprocessableEntity) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetLeadsObservableUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetLeadsObservableInternalServerError creates a GetLeadsObservableInternalServerError with default headers values
func NewGetLeadsObservableInternalServerError() *GetLeadsObservableInternalServerError {
	return &GetLeadsObservableInternalServerError{}
}

/*GetLeadsObservableInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetLeadsObservableInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *GetLeadsObservableInternalServerError) Error() string {
	return fmt.Sprintf("[GET /leads/observable][%d] getLeadsObservableInternalServerError  %+v", 500, o.Payload)
}

func (o *GetLeadsObservableInternalServerError) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetLeadsObservableInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
