// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/devops/devops_models"
)

// GetClustersReader is a Reader for the GetClusters structure.
type GetClustersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetClustersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetClustersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetClustersUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetClustersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetClustersNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetClustersUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetClustersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetClustersOK creates a GetClustersOK with default headers values
func NewGetClustersOK() *GetClustersOK {
	return &GetClustersOK{}
}

/*GetClustersOK handles this case with default header values.

Taxnexus Response with Cluster objects
*/
type GetClustersOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.ClusterResponse
}

func (o *GetClustersOK) Error() string {
	return fmt.Sprintf("[GET /clusters][%d] getClustersOK  %+v", 200, o.Payload)
}

func (o *GetClustersOK) GetPayload() *devops_models.ClusterResponse {
	return o.Payload
}

func (o *GetClustersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.ClusterResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClustersUnauthorized creates a GetClustersUnauthorized with default headers values
func NewGetClustersUnauthorized() *GetClustersUnauthorized {
	return &GetClustersUnauthorized{}
}

/*GetClustersUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetClustersUnauthorized struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *GetClustersUnauthorized) Error() string {
	return fmt.Sprintf("[GET /clusters][%d] getClustersUnauthorized  %+v", 401, o.Payload)
}

func (o *GetClustersUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetClustersUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClustersForbidden creates a GetClustersForbidden with default headers values
func NewGetClustersForbidden() *GetClustersForbidden {
	return &GetClustersForbidden{}
}

/*GetClustersForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetClustersForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetClustersForbidden) Error() string {
	return fmt.Sprintf("[GET /clusters][%d] getClustersForbidden  %+v", 403, o.Payload)
}

func (o *GetClustersForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetClustersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClustersNotFound creates a GetClustersNotFound with default headers values
func NewGetClustersNotFound() *GetClustersNotFound {
	return &GetClustersNotFound{}
}

/*GetClustersNotFound handles this case with default header values.

Resource was not found
*/
type GetClustersNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetClustersNotFound) Error() string {
	return fmt.Sprintf("[GET /clusters][%d] getClustersNotFound  %+v", 404, o.Payload)
}

func (o *GetClustersNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetClustersNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClustersUnprocessableEntity creates a GetClustersUnprocessableEntity with default headers values
func NewGetClustersUnprocessableEntity() *GetClustersUnprocessableEntity {
	return &GetClustersUnprocessableEntity{}
}

/*GetClustersUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetClustersUnprocessableEntity struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *GetClustersUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /clusters][%d] getClustersUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetClustersUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetClustersUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClustersInternalServerError creates a GetClustersInternalServerError with default headers values
func NewGetClustersInternalServerError() *GetClustersInternalServerError {
	return &GetClustersInternalServerError{}
}

/*GetClustersInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetClustersInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetClustersInternalServerError) Error() string {
	return fmt.Sprintf("[GET /clusters][%d] getClustersInternalServerError  %+v", 500, o.Payload)
}

func (o *GetClustersInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetClustersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
