// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package database

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/devops/devops_models"
)

// PostDatabasesReader is a Reader for the PostDatabases structure.
type PostDatabasesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostDatabasesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostDatabasesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostDatabasesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostDatabasesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostDatabasesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostDatabasesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostDatabasesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostDatabasesOK creates a PostDatabasesOK with default headers values
func NewPostDatabasesOK() *PostDatabasesOK {
	return &PostDatabasesOK{}
}

/*PostDatabasesOK handles this case with default header values.

Taxnexus Response with Database objects
*/
type PostDatabasesOK struct {
	AccessControlAllowOrigin string

	Payload *devops_models.DatabaseResponse
}

func (o *PostDatabasesOK) Error() string {
	return fmt.Sprintf("[POST /databases][%d] postDatabasesOK  %+v", 200, o.Payload)
}

func (o *PostDatabasesOK) GetPayload() *devops_models.DatabaseResponse {
	return o.Payload
}

func (o *PostDatabasesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.DatabaseResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostDatabasesUnauthorized creates a PostDatabasesUnauthorized with default headers values
func NewPostDatabasesUnauthorized() *PostDatabasesUnauthorized {
	return &PostDatabasesUnauthorized{}
}

/*PostDatabasesUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostDatabasesUnauthorized struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *PostDatabasesUnauthorized) Error() string {
	return fmt.Sprintf("[POST /databases][%d] postDatabasesUnauthorized  %+v", 401, o.Payload)
}

func (o *PostDatabasesUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostDatabasesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostDatabasesForbidden creates a PostDatabasesForbidden with default headers values
func NewPostDatabasesForbidden() *PostDatabasesForbidden {
	return &PostDatabasesForbidden{}
}

/*PostDatabasesForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostDatabasesForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *PostDatabasesForbidden) Error() string {
	return fmt.Sprintf("[POST /databases][%d] postDatabasesForbidden  %+v", 403, o.Payload)
}

func (o *PostDatabasesForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostDatabasesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostDatabasesNotFound creates a PostDatabasesNotFound with default headers values
func NewPostDatabasesNotFound() *PostDatabasesNotFound {
	return &PostDatabasesNotFound{}
}

/*PostDatabasesNotFound handles this case with default header values.

Resource was not found
*/
type PostDatabasesNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *PostDatabasesNotFound) Error() string {
	return fmt.Sprintf("[POST /databases][%d] postDatabasesNotFound  %+v", 404, o.Payload)
}

func (o *PostDatabasesNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostDatabasesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostDatabasesUnprocessableEntity creates a PostDatabasesUnprocessableEntity with default headers values
func NewPostDatabasesUnprocessableEntity() *PostDatabasesUnprocessableEntity {
	return &PostDatabasesUnprocessableEntity{}
}

/*PostDatabasesUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostDatabasesUnprocessableEntity struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *PostDatabasesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /databases][%d] postDatabasesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostDatabasesUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostDatabasesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostDatabasesInternalServerError creates a PostDatabasesInternalServerError with default headers values
func NewPostDatabasesInternalServerError() *PostDatabasesInternalServerError {
	return &PostDatabasesInternalServerError{}
}

/*PostDatabasesInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostDatabasesInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *PostDatabasesInternalServerError) Error() string {
	return fmt.Sprintf("[POST /databases][%d] postDatabasesInternalServerError  %+v", 500, o.Payload)
}

func (o *PostDatabasesInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostDatabasesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
