// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package ingest

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/devops/devops_models"
)

// GetIngestsReader is a Reader for the GetIngests structure.
type GetIngestsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetIngestsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetIngestsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetIngestsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetIngestsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetIngestsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetIngestsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetIngestsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetIngestsOK creates a GetIngestsOK with default headers values
func NewGetIngestsOK() *GetIngestsOK {
	return &GetIngestsOK{}
}

/*GetIngestsOK handles this case with default header values.

Taxnexus Response with Ingest objects
*/
type GetIngestsOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.IngestResponse
}

func (o *GetIngestsOK) Error() string {
	return fmt.Sprintf("[GET /ingests][%d] getIngestsOK  %+v", 200, o.Payload)
}

func (o *GetIngestsOK) GetPayload() *devops_models.IngestResponse {
	return o.Payload
}

func (o *GetIngestsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.IngestResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetIngestsUnauthorized creates a GetIngestsUnauthorized with default headers values
func NewGetIngestsUnauthorized() *GetIngestsUnauthorized {
	return &GetIngestsUnauthorized{}
}

/*GetIngestsUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetIngestsUnauthorized struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *GetIngestsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /ingests][%d] getIngestsUnauthorized  %+v", 401, o.Payload)
}

func (o *GetIngestsUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetIngestsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetIngestsForbidden creates a GetIngestsForbidden with default headers values
func NewGetIngestsForbidden() *GetIngestsForbidden {
	return &GetIngestsForbidden{}
}

/*GetIngestsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetIngestsForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetIngestsForbidden) Error() string {
	return fmt.Sprintf("[GET /ingests][%d] getIngestsForbidden  %+v", 403, o.Payload)
}

func (o *GetIngestsForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetIngestsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetIngestsNotFound creates a GetIngestsNotFound with default headers values
func NewGetIngestsNotFound() *GetIngestsNotFound {
	return &GetIngestsNotFound{}
}

/*GetIngestsNotFound handles this case with default header values.

Resource was not found
*/
type GetIngestsNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetIngestsNotFound) Error() string {
	return fmt.Sprintf("[GET /ingests][%d] getIngestsNotFound  %+v", 404, o.Payload)
}

func (o *GetIngestsNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetIngestsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetIngestsUnprocessableEntity creates a GetIngestsUnprocessableEntity with default headers values
func NewGetIngestsUnprocessableEntity() *GetIngestsUnprocessableEntity {
	return &GetIngestsUnprocessableEntity{}
}

/*GetIngestsUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetIngestsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *GetIngestsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /ingests][%d] getIngestsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetIngestsUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetIngestsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetIngestsInternalServerError creates a GetIngestsInternalServerError with default headers values
func NewGetIngestsInternalServerError() *GetIngestsInternalServerError {
	return &GetIngestsInternalServerError{}
}

/*GetIngestsInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetIngestsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetIngestsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /ingests][%d] getIngestsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetIngestsInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetIngestsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
