// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package ingest

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/devops/devops_models"
)

// PostIngestsReader is a Reader for the PostIngests structure.
type PostIngestsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostIngestsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostIngestsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostIngestsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostIngestsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostIngestsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostIngestsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostIngestsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostIngestsOK creates a PostIngestsOK with default headers values
func NewPostIngestsOK() *PostIngestsOK {
	return &PostIngestsOK{}
}

/*PostIngestsOK handles this case with default header values.

Taxnexus Response with Ingest objects
*/
type PostIngestsOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.IngestResponse
}

func (o *PostIngestsOK) Error() string {
	return fmt.Sprintf("[POST /ingests][%d] postIngestsOK  %+v", 200, o.Payload)
}

func (o *PostIngestsOK) GetPayload() *devops_models.IngestResponse {
	return o.Payload
}

func (o *PostIngestsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.IngestResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostIngestsUnauthorized creates a PostIngestsUnauthorized with default headers values
func NewPostIngestsUnauthorized() *PostIngestsUnauthorized {
	return &PostIngestsUnauthorized{}
}

/*PostIngestsUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostIngestsUnauthorized struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *PostIngestsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /ingests][%d] postIngestsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostIngestsUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostIngestsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostIngestsForbidden creates a PostIngestsForbidden with default headers values
func NewPostIngestsForbidden() *PostIngestsForbidden {
	return &PostIngestsForbidden{}
}

/*PostIngestsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostIngestsForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *PostIngestsForbidden) Error() string {
	return fmt.Sprintf("[POST /ingests][%d] postIngestsForbidden  %+v", 403, o.Payload)
}

func (o *PostIngestsForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostIngestsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostIngestsNotFound creates a PostIngestsNotFound with default headers values
func NewPostIngestsNotFound() *PostIngestsNotFound {
	return &PostIngestsNotFound{}
}

/*PostIngestsNotFound handles this case with default header values.

Resource was not found
*/
type PostIngestsNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *PostIngestsNotFound) Error() string {
	return fmt.Sprintf("[POST /ingests][%d] postIngestsNotFound  %+v", 404, o.Payload)
}

func (o *PostIngestsNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostIngestsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostIngestsUnprocessableEntity creates a PostIngestsUnprocessableEntity with default headers values
func NewPostIngestsUnprocessableEntity() *PostIngestsUnprocessableEntity {
	return &PostIngestsUnprocessableEntity{}
}

/*PostIngestsUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostIngestsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *PostIngestsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /ingests][%d] postIngestsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostIngestsUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostIngestsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostIngestsInternalServerError creates a PostIngestsInternalServerError with default headers values
func NewPostIngestsInternalServerError() *PostIngestsInternalServerError {
	return &PostIngestsInternalServerError{}
}

/*PostIngestsInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostIngestsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *PostIngestsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /ingests][%d] postIngestsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostIngestsInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PostIngestsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
