// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package job

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/devops/devops_models"
)

// GetJobReader is a Reader for the GetJob structure.
type GetJobReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetJobReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetJobOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetJobUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetJobForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetJobNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetJobUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetJobInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetJobOK creates a GetJobOK with default headers values
func NewGetJobOK() *GetJobOK {
	return &GetJobOK{}
}

/*GetJobOK handles this case with default header values.

Single Job record response
*/
type GetJobOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Job
}

func (o *GetJobOK) Error() string {
	return fmt.Sprintf("[GET /jobs/{jobIdPath}][%d] getJobOK  %+v", 200, o.Payload)
}

func (o *GetJobOK) GetPayload() *devops_models.Job {
	return o.Payload
}

func (o *GetJobOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Job)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetJobUnauthorized creates a GetJobUnauthorized with default headers values
func NewGetJobUnauthorized() *GetJobUnauthorized {
	return &GetJobUnauthorized{}
}

/*GetJobUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetJobUnauthorized struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *GetJobUnauthorized) Error() string {
	return fmt.Sprintf("[GET /jobs/{jobIdPath}][%d] getJobUnauthorized  %+v", 401, o.Payload)
}

func (o *GetJobUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetJobUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetJobForbidden creates a GetJobForbidden with default headers values
func NewGetJobForbidden() *GetJobForbidden {
	return &GetJobForbidden{}
}

/*GetJobForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetJobForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetJobForbidden) Error() string {
	return fmt.Sprintf("[GET /jobs/{jobIdPath}][%d] getJobForbidden  %+v", 403, o.Payload)
}

func (o *GetJobForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetJobForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetJobNotFound creates a GetJobNotFound with default headers values
func NewGetJobNotFound() *GetJobNotFound {
	return &GetJobNotFound{}
}

/*GetJobNotFound handles this case with default header values.

Resource was not found
*/
type GetJobNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetJobNotFound) Error() string {
	return fmt.Sprintf("[GET /jobs/{jobIdPath}][%d] getJobNotFound  %+v", 404, o.Payload)
}

func (o *GetJobNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetJobNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetJobUnprocessableEntity creates a GetJobUnprocessableEntity with default headers values
func NewGetJobUnprocessableEntity() *GetJobUnprocessableEntity {
	return &GetJobUnprocessableEntity{}
}

/*GetJobUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetJobUnprocessableEntity struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *GetJobUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /jobs/{jobIdPath}][%d] getJobUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetJobUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetJobUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetJobInternalServerError creates a GetJobInternalServerError with default headers values
func NewGetJobInternalServerError() *GetJobInternalServerError {
	return &GetJobInternalServerError{}
}

/*GetJobInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetJobInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetJobInternalServerError) Error() string {
	return fmt.Sprintf("[GET /jobs/{jobIdPath}][%d] getJobInternalServerError  %+v", 500, o.Payload)
}

func (o *GetJobInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetJobInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
