// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package template

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/devops/devops_models"
)

// GetTemplateReader is a Reader for the GetTemplate structure.
type GetTemplateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetTemplateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetTemplateOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetTemplateUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetTemplateForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetTemplateNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetTemplateUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetTemplateInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetTemplateOK creates a GetTemplateOK with default headers values
func NewGetTemplateOK() *GetTemplateOK {
	return &GetTemplateOK{}
}

/*GetTemplateOK handles this case with default header values.

Single Template record response
*/
type GetTemplateOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Template
}

func (o *GetTemplateOK) Error() string {
	return fmt.Sprintf("[GET /templates/{templateIdPath}][%d] getTemplateOK  %+v", 200, o.Payload)
}

func (o *GetTemplateOK) GetPayload() *devops_models.Template {
	return o.Payload
}

func (o *GetTemplateOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Template)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTemplateUnauthorized creates a GetTemplateUnauthorized with default headers values
func NewGetTemplateUnauthorized() *GetTemplateUnauthorized {
	return &GetTemplateUnauthorized{}
}

/*GetTemplateUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetTemplateUnauthorized struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *GetTemplateUnauthorized) Error() string {
	return fmt.Sprintf("[GET /templates/{templateIdPath}][%d] getTemplateUnauthorized  %+v", 401, o.Payload)
}

func (o *GetTemplateUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTemplateUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTemplateForbidden creates a GetTemplateForbidden with default headers values
func NewGetTemplateForbidden() *GetTemplateForbidden {
	return &GetTemplateForbidden{}
}

/*GetTemplateForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetTemplateForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetTemplateForbidden) Error() string {
	return fmt.Sprintf("[GET /templates/{templateIdPath}][%d] getTemplateForbidden  %+v", 403, o.Payload)
}

func (o *GetTemplateForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTemplateForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTemplateNotFound creates a GetTemplateNotFound with default headers values
func NewGetTemplateNotFound() *GetTemplateNotFound {
	return &GetTemplateNotFound{}
}

/*GetTemplateNotFound handles this case with default header values.

Resource was not found
*/
type GetTemplateNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetTemplateNotFound) Error() string {
	return fmt.Sprintf("[GET /templates/{templateIdPath}][%d] getTemplateNotFound  %+v", 404, o.Payload)
}

func (o *GetTemplateNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTemplateNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTemplateUnprocessableEntity creates a GetTemplateUnprocessableEntity with default headers values
func NewGetTemplateUnprocessableEntity() *GetTemplateUnprocessableEntity {
	return &GetTemplateUnprocessableEntity{}
}

/*GetTemplateUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetTemplateUnprocessableEntity struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *GetTemplateUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /templates/{templateIdPath}][%d] getTemplateUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetTemplateUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTemplateUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTemplateInternalServerError creates a GetTemplateInternalServerError with default headers values
func NewGetTemplateInternalServerError() *GetTemplateInternalServerError {
	return &GetTemplateInternalServerError{}
}

/*GetTemplateInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetTemplateInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetTemplateInternalServerError) Error() string {
	return fmt.Sprintf("[GET /templates/{templateIdPath}][%d] getTemplateInternalServerError  %+v", 500, o.Payload)
}

func (o *GetTemplateInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTemplateInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
