// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tenant

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/devops/devops_models"
)

// GetTenantReader is a Reader for the GetTenant structure.
type GetTenantReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetTenantReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetTenantOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetTenantUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetTenantForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetTenantNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetTenantUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetTenantInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetTenantOK creates a GetTenantOK with default headers values
func NewGetTenantOK() *GetTenantOK {
	return &GetTenantOK{}
}

/*GetTenantOK handles this case with default header values.

Single Tenant record response
*/
type GetTenantOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Tenant
}

func (o *GetTenantOK) Error() string {
	return fmt.Sprintf("[GET /tenants/{tenantIdPath}][%d] getTenantOK  %+v", 200, o.Payload)
}

func (o *GetTenantOK) GetPayload() *devops_models.Tenant {
	return o.Payload
}

func (o *GetTenantOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Tenant)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantUnauthorized creates a GetTenantUnauthorized with default headers values
func NewGetTenantUnauthorized() *GetTenantUnauthorized {
	return &GetTenantUnauthorized{}
}

/*GetTenantUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetTenantUnauthorized struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *GetTenantUnauthorized) Error() string {
	return fmt.Sprintf("[GET /tenants/{tenantIdPath}][%d] getTenantUnauthorized  %+v", 401, o.Payload)
}

func (o *GetTenantUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTenantUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantForbidden creates a GetTenantForbidden with default headers values
func NewGetTenantForbidden() *GetTenantForbidden {
	return &GetTenantForbidden{}
}

/*GetTenantForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetTenantForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetTenantForbidden) Error() string {
	return fmt.Sprintf("[GET /tenants/{tenantIdPath}][%d] getTenantForbidden  %+v", 403, o.Payload)
}

func (o *GetTenantForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTenantForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantNotFound creates a GetTenantNotFound with default headers values
func NewGetTenantNotFound() *GetTenantNotFound {
	return &GetTenantNotFound{}
}

/*GetTenantNotFound handles this case with default header values.

Resource was not found
*/
type GetTenantNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetTenantNotFound) Error() string {
	return fmt.Sprintf("[GET /tenants/{tenantIdPath}][%d] getTenantNotFound  %+v", 404, o.Payload)
}

func (o *GetTenantNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTenantNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantUnprocessableEntity creates a GetTenantUnprocessableEntity with default headers values
func NewGetTenantUnprocessableEntity() *GetTenantUnprocessableEntity {
	return &GetTenantUnprocessableEntity{}
}

/*GetTenantUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetTenantUnprocessableEntity struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *GetTenantUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /tenants/{tenantIdPath}][%d] getTenantUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetTenantUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTenantUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantInternalServerError creates a GetTenantInternalServerError with default headers values
func NewGetTenantInternalServerError() *GetTenantInternalServerError {
	return &GetTenantInternalServerError{}
}

/*GetTenantInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetTenantInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetTenantInternalServerError) Error() string {
	return fmt.Sprintf("[GET /tenants/{tenantIdPath}][%d] getTenantInternalServerError  %+v", 500, o.Payload)
}

func (o *GetTenantInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTenantInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
