// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tenant

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/devops/devops_models"
)

// GetTenantsReader is a Reader for the GetTenants structure.
type GetTenantsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetTenantsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetTenantsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetTenantsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetTenantsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetTenantsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetTenantsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetTenantsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetTenantsOK creates a GetTenantsOK with default headers values
func NewGetTenantsOK() *GetTenantsOK {
	return &GetTenantsOK{}
}

/*GetTenantsOK handles this case with default header values.

Taxnexus Response with Tenant objects
*/
type GetTenantsOK struct {
	AccessControlAllowOrigin string

	Payload *devops_models.TenantResponse
}

func (o *GetTenantsOK) Error() string {
	return fmt.Sprintf("[GET /tenants][%d] getTenantsOK  %+v", 200, o.Payload)
}

func (o *GetTenantsOK) GetPayload() *devops_models.TenantResponse {
	return o.Payload
}

func (o *GetTenantsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.TenantResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantsUnauthorized creates a GetTenantsUnauthorized with default headers values
func NewGetTenantsUnauthorized() *GetTenantsUnauthorized {
	return &GetTenantsUnauthorized{}
}

/*GetTenantsUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetTenantsUnauthorized struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *GetTenantsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /tenants][%d] getTenantsUnauthorized  %+v", 401, o.Payload)
}

func (o *GetTenantsUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTenantsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantsForbidden creates a GetTenantsForbidden with default headers values
func NewGetTenantsForbidden() *GetTenantsForbidden {
	return &GetTenantsForbidden{}
}

/*GetTenantsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetTenantsForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetTenantsForbidden) Error() string {
	return fmt.Sprintf("[GET /tenants][%d] getTenantsForbidden  %+v", 403, o.Payload)
}

func (o *GetTenantsForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTenantsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantsNotFound creates a GetTenantsNotFound with default headers values
func NewGetTenantsNotFound() *GetTenantsNotFound {
	return &GetTenantsNotFound{}
}

/*GetTenantsNotFound handles this case with default header values.

Resource was not found
*/
type GetTenantsNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetTenantsNotFound) Error() string {
	return fmt.Sprintf("[GET /tenants][%d] getTenantsNotFound  %+v", 404, o.Payload)
}

func (o *GetTenantsNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTenantsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantsUnprocessableEntity creates a GetTenantsUnprocessableEntity with default headers values
func NewGetTenantsUnprocessableEntity() *GetTenantsUnprocessableEntity {
	return &GetTenantsUnprocessableEntity{}
}

/*GetTenantsUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetTenantsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *GetTenantsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /tenants][%d] getTenantsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetTenantsUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTenantsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantsInternalServerError creates a GetTenantsInternalServerError with default headers values
func NewGetTenantsInternalServerError() *GetTenantsInternalServerError {
	return &GetTenantsInternalServerError{}
}

/*GetTenantsInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetTenantsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *GetTenantsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /tenants][%d] getTenantsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetTenantsInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTenantsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
