// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package country

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/geo/geo_models"
)

// PostCountriesReader is a Reader for the PostCountries structure.
type PostCountriesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostCountriesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostCountriesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostCountriesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostCountriesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostCountriesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostCountriesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostCountriesOK creates a PostCountriesOK with default headers values
func NewPostCountriesOK() *PostCountriesOK {
	return &PostCountriesOK{}
}

/*PostCountriesOK handles this case with default header values.

Taxnexus Response with an array of Country objects
*/
type PostCountriesOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *geo_models.CountryResponse
}

func (o *PostCountriesOK) Error() string {
	return fmt.Sprintf("[POST /countries][%d] postCountriesOK  %+v", 200, o.Payload)
}

func (o *PostCountriesOK) GetPayload() *geo_models.CountryResponse {
	return o.Payload
}

func (o *PostCountriesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(geo_models.CountryResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostCountriesUnauthorized creates a PostCountriesUnauthorized with default headers values
func NewPostCountriesUnauthorized() *PostCountriesUnauthorized {
	return &PostCountriesUnauthorized{}
}

/*PostCountriesUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PostCountriesUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *geo_models.Error
}

func (o *PostCountriesUnauthorized) Error() string {
	return fmt.Sprintf("[POST /countries][%d] postCountriesUnauthorized  %+v", 401, o.Payload)
}

func (o *PostCountriesUnauthorized) GetPayload() *geo_models.Error {
	return o.Payload
}

func (o *PostCountriesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(geo_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostCountriesForbidden creates a PostCountriesForbidden with default headers values
func NewPostCountriesForbidden() *PostCountriesForbidden {
	return &PostCountriesForbidden{}
}

/*PostCountriesForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostCountriesForbidden struct {
	AccessControlAllowOrigin string

	Payload *geo_models.Error
}

func (o *PostCountriesForbidden) Error() string {
	return fmt.Sprintf("[POST /countries][%d] postCountriesForbidden  %+v", 403, o.Payload)
}

func (o *PostCountriesForbidden) GetPayload() *geo_models.Error {
	return o.Payload
}

func (o *PostCountriesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(geo_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostCountriesNotFound creates a PostCountriesNotFound with default headers values
func NewPostCountriesNotFound() *PostCountriesNotFound {
	return &PostCountriesNotFound{}
}

/*PostCountriesNotFound handles this case with default header values.

Resource was not found
*/
type PostCountriesNotFound struct {
	AccessControlAllowOrigin string

	Payload *geo_models.Error
}

func (o *PostCountriesNotFound) Error() string {
	return fmt.Sprintf("[POST /countries][%d] postCountriesNotFound  %+v", 404, o.Payload)
}

func (o *PostCountriesNotFound) GetPayload() *geo_models.Error {
	return o.Payload
}

func (o *PostCountriesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(geo_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostCountriesInternalServerError creates a PostCountriesInternalServerError with default headers values
func NewPostCountriesInternalServerError() *PostCountriesInternalServerError {
	return &PostCountriesInternalServerError{}
}

/*PostCountriesInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostCountriesInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *geo_models.Error
}

func (o *PostCountriesInternalServerError) Error() string {
	return fmt.Sprintf("[POST /countries][%d] postCountriesInternalServerError  %+v", 500, o.Payload)
}

func (o *PostCountriesInternalServerError) GetPayload() *geo_models.Error {
	return o.Payload
}

func (o *PostCountriesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(geo_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
