// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package county

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new county API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for county API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	GetCounties(params *GetCountiesParams, authInfo runtime.ClientAuthInfoWriter) (*GetCountiesOK, error)

	GetCountiesObservable(params *GetCountiesObservableParams, authInfo runtime.ClientAuthInfoWriter) (*GetCountiesObservableOK, error)

	PostCounties(params *PostCountiesParams, authInfo runtime.ClientAuthInfoWriter) (*PostCountiesOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetCounties retrieves counties

  Retrieve Counties, filter with parameters
*/
func (a *Client) GetCounties(params *GetCountiesParams, authInfo runtime.ClientAuthInfoWriter) (*GetCountiesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetCountiesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getCounties",
		Method:             "GET",
		PathPattern:        "/counties",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetCountiesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetCountiesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getCounties: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetCountiesObservable gets counties in an observable array

  Returns a county retrieval in a observable array
*/
func (a *Client) GetCountiesObservable(params *GetCountiesObservableParams, authInfo runtime.ClientAuthInfoWriter) (*GetCountiesObservableOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetCountiesObservableParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getCountiesObservable",
		Method:             "GET",
		PathPattern:        "/counties/observable",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetCountiesObservableReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetCountiesObservableOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getCountiesObservable: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostCounties stores new counties

  Create New Counties
*/
func (a *Client) PostCounties(params *PostCountiesParams, authInfo runtime.ClientAuthInfoWriter) (*PostCountiesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostCountiesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postCounties",
		Method:             "POST",
		PathPattern:        "/counties",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostCountiesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostCountiesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postCounties: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
