// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package place

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetPlaceObservableParams creates a new GetPlaceObservableParams object
// with the default values initialized.
func NewGetPlaceObservableParams() *GetPlaceObservableParams {
	var ()
	return &GetPlaceObservableParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetPlaceObservableParamsWithTimeout creates a new GetPlaceObservableParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetPlaceObservableParamsWithTimeout(timeout time.Duration) *GetPlaceObservableParams {
	var ()
	return &GetPlaceObservableParams{

		timeout: timeout,
	}
}

// NewGetPlaceObservableParamsWithContext creates a new GetPlaceObservableParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetPlaceObservableParamsWithContext(ctx context.Context) *GetPlaceObservableParams {
	var ()
	return &GetPlaceObservableParams{

		Context: ctx,
	}
}

// NewGetPlaceObservableParamsWithHTTPClient creates a new GetPlaceObservableParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetPlaceObservableParamsWithHTTPClient(client *http.Client) *GetPlaceObservableParams {
	var ()
	return &GetPlaceObservableParams{
		HTTPClient: client,
	}
}

/*GetPlaceObservableParams contains all the parameters to send to the API endpoint
for the get place observable operation typically these are written to a http.Request
*/
type GetPlaceObservableParams struct {

	/*Geocode
	  The Geocode of this Place record

	*/
	Geocode *string
	/*PlaceID
	  The ID of a Place record

	*/
	PlaceID *string
	/*State
	  The State or Province abbreviation (2 char)

	*/
	State *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get place observable params
func (o *GetPlaceObservableParams) WithTimeout(timeout time.Duration) *GetPlaceObservableParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get place observable params
func (o *GetPlaceObservableParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get place observable params
func (o *GetPlaceObservableParams) WithContext(ctx context.Context) *GetPlaceObservableParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get place observable params
func (o *GetPlaceObservableParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get place observable params
func (o *GetPlaceObservableParams) WithHTTPClient(client *http.Client) *GetPlaceObservableParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get place observable params
func (o *GetPlaceObservableParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithGeocode adds the geocode to the get place observable params
func (o *GetPlaceObservableParams) WithGeocode(geocode *string) *GetPlaceObservableParams {
	o.SetGeocode(geocode)
	return o
}

// SetGeocode adds the geocode to the get place observable params
func (o *GetPlaceObservableParams) SetGeocode(geocode *string) {
	o.Geocode = geocode
}

// WithPlaceID adds the placeID to the get place observable params
func (o *GetPlaceObservableParams) WithPlaceID(placeID *string) *GetPlaceObservableParams {
	o.SetPlaceID(placeID)
	return o
}

// SetPlaceID adds the placeId to the get place observable params
func (o *GetPlaceObservableParams) SetPlaceID(placeID *string) {
	o.PlaceID = placeID
}

// WithState adds the state to the get place observable params
func (o *GetPlaceObservableParams) WithState(state *string) *GetPlaceObservableParams {
	o.SetState(state)
	return o
}

// SetState adds the state to the get place observable params
func (o *GetPlaceObservableParams) SetState(state *string) {
	o.State = state
}

// WriteToRequest writes these params to a swagger request
func (o *GetPlaceObservableParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Geocode != nil {

		// query param geocode
		var qrGeocode string
		if o.Geocode != nil {
			qrGeocode = *o.Geocode
		}
		qGeocode := qrGeocode
		if qGeocode != "" {
			if err := r.SetQueryParam("geocode", qGeocode); err != nil {
				return err
			}
		}

	}

	if o.PlaceID != nil {

		// query param placeId
		var qrPlaceID string
		if o.PlaceID != nil {
			qrPlaceID = *o.PlaceID
		}
		qPlaceID := qrPlaceID
		if qPlaceID != "" {
			if err := r.SetQueryParam("placeId", qPlaceID); err != nil {
				return err
			}
		}

	}

	if o.State != nil {

		// query param state
		var qrState string
		if o.State != nil {
			qrState = *o.State
		}
		qState := qrState
		if qState != "" {
			if err := r.SetQueryParam("state", qState); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
