// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package state

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetStateObservableParams creates a new GetStateObservableParams object
// with the default values initialized.
func NewGetStateObservableParams() *GetStateObservableParams {
	var ()
	return &GetStateObservableParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetStateObservableParamsWithTimeout creates a new GetStateObservableParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetStateObservableParamsWithTimeout(timeout time.Duration) *GetStateObservableParams {
	var ()
	return &GetStateObservableParams{

		timeout: timeout,
	}
}

// NewGetStateObservableParamsWithContext creates a new GetStateObservableParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetStateObservableParamsWithContext(ctx context.Context) *GetStateObservableParams {
	var ()
	return &GetStateObservableParams{

		Context: ctx,
	}
}

// NewGetStateObservableParamsWithHTTPClient creates a new GetStateObservableParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetStateObservableParamsWithHTTPClient(client *http.Client) *GetStateObservableParams {
	var ()
	return &GetStateObservableParams{
		HTTPClient: client,
	}
}

/*GetStateObservableParams contains all the parameters to send to the API endpoint
for the get state observable operation typically these are written to a http.Request
*/
type GetStateObservableParams struct {

	/*StateID
	  The ID of this Object

	*/
	StateID *string
	/*CountryCode
	  The Country abbreviation (2 char)

	*/
	CountryCode *string
	/*Geocode
	  The Geocode of this Place record

	*/
	Geocode *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get state observable params
func (o *GetStateObservableParams) WithTimeout(timeout time.Duration) *GetStateObservableParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get state observable params
func (o *GetStateObservableParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get state observable params
func (o *GetStateObservableParams) WithContext(ctx context.Context) *GetStateObservableParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get state observable params
func (o *GetStateObservableParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get state observable params
func (o *GetStateObservableParams) WithHTTPClient(client *http.Client) *GetStateObservableParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get state observable params
func (o *GetStateObservableParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithStateID adds the stateID to the get state observable params
func (o *GetStateObservableParams) WithStateID(stateID *string) *GetStateObservableParams {
	o.SetStateID(stateID)
	return o
}

// SetStateID adds the stateId to the get state observable params
func (o *GetStateObservableParams) SetStateID(stateID *string) {
	o.StateID = stateID
}

// WithCountryCode adds the countryCode to the get state observable params
func (o *GetStateObservableParams) WithCountryCode(countryCode *string) *GetStateObservableParams {
	o.SetCountryCode(countryCode)
	return o
}

// SetCountryCode adds the countryCode to the get state observable params
func (o *GetStateObservableParams) SetCountryCode(countryCode *string) {
	o.CountryCode = countryCode
}

// WithGeocode adds the geocode to the get state observable params
func (o *GetStateObservableParams) WithGeocode(geocode *string) *GetStateObservableParams {
	o.SetGeocode(geocode)
	return o
}

// SetGeocode adds the geocode to the get state observable params
func (o *GetStateObservableParams) SetGeocode(geocode *string) {
	o.Geocode = geocode
}

// WriteToRequest writes these params to a swagger request
func (o *GetStateObservableParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.StateID != nil {

		// query param StateID
		var qrStateID string
		if o.StateID != nil {
			qrStateID = *o.StateID
		}
		qStateID := qrStateID
		if qStateID != "" {
			if err := r.SetQueryParam("StateID", qStateID); err != nil {
				return err
			}
		}

	}

	if o.CountryCode != nil {

		// query param countryCode
		var qrCountryCode string
		if o.CountryCode != nil {
			qrCountryCode = *o.CountryCode
		}
		qCountryCode := qrCountryCode
		if qCountryCode != "" {
			if err := r.SetQueryParam("countryCode", qCountryCode); err != nil {
				return err
			}
		}

	}

	if o.Geocode != nil {

		// query param geocode
		var qrGeocode string
		if o.Geocode != nil {
			qrGeocode = *o.Geocode
		}
		qGeocode := qrGeocode
		if qGeocode != "" {
			if err := r.SetQueryParam("geocode", qGeocode); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
