// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package state

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new state API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for state API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	GetStateObservable(params *GetStateObservableParams, authInfo runtime.ClientAuthInfoWriter) (*GetStateObservableOK, error)

	GetStates(params *GetStatesParams, authInfo runtime.ClientAuthInfoWriter) (*GetStatesOK, error)

	PostStates(params *PostStatesParams, authInfo runtime.ClientAuthInfoWriter) (*PostStatesOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetStateObservable gets states in an observable array

  Returns a state retrieval in a observable array
*/
func (a *Client) GetStateObservable(params *GetStateObservableParams, authInfo runtime.ClientAuthInfoWriter) (*GetStateObservableOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetStateObservableParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getStateObservable",
		Method:             "GET",
		PathPattern:        "/states/observable",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetStateObservableReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetStateObservableOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getStateObservable: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetStates retrieves states

  Retrieve States, filter with parameters
*/
func (a *Client) GetStates(params *GetStatesParams, authInfo runtime.ClientAuthInfoWriter) (*GetStatesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetStatesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getStates",
		Method:             "GET",
		PathPattern:        "/states",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetStatesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetStatesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getStates: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostStates stores new state records

  Store a batch of new State records
*/
func (a *Client) PostStates(params *PostStatesParams, authInfo runtime.ClientAuthInfoWriter) (*PostStatesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostStatesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postStates",
		Method:             "POST",
		PathPattern:        "/states",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostStatesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostStatesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postStates: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
