// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tax_type

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new tax type API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for tax type API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	GetTaxTypes(params *GetTaxTypesParams, authInfo runtime.ClientAuthInfoWriter) (*GetTaxTypesOK, error)

	GetTaxTypesObservable(params *GetTaxTypesObservableParams, authInfo runtime.ClientAuthInfoWriter) (*GetTaxTypesObservableOK, error)

	PostTaxTypes(params *PostTaxTypesParams, authInfo runtime.ClientAuthInfoWriter) (*PostTaxTypesOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetTaxTypes gets a list of tax types

  Return a list of tax types
*/
func (a *Client) GetTaxTypes(params *GetTaxTypesParams, authInfo runtime.ClientAuthInfoWriter) (*GetTaxTypesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetTaxTypesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getTaxTypes",
		Method:             "GET",
		PathPattern:        "/taxtypes",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetTaxTypesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetTaxTypesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getTaxTypes: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetTaxTypesObservable gets taxtypes in an observable array

  Returns a taxtype retrieval in a observable array
*/
func (a *Client) GetTaxTypesObservable(params *GetTaxTypesObservableParams, authInfo runtime.ClientAuthInfoWriter) (*GetTaxTypesObservableOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetTaxTypesObservableParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getTaxTypesObservable",
		Method:             "GET",
		PathPattern:        "/taxtypes/observable",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetTaxTypesObservableReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetTaxTypesObservableOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getTaxTypesObservable: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostTaxTypes stores new tax type records

  Store a batch of new TaxType records
*/
func (a *Client) PostTaxTypes(params *PostTaxTypesParams, authInfo runtime.ClientAuthInfoWriter) (*PostTaxTypesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostTaxTypesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postTaxTypes",
		Method:             "POST",
		PathPattern:        "/taxtypes",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostTaxTypesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostTaxTypesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postTaxTypes: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
