// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package coa

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/ledger/ledger_models"
)

// PostCoasReader is a Reader for the PostCoas structure.
type PostCoasReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostCoasReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostCoasOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostCoasUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostCoasForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostCoasNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostCoasUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostCoasInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostCoasOK creates a PostCoasOK with default headers values
func NewPostCoasOK() *PostCoasOK {
	return &PostCoasOK{}
}

/*PostCoasOK handles this case with default header values.

Taxnexus Response with Chart of Accounts objects
*/
type PostCoasOK struct {
	Payload *ledger_models.CoaResponse
}

func (o *PostCoasOK) Error() string {
	return fmt.Sprintf("[POST /coas][%d] postCoasOK  %+v", 200, o.Payload)
}

func (o *PostCoasOK) GetPayload() *ledger_models.CoaResponse {
	return o.Payload
}

func (o *PostCoasOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(ledger_models.CoaResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostCoasUnauthorized creates a PostCoasUnauthorized with default headers values
func NewPostCoasUnauthorized() *PostCoasUnauthorized {
	return &PostCoasUnauthorized{}
}

/*PostCoasUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostCoasUnauthorized struct {
	Payload *ledger_models.Error
}

func (o *PostCoasUnauthorized) Error() string {
	return fmt.Sprintf("[POST /coas][%d] postCoasUnauthorized  %+v", 401, o.Payload)
}

func (o *PostCoasUnauthorized) GetPayload() *ledger_models.Error {
	return o.Payload
}

func (o *PostCoasUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(ledger_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostCoasForbidden creates a PostCoasForbidden with default headers values
func NewPostCoasForbidden() *PostCoasForbidden {
	return &PostCoasForbidden{}
}

/*PostCoasForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostCoasForbidden struct {
	Payload *ledger_models.Error
}

func (o *PostCoasForbidden) Error() string {
	return fmt.Sprintf("[POST /coas][%d] postCoasForbidden  %+v", 403, o.Payload)
}

func (o *PostCoasForbidden) GetPayload() *ledger_models.Error {
	return o.Payload
}

func (o *PostCoasForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(ledger_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostCoasNotFound creates a PostCoasNotFound with default headers values
func NewPostCoasNotFound() *PostCoasNotFound {
	return &PostCoasNotFound{}
}

/*PostCoasNotFound handles this case with default header values.

Resource was not found
*/
type PostCoasNotFound struct {
	Payload *ledger_models.Error
}

func (o *PostCoasNotFound) Error() string {
	return fmt.Sprintf("[POST /coas][%d] postCoasNotFound  %+v", 404, o.Payload)
}

func (o *PostCoasNotFound) GetPayload() *ledger_models.Error {
	return o.Payload
}

func (o *PostCoasNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(ledger_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostCoasUnprocessableEntity creates a PostCoasUnprocessableEntity with default headers values
func NewPostCoasUnprocessableEntity() *PostCoasUnprocessableEntity {
	return &PostCoasUnprocessableEntity{}
}

/*PostCoasUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostCoasUnprocessableEntity struct {
	Payload *ledger_models.Error
}

func (o *PostCoasUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /coas][%d] postCoasUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostCoasUnprocessableEntity) GetPayload() *ledger_models.Error {
	return o.Payload
}

func (o *PostCoasUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(ledger_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostCoasInternalServerError creates a PostCoasInternalServerError with default headers values
func NewPostCoasInternalServerError() *PostCoasInternalServerError {
	return &PostCoasInternalServerError{}
}

/*PostCoasInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostCoasInternalServerError struct {
	Payload *ledger_models.Error
}

func (o *PostCoasInternalServerError) Error() string {
	return fmt.Sprintf("[POST /coas][%d] postCoasInternalServerError  %+v", 500, o.Payload)
}

func (o *PostCoasInternalServerError) GetPayload() *ledger_models.Error {
	return o.Payload
}

func (o *PostCoasInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(ledger_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
