// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package gl_balance

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetGlBalancesParams creates a new GetGlBalancesParams object
// with the default values initialized.
func NewGetGlBalancesParams() *GetGlBalancesParams {
	var ()
	return &GetGlBalancesParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetGlBalancesParamsWithTimeout creates a new GetGlBalancesParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetGlBalancesParamsWithTimeout(timeout time.Duration) *GetGlBalancesParams {
	var ()
	return &GetGlBalancesParams{

		timeout: timeout,
	}
}

// NewGetGlBalancesParamsWithContext creates a new GetGlBalancesParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetGlBalancesParamsWithContext(ctx context.Context) *GetGlBalancesParams {
	var ()
	return &GetGlBalancesParams{

		Context: ctx,
	}
}

// NewGetGlBalancesParamsWithHTTPClient creates a new GetGlBalancesParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetGlBalancesParamsWithHTTPClient(client *http.Client) *GetGlBalancesParams {
	var ()
	return &GetGlBalancesParams{
		HTTPClient: client,
	}
}

/*GetGlBalancesParams contains all the parameters to send to the API endpoint
for the get gl balances operation typically these are written to a http.Request
*/
type GetGlBalancesParams struct {

	/*AccountID
	  Taxnexus Record Id of an Account

	*/
	AccountID *string
	/*GlAccountID
	  Taxnexus Record Id of Gl Account Record

	*/
	GlAccountID *string
	/*ID
	  Taxnexus Record Id

	*/
	ID *string
	/*PeriodID
	  Taxnexus Record Id of a Period

	*/
	PeriodID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get gl balances params
func (o *GetGlBalancesParams) WithTimeout(timeout time.Duration) *GetGlBalancesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get gl balances params
func (o *GetGlBalancesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get gl balances params
func (o *GetGlBalancesParams) WithContext(ctx context.Context) *GetGlBalancesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get gl balances params
func (o *GetGlBalancesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get gl balances params
func (o *GetGlBalancesParams) WithHTTPClient(client *http.Client) *GetGlBalancesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get gl balances params
func (o *GetGlBalancesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the get gl balances params
func (o *GetGlBalancesParams) WithAccountID(accountID *string) *GetGlBalancesParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the get gl balances params
func (o *GetGlBalancesParams) SetAccountID(accountID *string) {
	o.AccountID = accountID
}

// WithGlAccountID adds the glAccountID to the get gl balances params
func (o *GetGlBalancesParams) WithGlAccountID(glAccountID *string) *GetGlBalancesParams {
	o.SetGlAccountID(glAccountID)
	return o
}

// SetGlAccountID adds the glAccountId to the get gl balances params
func (o *GetGlBalancesParams) SetGlAccountID(glAccountID *string) {
	o.GlAccountID = glAccountID
}

// WithID adds the id to the get gl balances params
func (o *GetGlBalancesParams) WithID(id *string) *GetGlBalancesParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the get gl balances params
func (o *GetGlBalancesParams) SetID(id *string) {
	o.ID = id
}

// WithPeriodID adds the periodID to the get gl balances params
func (o *GetGlBalancesParams) WithPeriodID(periodID *string) *GetGlBalancesParams {
	o.SetPeriodID(periodID)
	return o
}

// SetPeriodID adds the periodId to the get gl balances params
func (o *GetGlBalancesParams) SetPeriodID(periodID *string) {
	o.PeriodID = periodID
}

// WriteToRequest writes these params to a swagger request
func (o *GetGlBalancesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccountID != nil {

		// query param accountId
		var qrAccountID string
		if o.AccountID != nil {
			qrAccountID = *o.AccountID
		}
		qAccountID := qrAccountID
		if qAccountID != "" {
			if err := r.SetQueryParam("accountId", qAccountID); err != nil {
				return err
			}
		}

	}

	if o.GlAccountID != nil {

		// query param glAccountId
		var qrGlAccountID string
		if o.GlAccountID != nil {
			qrGlAccountID = *o.GlAccountID
		}
		qGlAccountID := qrGlAccountID
		if qGlAccountID != "" {
			if err := r.SetQueryParam("glAccountId", qGlAccountID); err != nil {
				return err
			}
		}

	}

	if o.ID != nil {

		// query param id
		var qrID string
		if o.ID != nil {
			qrID = *o.ID
		}
		qID := qrID
		if qID != "" {
			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}

	}

	if o.PeriodID != nil {

		// query param periodId
		var qrPeriodID string
		if o.PeriodID != nil {
			qrPeriodID = *o.PeriodID
		}
		qPeriodID := qrPeriodID
		if qPeriodID != "" {
			if err := r.SetQueryParam("periodId", qPeriodID); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
