// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package gl_balance

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new gl balance API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for gl balance API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	GetGlBalances(params *GetGlBalancesParams, authInfo runtime.ClientAuthInfoWriter) (*GetGlBalancesOK, error)

	PostGlBalances(params *PostGlBalancesParams, authInfo runtime.ClientAuthInfoWriter) (*PostGlBalancesOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetGlBalances gets one or more general account balance records

  Return a list of General  Account Balances for a Taxnexus Account
*/
func (a *Client) GetGlBalances(params *GetGlBalancesParams, authInfo runtime.ClientAuthInfoWriter) (*GetGlBalancesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetGlBalancesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getGlBalances",
		Method:             "GET",
		PathPattern:        "/glbalances",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetGlBalancesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetGlBalancesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getGlBalances: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostGlBalances inserts a g l balance

  Insert new GL Balance records
*/
func (a *Client) PostGlBalances(params *PostGlBalancesParams, authInfo runtime.ClientAuthInfoWriter) (*PostGlBalancesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostGlBalancesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postGlBalances",
		Method:             "POST",
		PathPattern:        "/glbalances",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostGlBalancesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostGlBalancesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postGlBalances: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
