// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package ledger_client

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"
	httptransport "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/ledger/ledger_client/accounting_rule"
	"code.tnxs.net/taxnexus/lib/api/ledger/ledger_client/accounting_ruleset"
	"code.tnxs.net/taxnexus/lib/api/ledger/ledger_client/coa"
	"code.tnxs.net/taxnexus/lib/api/ledger/ledger_client/gl_account"
	"code.tnxs.net/taxnexus/lib/api/ledger/ledger_client/gl_balance"
	"code.tnxs.net/taxnexus/lib/api/ledger/ledger_client/journal_entry"
	"code.tnxs.net/taxnexus/lib/api/ledger/ledger_client/journal_item"
	"code.tnxs.net/taxnexus/lib/api/ledger/ledger_client/period"
)

// Default ledger HTTP client.
var Default = NewHTTPClient(nil)

const (
	// DefaultHost is the default Host
	// found in Meta (info) section of spec file
	DefaultHost string = "ledger.fabric.tnxs.net:8080"
	// DefaultBasePath is the default BasePath
	// found in Meta (info) section of spec file
	DefaultBasePath string = "/v1"
)

// DefaultSchemes are the default schemes found in Meta (info) section of spec file
var DefaultSchemes = []string{"http"}

// NewHTTPClient creates a new ledger HTTP client.
func NewHTTPClient(formats strfmt.Registry) *Ledger {
	return NewHTTPClientWithConfig(formats, nil)
}

// NewHTTPClientWithConfig creates a new ledger HTTP client,
// using a customizable transport config.
func NewHTTPClientWithConfig(formats strfmt.Registry, cfg *TransportConfig) *Ledger {
	// ensure nullable parameters have default
	if cfg == nil {
		cfg = DefaultTransportConfig()
	}

	// create transport and client
	transport := httptransport.New(cfg.Host, cfg.BasePath, cfg.Schemes)
	return New(transport, formats)
}

// New creates a new ledger client
func New(transport runtime.ClientTransport, formats strfmt.Registry) *Ledger {
	// ensure nullable parameters have default
	if formats == nil {
		formats = strfmt.Default
	}

	cli := new(Ledger)
	cli.Transport = transport
	cli.AccountingRule = accounting_rule.New(transport, formats)
	cli.AccountingRuleset = accounting_ruleset.New(transport, formats)
	cli.Coa = coa.New(transport, formats)
	cli.GlAccount = gl_account.New(transport, formats)
	cli.GlBalance = gl_balance.New(transport, formats)
	cli.JournalEntry = journal_entry.New(transport, formats)
	cli.JournalItem = journal_item.New(transport, formats)
	cli.Period = period.New(transport, formats)
	return cli
}

// DefaultTransportConfig creates a TransportConfig with the
// default settings taken from the meta section of the spec file.
func DefaultTransportConfig() *TransportConfig {
	return &TransportConfig{
		Host:     DefaultHost,
		BasePath: DefaultBasePath,
		Schemes:  DefaultSchemes,
	}
}

// TransportConfig contains the transport related info,
// found in the meta section of the spec file.
type TransportConfig struct {
	Host     string
	BasePath string
	Schemes  []string
}

// WithHost overrides the default host,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithHost(host string) *TransportConfig {
	cfg.Host = host
	return cfg
}

// WithBasePath overrides the default basePath,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithBasePath(basePath string) *TransportConfig {
	cfg.BasePath = basePath
	return cfg
}

// WithSchemes overrides the default schemes,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithSchemes(schemes []string) *TransportConfig {
	cfg.Schemes = schemes
	return cfg
}

// Ledger is a client for ledger
type Ledger struct {
	AccountingRule accounting_rule.ClientService

	AccountingRuleset accounting_ruleset.ClientService

	Coa coa.ClientService

	GlAccount gl_account.ClientService

	GlBalance gl_balance.ClientService

	JournalEntry journal_entry.ClientService

	JournalItem journal_item.ClientService

	Period period.ClientService

	Transport runtime.ClientTransport
}

// SetTransport changes the transport on the client and all its subresources
func (c *Ledger) SetTransport(transport runtime.ClientTransport) {
	c.Transport = transport
	c.AccountingRule.SetTransport(transport)
	c.AccountingRuleset.SetTransport(transport)
	c.Coa.SetTransport(transport)
	c.GlAccount.SetTransport(transport)
	c.GlBalance.SetTransport(transport)
	c.JournalEntry.SetTransport(transport)
	c.JournalItem.SetTransport(transport)
	c.Period.SetTransport(transport)
}
