// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package ledger_models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// AccountingRule Rules used to assign transactions to the proper GL accounts
//
// swagger:model AccountingRule
type AccountingRule struct {

	// The Account ID for whom this Account Rule exists
	AcountID string `json:"AcountID,omitempty"`

	// The Taxnexus ID of the Cost of Goods Sold account to be used for this Accounting Rule
	COGSAccountID string `json:"COGSAccountID,omitempty"`

	// COGS Account Name
	COGSAccountName string `json:"COGSAccountName,omitempty"`

	// The Code used for Accounting Rule Lookups
	Code string `json:"Code,omitempty"`

	// Created By
	CreatedByID string `json:"CreatedByID,omitempty"`

	// Created Date
	CreatedDate string `json:"CreatedDate,omitempty"`

	// The Taxnexus ID of the GL Account that is the Credit Account to be used in this Accounting Rule
	CreditAccountID string `json:"CreditAccountID,omitempty"`

	// Credit Account Name
	CreditAccountName string `json:"CreditAccountName,omitempty"`

	// The GL Account that is the Debit Account to be used in this Accounting Rule
	DebitAccountID string `json:"DebitAccountID,omitempty"`

	// Debit Account Name
	DebitAccountName string `json:"DebitAccountName,omitempty"`

	// Description
	Description string `json:"Description,omitempty"`

	// Taxnexus Record Id
	ID string `json:"ID,omitempty"`

	// The Taxnexus ID of the GL Account that is the Inventory Account to be used in this Accounting Rule
	InventoryAccountID string `json:"InventoryAccountID,omitempty"`

	// Inventory Account Name
	InventoryAccountName string `json:"InventoryAccountName,omitempty"`

	// Is this a deferred tax, not to be charged on the invoice?
	IsDeferred bool `json:"IsDeferred,omitempty"`

	// Last Modified By
	LastModifiedByID string `json:"LastModifiedByID,omitempty"`

	// Last Modified Date
	LastModifiedDate string `json:"LastModifiedDate,omitempty"`

	// Parent Foreign Key
	ParentFK string `json:"ParentFK,omitempty"`

	// The Proportion of Revenue which is governed by this Accounting Rule; used for proportional taxing of products and services
	Proportion float64 `json:"Proportion,omitempty"`

	// Tenant that owns this object instance
	TenantID string `json:"TenantID,omitempty"`
}

// Validate validates this accounting rule
func (m *AccountingRule) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *AccountingRule) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *AccountingRule) UnmarshalBinary(b []byte) error {
	var res AccountingRule
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
