// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package harvests

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/metrc-gw/metrc_gw_models"
)

// GetHarvestsReader is a Reader for the GetHarvests structure.
type GetHarvestsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetHarvestsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetHarvestsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetHarvestsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetHarvestsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetHarvestsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetHarvestsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetHarvestsOK creates a GetHarvestsOK with default headers values
func NewGetHarvestsOK() *GetHarvestsOK {
	return &GetHarvestsOK{}
}

/*GetHarvestsOK handles this case with default header values.

A Harvest was successfully retrieved
*/
type GetHarvestsOK struct {
	Payload *metrc_gw_models.HarvestResponse
}

func (o *GetHarvestsOK) Error() string {
	return fmt.Sprintf("[GET /harvests][%d] getHarvestsOK  %+v", 200, o.Payload)
}

func (o *GetHarvestsOK) GetPayload() *metrc_gw_models.HarvestResponse {
	return o.Payload
}

func (o *GetHarvestsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.HarvestResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetHarvestsUnauthorized creates a GetHarvestsUnauthorized with default headers values
func NewGetHarvestsUnauthorized() *GetHarvestsUnauthorized {
	return &GetHarvestsUnauthorized{}
}

/*GetHarvestsUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetHarvestsUnauthorized struct {
	Payload *metrc_gw_models.Error
}

func (o *GetHarvestsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /harvests][%d] getHarvestsUnauthorized  %+v", 401, o.Payload)
}

func (o *GetHarvestsUnauthorized) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *GetHarvestsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetHarvestsForbidden creates a GetHarvestsForbidden with default headers values
func NewGetHarvestsForbidden() *GetHarvestsForbidden {
	return &GetHarvestsForbidden{}
}

/*GetHarvestsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetHarvestsForbidden struct {
	Payload *metrc_gw_models.Error
}

func (o *GetHarvestsForbidden) Error() string {
	return fmt.Sprintf("[GET /harvests][%d] getHarvestsForbidden  %+v", 403, o.Payload)
}

func (o *GetHarvestsForbidden) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *GetHarvestsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetHarvestsNotFound creates a GetHarvestsNotFound with default headers values
func NewGetHarvestsNotFound() *GetHarvestsNotFound {
	return &GetHarvestsNotFound{}
}

/*GetHarvestsNotFound handles this case with default header values.

Resource was not found
*/
type GetHarvestsNotFound struct {
	Payload *metrc_gw_models.Error
}

func (o *GetHarvestsNotFound) Error() string {
	return fmt.Sprintf("[GET /harvests][%d] getHarvestsNotFound  %+v", 404, o.Payload)
}

func (o *GetHarvestsNotFound) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *GetHarvestsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetHarvestsInternalServerError creates a GetHarvestsInternalServerError with default headers values
func NewGetHarvestsInternalServerError() *GetHarvestsInternalServerError {
	return &GetHarvestsInternalServerError{}
}

/*GetHarvestsInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetHarvestsInternalServerError struct {
	Payload *metrc_gw_models.Error
}

func (o *GetHarvestsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /harvests][%d] getHarvestsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetHarvestsInternalServerError) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *GetHarvestsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
