// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package harvests

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new harvests API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for harvests API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	GetHarvestWasteTypes(params *GetHarvestWasteTypesParams, authInfo runtime.ClientAuthInfoWriter) (*GetHarvestWasteTypesOK, error)

	GetHarvests(params *GetHarvestsParams, authInfo runtime.ClientAuthInfoWriter) (*GetHarvestsOK, error)

	PostHarvestPackages(params *PostHarvestPackagesParams, authInfo runtime.ClientAuthInfoWriter) (*PostHarvestPackagesOK, error)

	PutHarvests(params *PutHarvestsParams, authInfo runtime.ClientAuthInfoWriter) (*PutHarvestsOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetHarvestWasteTypes harvests waste types for user

  Harvest Waste Types for this User

*/
func (a *Client) GetHarvestWasteTypes(params *GetHarvestWasteTypesParams, authInfo runtime.ClientAuthInfoWriter) (*GetHarvestWasteTypesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetHarvestWasteTypesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getHarvestWasteTypes",
		Method:             "GET",
		PathPattern:        "/harvests/wastetypes",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetHarvestWasteTypesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetHarvestWasteTypesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getHarvestWasteTypes: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetHarvests harvests for this user license

  Get a Harvest for this User-License

*/
func (a *Client) GetHarvests(params *GetHarvestsParams, authInfo runtime.ClientAuthInfoWriter) (*GetHarvestsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetHarvestsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getHarvests",
		Method:             "GET",
		PathPattern:        "/harvests",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetHarvestsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetHarvestsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getHarvests: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostHarvestPackages creates new harvest packages

  Create new Plants
*/
func (a *Client) PostHarvestPackages(params *PostHarvestPackagesParams, authInfo runtime.ClientAuthInfoWriter) (*PostHarvestPackagesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostHarvestPackagesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postHarvestPackages",
		Method:             "POST",
		PathPattern:        "/harvestpackages",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostHarvestPackagesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostHarvestPackagesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postHarvestPackages: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PutHarvests Update Harvest Records
*/
func (a *Client) PutHarvests(params *PutHarvestsParams, authInfo runtime.ClientAuthInfoWriter) (*PutHarvestsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutHarvestsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "putHarvests",
		Method:             "PUT",
		PathPattern:        "/harvests",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutHarvestsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutHarvestsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putHarvests: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
