// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package items

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/metrc-gw/metrc_gw_models"
)

// DeleteItemReader is a Reader for the DeleteItem structure.
type DeleteItemReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteItemReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteItemOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewDeleteItemUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewDeleteItemForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewDeleteItemNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewDeleteItemInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewDeleteItemOK creates a DeleteItemOK with default headers values
func NewDeleteItemOK() *DeleteItemOK {
	return &DeleteItemOK{}
}

/*DeleteItemOK handles this case with default header values.

Item were successfully Deleted
*/
type DeleteItemOK struct {
	Payload *metrc_gw_models.ItemResponse
}

func (o *DeleteItemOK) Error() string {
	return fmt.Sprintf("[DELETE /items][%d] deleteItemOK  %+v", 200, o.Payload)
}

func (o *DeleteItemOK) GetPayload() *metrc_gw_models.ItemResponse {
	return o.Payload
}

func (o *DeleteItemOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.ItemResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteItemUnauthorized creates a DeleteItemUnauthorized with default headers values
func NewDeleteItemUnauthorized() *DeleteItemUnauthorized {
	return &DeleteItemUnauthorized{}
}

/*DeleteItemUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type DeleteItemUnauthorized struct {
	Payload *metrc_gw_models.Error
}

func (o *DeleteItemUnauthorized) Error() string {
	return fmt.Sprintf("[DELETE /items][%d] deleteItemUnauthorized  %+v", 401, o.Payload)
}

func (o *DeleteItemUnauthorized) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *DeleteItemUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteItemForbidden creates a DeleteItemForbidden with default headers values
func NewDeleteItemForbidden() *DeleteItemForbidden {
	return &DeleteItemForbidden{}
}

/*DeleteItemForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type DeleteItemForbidden struct {
	Payload *metrc_gw_models.Error
}

func (o *DeleteItemForbidden) Error() string {
	return fmt.Sprintf("[DELETE /items][%d] deleteItemForbidden  %+v", 403, o.Payload)
}

func (o *DeleteItemForbidden) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *DeleteItemForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteItemNotFound creates a DeleteItemNotFound with default headers values
func NewDeleteItemNotFound() *DeleteItemNotFound {
	return &DeleteItemNotFound{}
}

/*DeleteItemNotFound handles this case with default header values.

Resource was not found
*/
type DeleteItemNotFound struct {
	Payload *metrc_gw_models.Error
}

func (o *DeleteItemNotFound) Error() string {
	return fmt.Sprintf("[DELETE /items][%d] deleteItemNotFound  %+v", 404, o.Payload)
}

func (o *DeleteItemNotFound) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *DeleteItemNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteItemInternalServerError creates a DeleteItemInternalServerError with default headers values
func NewDeleteItemInternalServerError() *DeleteItemInternalServerError {
	return &DeleteItemInternalServerError{}
}

/*DeleteItemInternalServerError handles this case with default header values.

Server Internal Error
*/
type DeleteItemInternalServerError struct {
	Payload *metrc_gw_models.Error
}

func (o *DeleteItemInternalServerError) Error() string {
	return fmt.Sprintf("[DELETE /items][%d] deleteItemInternalServerError  %+v", 500, o.Payload)
}

func (o *DeleteItemInternalServerError) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *DeleteItemInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
