// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package items

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/metrc-gw/metrc_gw_models"
)

// PutItemsReader is a Reader for the PutItems structure.
type PutItemsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutItemsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutItemsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutItemsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutItemsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutItemsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutItemsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPutItemsOK creates a PutItemsOK with default headers values
func NewPutItemsOK() *PutItemsOK {
	return &PutItemsOK{}
}

/*PutItemsOK handles this case with default header values.

An array of Items records
*/
type PutItemsOK struct {
	Payload *metrc_gw_models.ItemResponse
}

func (o *PutItemsOK) Error() string {
	return fmt.Sprintf("[PUT /items][%d] putItemsOK  %+v", 200, o.Payload)
}

func (o *PutItemsOK) GetPayload() *metrc_gw_models.ItemResponse {
	return o.Payload
}

func (o *PutItemsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.ItemResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutItemsUnauthorized creates a PutItemsUnauthorized with default headers values
func NewPutItemsUnauthorized() *PutItemsUnauthorized {
	return &PutItemsUnauthorized{}
}

/*PutItemsUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PutItemsUnauthorized struct {
	Payload *metrc_gw_models.Error
}

func (o *PutItemsUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /items][%d] putItemsUnauthorized  %+v", 401, o.Payload)
}

func (o *PutItemsUnauthorized) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PutItemsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutItemsForbidden creates a PutItemsForbidden with default headers values
func NewPutItemsForbidden() *PutItemsForbidden {
	return &PutItemsForbidden{}
}

/*PutItemsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PutItemsForbidden struct {
	Payload *metrc_gw_models.Error
}

func (o *PutItemsForbidden) Error() string {
	return fmt.Sprintf("[PUT /items][%d] putItemsForbidden  %+v", 403, o.Payload)
}

func (o *PutItemsForbidden) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PutItemsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutItemsNotFound creates a PutItemsNotFound with default headers values
func NewPutItemsNotFound() *PutItemsNotFound {
	return &PutItemsNotFound{}
}

/*PutItemsNotFound handles this case with default header values.

Resource was not found
*/
type PutItemsNotFound struct {
	Payload *metrc_gw_models.Error
}

func (o *PutItemsNotFound) Error() string {
	return fmt.Sprintf("[PUT /items][%d] putItemsNotFound  %+v", 404, o.Payload)
}

func (o *PutItemsNotFound) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PutItemsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutItemsInternalServerError creates a PutItemsInternalServerError with default headers values
func NewPutItemsInternalServerError() *PutItemsInternalServerError {
	return &PutItemsInternalServerError{}
}

/*PutItemsInternalServerError handles this case with default header values.

Server Internal Error
*/
type PutItemsInternalServerError struct {
	Payload *metrc_gw_models.Error
}

func (o *PutItemsInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /items][%d] putItemsInternalServerError  %+v", 500, o.Payload)
}

func (o *PutItemsInternalServerError) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PutItemsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
