// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package packages

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/metrc-gw/metrc_gw_models"
)

// PutPackagesReader is a Reader for the PutPackages structure.
type PutPackagesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutPackagesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutPackagesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutPackagesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutPackagesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutPackagesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutPackagesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPutPackagesOK creates a PutPackagesOK with default headers values
func NewPutPackagesOK() *PutPackagesOK {
	return &PutPackagesOK{}
}

/*PutPackagesOK handles this case with default header values.

An array of Package records
*/
type PutPackagesOK struct {
	Payload *metrc_gw_models.PackageResponse
}

func (o *PutPackagesOK) Error() string {
	return fmt.Sprintf("[PUT /packages][%d] putPackagesOK  %+v", 200, o.Payload)
}

func (o *PutPackagesOK) GetPayload() *metrc_gw_models.PackageResponse {
	return o.Payload
}

func (o *PutPackagesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.PackageResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutPackagesUnauthorized creates a PutPackagesUnauthorized with default headers values
func NewPutPackagesUnauthorized() *PutPackagesUnauthorized {
	return &PutPackagesUnauthorized{}
}

/*PutPackagesUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PutPackagesUnauthorized struct {
	Payload *metrc_gw_models.Error
}

func (o *PutPackagesUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /packages][%d] putPackagesUnauthorized  %+v", 401, o.Payload)
}

func (o *PutPackagesUnauthorized) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PutPackagesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutPackagesForbidden creates a PutPackagesForbidden with default headers values
func NewPutPackagesForbidden() *PutPackagesForbidden {
	return &PutPackagesForbidden{}
}

/*PutPackagesForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PutPackagesForbidden struct {
	Payload *metrc_gw_models.Error
}

func (o *PutPackagesForbidden) Error() string {
	return fmt.Sprintf("[PUT /packages][%d] putPackagesForbidden  %+v", 403, o.Payload)
}

func (o *PutPackagesForbidden) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PutPackagesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutPackagesNotFound creates a PutPackagesNotFound with default headers values
func NewPutPackagesNotFound() *PutPackagesNotFound {
	return &PutPackagesNotFound{}
}

/*PutPackagesNotFound handles this case with default header values.

Resource was not found
*/
type PutPackagesNotFound struct {
	Payload *metrc_gw_models.Error
}

func (o *PutPackagesNotFound) Error() string {
	return fmt.Sprintf("[PUT /packages][%d] putPackagesNotFound  %+v", 404, o.Payload)
}

func (o *PutPackagesNotFound) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PutPackagesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutPackagesInternalServerError creates a PutPackagesInternalServerError with default headers values
func NewPutPackagesInternalServerError() *PutPackagesInternalServerError {
	return &PutPackagesInternalServerError{}
}

/*PutPackagesInternalServerError handles this case with default header values.

Server Internal Error
*/
type PutPackagesInternalServerError struct {
	Payload *metrc_gw_models.Error
}

func (o *PutPackagesInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /packages][%d] putPackagesInternalServerError  %+v", 500, o.Payload)
}

func (o *PutPackagesInternalServerError) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PutPackagesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
