// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package rooms

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/metrc-gw/metrc_gw_models"
)

// PutRoomsReader is a Reader for the PutRooms structure.
type PutRoomsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutRoomsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutRoomsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutRoomsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutRoomsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutRoomsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutRoomsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPutRoomsOK creates a PutRoomsOK with default headers values
func NewPutRoomsOK() *PutRoomsOK {
	return &PutRoomsOK{}
}

/*PutRoomsOK handles this case with default header values.

An array of Room records
*/
type PutRoomsOK struct {
	Payload *metrc_gw_models.RoomResponse
}

func (o *PutRoomsOK) Error() string {
	return fmt.Sprintf("[PUT /rooms][%d] putRoomsOK  %+v", 200, o.Payload)
}

func (o *PutRoomsOK) GetPayload() *metrc_gw_models.RoomResponse {
	return o.Payload
}

func (o *PutRoomsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.RoomResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutRoomsUnauthorized creates a PutRoomsUnauthorized with default headers values
func NewPutRoomsUnauthorized() *PutRoomsUnauthorized {
	return &PutRoomsUnauthorized{}
}

/*PutRoomsUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PutRoomsUnauthorized struct {
	Payload *metrc_gw_models.Error
}

func (o *PutRoomsUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /rooms][%d] putRoomsUnauthorized  %+v", 401, o.Payload)
}

func (o *PutRoomsUnauthorized) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PutRoomsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutRoomsForbidden creates a PutRoomsForbidden with default headers values
func NewPutRoomsForbidden() *PutRoomsForbidden {
	return &PutRoomsForbidden{}
}

/*PutRoomsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PutRoomsForbidden struct {
	Payload *metrc_gw_models.Error
}

func (o *PutRoomsForbidden) Error() string {
	return fmt.Sprintf("[PUT /rooms][%d] putRoomsForbidden  %+v", 403, o.Payload)
}

func (o *PutRoomsForbidden) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PutRoomsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutRoomsNotFound creates a PutRoomsNotFound with default headers values
func NewPutRoomsNotFound() *PutRoomsNotFound {
	return &PutRoomsNotFound{}
}

/*PutRoomsNotFound handles this case with default header values.

Resource was not found
*/
type PutRoomsNotFound struct {
	Payload *metrc_gw_models.Error
}

func (o *PutRoomsNotFound) Error() string {
	return fmt.Sprintf("[PUT /rooms][%d] putRoomsNotFound  %+v", 404, o.Payload)
}

func (o *PutRoomsNotFound) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PutRoomsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutRoomsInternalServerError creates a PutRoomsInternalServerError with default headers values
func NewPutRoomsInternalServerError() *PutRoomsInternalServerError {
	return &PutRoomsInternalServerError{}
}

/*PutRoomsInternalServerError handles this case with default header values.

Server Internal Error
*/
type PutRoomsInternalServerError struct {
	Payload *metrc_gw_models.Error
}

func (o *PutRoomsInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /rooms][%d] putRoomsInternalServerError  %+v", 500, o.Payload)
}

func (o *PutRoomsInternalServerError) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PutRoomsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
