// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package rooms

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new rooms API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for rooms API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	DeleteRoom(params *DeleteRoomParams, authInfo runtime.ClientAuthInfoWriter) (*DeleteRoomOK, error)

	GetRooms(params *GetRoomsParams, authInfo runtime.ClientAuthInfoWriter) (*GetRoomsOK, error)

	PostRooms(params *PostRoomsParams, authInfo runtime.ClientAuthInfoWriter) (*PostRoomsOK, error)

	PutRooms(params *PutRoomsParams, authInfo runtime.ClientAuthInfoWriter) (*PutRoomsOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  DeleteRoom rooms for this user license

  Delete a Room for this User-License

*/
func (a *Client) DeleteRoom(params *DeleteRoomParams, authInfo runtime.ClientAuthInfoWriter) (*DeleteRoomOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewDeleteRoomParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "deleteRoom",
		Method:             "DELETE",
		PathPattern:        "/rooms",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &DeleteRoomReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*DeleteRoomOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for deleteRoom: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetRooms rooms for this user license

  Get Rooms for this User-License

*/
func (a *Client) GetRooms(params *GetRoomsParams, authInfo runtime.ClientAuthInfoWriter) (*GetRoomsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetRoomsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getRooms",
		Method:             "GET",
		PathPattern:        "/rooms",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetRoomsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetRoomsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getRooms: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostRooms creates new rooms

  Create new Rooms
*/
func (a *Client) PostRooms(params *PostRoomsParams, authInfo runtime.ClientAuthInfoWriter) (*PostRoomsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostRoomsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postRooms",
		Method:             "POST",
		PathPattern:        "/rooms",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostRoomsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostRoomsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postRooms: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PutRooms updates existing rooms

  Update existing Rooms
*/
func (a *Client) PutRooms(params *PutRoomsParams, authInfo runtime.ClientAuthInfoWriter) (*PutRoomsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutRoomsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "putRooms",
		Method:             "PUT",
		PathPattern:        "/rooms",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutRoomsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutRoomsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putRooms: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
