// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package strains

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/metrc-gw/metrc_gw_models"
)

// GetStrainsReader is a Reader for the GetStrains structure.
type GetStrainsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetStrainsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetStrainsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetStrainsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetStrainsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetStrainsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetStrainsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetStrainsOK creates a GetStrainsOK with default headers values
func NewGetStrainsOK() *GetStrainsOK {
	return &GetStrainsOK{}
}

/*GetStrainsOK handles this case with default header values.

Strains were successfully retrieved
*/
type GetStrainsOK struct {
	Payload *metrc_gw_models.StrainResponse
}

func (o *GetStrainsOK) Error() string {
	return fmt.Sprintf("[GET /strains][%d] getStrainsOK  %+v", 200, o.Payload)
}

func (o *GetStrainsOK) GetPayload() *metrc_gw_models.StrainResponse {
	return o.Payload
}

func (o *GetStrainsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.StrainResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetStrainsUnauthorized creates a GetStrainsUnauthorized with default headers values
func NewGetStrainsUnauthorized() *GetStrainsUnauthorized {
	return &GetStrainsUnauthorized{}
}

/*GetStrainsUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetStrainsUnauthorized struct {
	Payload *metrc_gw_models.Error
}

func (o *GetStrainsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /strains][%d] getStrainsUnauthorized  %+v", 401, o.Payload)
}

func (o *GetStrainsUnauthorized) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *GetStrainsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetStrainsForbidden creates a GetStrainsForbidden with default headers values
func NewGetStrainsForbidden() *GetStrainsForbidden {
	return &GetStrainsForbidden{}
}

/*GetStrainsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetStrainsForbidden struct {
	Payload *metrc_gw_models.Error
}

func (o *GetStrainsForbidden) Error() string {
	return fmt.Sprintf("[GET /strains][%d] getStrainsForbidden  %+v", 403, o.Payload)
}

func (o *GetStrainsForbidden) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *GetStrainsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetStrainsNotFound creates a GetStrainsNotFound with default headers values
func NewGetStrainsNotFound() *GetStrainsNotFound {
	return &GetStrainsNotFound{}
}

/*GetStrainsNotFound handles this case with default header values.

Resource was not found
*/
type GetStrainsNotFound struct {
	Payload *metrc_gw_models.Error
}

func (o *GetStrainsNotFound) Error() string {
	return fmt.Sprintf("[GET /strains][%d] getStrainsNotFound  %+v", 404, o.Payload)
}

func (o *GetStrainsNotFound) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *GetStrainsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetStrainsInternalServerError creates a GetStrainsInternalServerError with default headers values
func NewGetStrainsInternalServerError() *GetStrainsInternalServerError {
	return &GetStrainsInternalServerError{}
}

/*GetStrainsInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetStrainsInternalServerError struct {
	Payload *metrc_gw_models.Error
}

func (o *GetStrainsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /strains][%d] getStrainsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetStrainsInternalServerError) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *GetStrainsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
