// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package strains

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/metrc-gw/metrc_gw_models"
)

// PutStrainsReader is a Reader for the PutStrains structure.
type PutStrainsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutStrainsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutStrainsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutStrainsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutStrainsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutStrainsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutStrainsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPutStrainsOK creates a PutStrainsOK with default headers values
func NewPutStrainsOK() *PutStrainsOK {
	return &PutStrainsOK{}
}

/*PutStrainsOK handles this case with default header values.

An array of Strain records
*/
type PutStrainsOK struct {
	Payload *metrc_gw_models.StrainResponse
}

func (o *PutStrainsOK) Error() string {
	return fmt.Sprintf("[PUT /strains][%d] putStrainsOK  %+v", 200, o.Payload)
}

func (o *PutStrainsOK) GetPayload() *metrc_gw_models.StrainResponse {
	return o.Payload
}

func (o *PutStrainsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.StrainResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutStrainsUnauthorized creates a PutStrainsUnauthorized with default headers values
func NewPutStrainsUnauthorized() *PutStrainsUnauthorized {
	return &PutStrainsUnauthorized{}
}

/*PutStrainsUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PutStrainsUnauthorized struct {
	Payload *metrc_gw_models.Error
}

func (o *PutStrainsUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /strains][%d] putStrainsUnauthorized  %+v", 401, o.Payload)
}

func (o *PutStrainsUnauthorized) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PutStrainsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutStrainsForbidden creates a PutStrainsForbidden with default headers values
func NewPutStrainsForbidden() *PutStrainsForbidden {
	return &PutStrainsForbidden{}
}

/*PutStrainsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PutStrainsForbidden struct {
	Payload *metrc_gw_models.Error
}

func (o *PutStrainsForbidden) Error() string {
	return fmt.Sprintf("[PUT /strains][%d] putStrainsForbidden  %+v", 403, o.Payload)
}

func (o *PutStrainsForbidden) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PutStrainsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutStrainsNotFound creates a PutStrainsNotFound with default headers values
func NewPutStrainsNotFound() *PutStrainsNotFound {
	return &PutStrainsNotFound{}
}

/*PutStrainsNotFound handles this case with default header values.

Resource was not found
*/
type PutStrainsNotFound struct {
	Payload *metrc_gw_models.Error
}

func (o *PutStrainsNotFound) Error() string {
	return fmt.Sprintf("[PUT /strains][%d] putStrainsNotFound  %+v", 404, o.Payload)
}

func (o *PutStrainsNotFound) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PutStrainsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutStrainsInternalServerError creates a PutStrainsInternalServerError with default headers values
func NewPutStrainsInternalServerError() *PutStrainsInternalServerError {
	return &PutStrainsInternalServerError{}
}

/*PutStrainsInternalServerError handles this case with default header values.

Server Internal Error
*/
type PutStrainsInternalServerError struct {
	Payload *metrc_gw_models.Error
}

func (o *PutStrainsInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /strains][%d] putStrainsInternalServerError  %+v", 500, o.Payload)
}

func (o *PutStrainsInternalServerError) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PutStrainsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
