// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package strains

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new strains API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for strains API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	DeleteStrain(params *DeleteStrainParams, authInfo runtime.ClientAuthInfoWriter) (*DeleteStrainOK, error)

	GetStrains(params *GetStrainsParams, authInfo runtime.ClientAuthInfoWriter) (*GetStrainsOK, error)

	PostStrains(params *PostStrainsParams, authInfo runtime.ClientAuthInfoWriter) (*PostStrainsOK, error)

	PutStrains(params *PutStrainsParams, authInfo runtime.ClientAuthInfoWriter) (*PutStrainsOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  DeleteStrain strains for this user license

  Delete a Strain for this User-License

*/
func (a *Client) DeleteStrain(params *DeleteStrainParams, authInfo runtime.ClientAuthInfoWriter) (*DeleteStrainOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewDeleteStrainParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "deleteStrain",
		Method:             "DELETE",
		PathPattern:        "/strains",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &DeleteStrainReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*DeleteStrainOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for deleteStrain: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetStrains strains for this user license

  Get Strains for this User-License

*/
func (a *Client) GetStrains(params *GetStrainsParams, authInfo runtime.ClientAuthInfoWriter) (*GetStrainsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetStrainsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getStrains",
		Method:             "GET",
		PathPattern:        "/strains",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetStrainsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetStrainsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getStrains: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostStrains creates new strains

  Create new Strains
*/
func (a *Client) PostStrains(params *PostStrainsParams, authInfo runtime.ClientAuthInfoWriter) (*PostStrainsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostStrainsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postStrains",
		Method:             "POST",
		PathPattern:        "/strains",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostStrainsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostStrainsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postStrains: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PutStrains updates existing strains

  Update existing Strains
*/
func (a *Client) PutStrains(params *PutStrainsParams, authInfo runtime.ClientAuthInfoWriter) (*PutStrainsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutStrainsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "putStrains",
		Method:             "PUT",
		PathPattern:        "/strains",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutStrainsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutStrainsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putStrains: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
