// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package charge

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/ops/ops_models"
)

// DeleteChargeReader is a Reader for the DeleteCharge structure.
type DeleteChargeReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteChargeReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteChargeOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewDeleteChargeUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewDeleteChargeForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewDeleteChargeNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewDeleteChargeUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewDeleteChargeInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewDeleteChargeOK creates a DeleteChargeOK with default headers values
func NewDeleteChargeOK() *DeleteChargeOK {
	return &DeleteChargeOK{}
}

/*DeleteChargeOK handles this case with default header values.

Taxnexus Response with Message Objects with Delete Status
*/
type DeleteChargeOK struct {
	AccessControlAllowOrigin string

	Payload *ops_models.DeleteResponse
}

func (o *DeleteChargeOK) Error() string {
	return fmt.Sprintf("[DELETE /charges][%d] deleteChargeOK  %+v", 200, o.Payload)
}

func (o *DeleteChargeOK) GetPayload() *ops_models.DeleteResponse {
	return o.Payload
}

func (o *DeleteChargeOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.DeleteResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteChargeUnauthorized creates a DeleteChargeUnauthorized with default headers values
func NewDeleteChargeUnauthorized() *DeleteChargeUnauthorized {
	return &DeleteChargeUnauthorized{}
}

/*DeleteChargeUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type DeleteChargeUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *DeleteChargeUnauthorized) Error() string {
	return fmt.Sprintf("[DELETE /charges][%d] deleteChargeUnauthorized  %+v", 401, o.Payload)
}

func (o *DeleteChargeUnauthorized) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *DeleteChargeUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteChargeForbidden creates a DeleteChargeForbidden with default headers values
func NewDeleteChargeForbidden() *DeleteChargeForbidden {
	return &DeleteChargeForbidden{}
}

/*DeleteChargeForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type DeleteChargeForbidden struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *DeleteChargeForbidden) Error() string {
	return fmt.Sprintf("[DELETE /charges][%d] deleteChargeForbidden  %+v", 403, o.Payload)
}

func (o *DeleteChargeForbidden) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *DeleteChargeForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteChargeNotFound creates a DeleteChargeNotFound with default headers values
func NewDeleteChargeNotFound() *DeleteChargeNotFound {
	return &DeleteChargeNotFound{}
}

/*DeleteChargeNotFound handles this case with default header values.

Resource was not found
*/
type DeleteChargeNotFound struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *DeleteChargeNotFound) Error() string {
	return fmt.Sprintf("[DELETE /charges][%d] deleteChargeNotFound  %+v", 404, o.Payload)
}

func (o *DeleteChargeNotFound) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *DeleteChargeNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteChargeUnprocessableEntity creates a DeleteChargeUnprocessableEntity with default headers values
func NewDeleteChargeUnprocessableEntity() *DeleteChargeUnprocessableEntity {
	return &DeleteChargeUnprocessableEntity{}
}

/*DeleteChargeUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type DeleteChargeUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *DeleteChargeUnprocessableEntity) Error() string {
	return fmt.Sprintf("[DELETE /charges][%d] deleteChargeUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *DeleteChargeUnprocessableEntity) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *DeleteChargeUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteChargeInternalServerError creates a DeleteChargeInternalServerError with default headers values
func NewDeleteChargeInternalServerError() *DeleteChargeInternalServerError {
	return &DeleteChargeInternalServerError{}
}

/*DeleteChargeInternalServerError handles this case with default header values.

Server Internal Error
*/
type DeleteChargeInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *DeleteChargeInternalServerError) Error() string {
	return fmt.Sprintf("[DELETE /charges][%d] deleteChargeInternalServerError  %+v", 500, o.Payload)
}

func (o *DeleteChargeInternalServerError) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *DeleteChargeInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
