// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package charge

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/ops/ops_models"
)

// PutChargesReader is a Reader for the PutCharges structure.
type PutChargesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutChargesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutChargesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutChargesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutChargesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutChargesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutChargesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutChargesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPutChargesOK creates a PutChargesOK with default headers values
func NewPutChargesOK() *PutChargesOK {
	return &PutChargesOK{}
}

/*PutChargesOK handles this case with default header values.

Taxnexus Response with an array of Message objects in response to a PUT
*/
type PutChargesOK struct {
	AccessControlAllowOrigin string

	Payload *ops_models.PutResponse
}

func (o *PutChargesOK) Error() string {
	return fmt.Sprintf("[PUT /charges][%d] putChargesOK  %+v", 200, o.Payload)
}

func (o *PutChargesOK) GetPayload() *ops_models.PutResponse {
	return o.Payload
}

func (o *PutChargesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.PutResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutChargesUnauthorized creates a PutChargesUnauthorized with default headers values
func NewPutChargesUnauthorized() *PutChargesUnauthorized {
	return &PutChargesUnauthorized{}
}

/*PutChargesUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PutChargesUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PutChargesUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /charges][%d] putChargesUnauthorized  %+v", 401, o.Payload)
}

func (o *PutChargesUnauthorized) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PutChargesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutChargesForbidden creates a PutChargesForbidden with default headers values
func NewPutChargesForbidden() *PutChargesForbidden {
	return &PutChargesForbidden{}
}

/*PutChargesForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PutChargesForbidden struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PutChargesForbidden) Error() string {
	return fmt.Sprintf("[PUT /charges][%d] putChargesForbidden  %+v", 403, o.Payload)
}

func (o *PutChargesForbidden) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PutChargesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutChargesNotFound creates a PutChargesNotFound with default headers values
func NewPutChargesNotFound() *PutChargesNotFound {
	return &PutChargesNotFound{}
}

/*PutChargesNotFound handles this case with default header values.

Resource was not found
*/
type PutChargesNotFound struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PutChargesNotFound) Error() string {
	return fmt.Sprintf("[PUT /charges][%d] putChargesNotFound  %+v", 404, o.Payload)
}

func (o *PutChargesNotFound) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PutChargesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutChargesUnprocessableEntity creates a PutChargesUnprocessableEntity with default headers values
func NewPutChargesUnprocessableEntity() *PutChargesUnprocessableEntity {
	return &PutChargesUnprocessableEntity{}
}

/*PutChargesUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutChargesUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PutChargesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /charges][%d] putChargesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutChargesUnprocessableEntity) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PutChargesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutChargesInternalServerError creates a PutChargesInternalServerError with default headers values
func NewPutChargesInternalServerError() *PutChargesInternalServerError {
	return &PutChargesInternalServerError{}
}

/*PutChargesInternalServerError handles this case with default header values.

Server Internal Error
*/
type PutChargesInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PutChargesInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /charges][%d] putChargesInternalServerError  %+v", 500, o.Payload)
}

func (o *PutChargesInternalServerError) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PutChargesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
