// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package eft

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new eft API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for eft API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	GetEfts(params *GetEftsParams, authInfo runtime.ClientAuthInfoWriter) (*GetEftsOK, error)

	PostEfts(params *PostEftsParams, authInfo runtime.ClientAuthInfoWriter) (*PostEftsOK, error)

	PutEfts(params *PutEftsParams, authInfo runtime.ClientAuthInfoWriter) (*PutEftsOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetEfts gets a list of efts

  Return a list of available Taxnexus Efts
*/
func (a *Client) GetEfts(params *GetEftsParams, authInfo runtime.ClientAuthInfoWriter) (*GetEftsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetEftsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getEfts",
		Method:             "GET",
		PathPattern:        "/efts",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetEftsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetEftsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getEfts: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostEfts creates new efts

  Create New Efts
*/
func (a *Client) PostEfts(params *PostEftsParams, authInfo runtime.ClientAuthInfoWriter) (*PostEftsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostEftsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postEfts",
		Method:             "POST",
		PathPattern:        "/efts",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostEftsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostEftsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postEfts: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PutEfts puts a list of efts

  Put a list of Efts
*/
func (a *Client) PutEfts(params *PutEftsParams, authInfo runtime.ClientAuthInfoWriter) (*PutEftsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutEftsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "putEfts",
		Method:             "PUT",
		PathPattern:        "/efts",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutEftsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutEftsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putEfts: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
