// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package eft

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetEftsParams creates a new GetEftsParams object
// with the default values initialized.
func NewGetEftsParams() *GetEftsParams {
	var ()
	return &GetEftsParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetEftsParamsWithTimeout creates a new GetEftsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetEftsParamsWithTimeout(timeout time.Duration) *GetEftsParams {
	var ()
	return &GetEftsParams{

		timeout: timeout,
	}
}

// NewGetEftsParamsWithContext creates a new GetEftsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetEftsParamsWithContext(ctx context.Context) *GetEftsParams {
	var ()
	return &GetEftsParams{

		Context: ctx,
	}
}

// NewGetEftsParamsWithHTTPClient creates a new GetEftsParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetEftsParamsWithHTTPClient(client *http.Client) *GetEftsParams {
	var ()
	return &GetEftsParams{
		HTTPClient: client,
	}
}

/*GetEftsParams contains all the parameters to send to the API endpoint
for the get efts operation typically these are written to a http.Request
*/
type GetEftsParams struct {

	/*EftID
	  Taxnexus Record Id of a EFT

	*/
	EftID *string
	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get efts params
func (o *GetEftsParams) WithTimeout(timeout time.Duration) *GetEftsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get efts params
func (o *GetEftsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get efts params
func (o *GetEftsParams) WithContext(ctx context.Context) *GetEftsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get efts params
func (o *GetEftsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get efts params
func (o *GetEftsParams) WithHTTPClient(client *http.Client) *GetEftsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get efts params
func (o *GetEftsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithEftID adds the eftID to the get efts params
func (o *GetEftsParams) WithEftID(eftID *string) *GetEftsParams {
	o.SetEftID(eftID)
	return o
}

// SetEftID adds the eftId to the get efts params
func (o *GetEftsParams) SetEftID(eftID *string) {
	o.EftID = eftID
}

// WithLimit adds the limit to the get efts params
func (o *GetEftsParams) WithLimit(limit *int64) *GetEftsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get efts params
func (o *GetEftsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get efts params
func (o *GetEftsParams) WithOffset(offset *int64) *GetEftsParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get efts params
func (o *GetEftsParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetEftsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.EftID != nil {

		// query param eftId
		var qrEftID string
		if o.EftID != nil {
			qrEftID = *o.EftID
		}
		qEftID := qrEftID
		if qEftID != "" {
			if err := r.SetQueryParam("eftId", qEftID); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
