// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package invoice

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/ops/ops_models"
)

// PostInvoicesReader is a Reader for the PostInvoices structure.
type PostInvoicesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostInvoicesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostInvoicesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostInvoicesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostInvoicesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostInvoicesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostInvoicesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostInvoicesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostInvoicesOK creates a PostInvoicesOK with default headers values
func NewPostInvoicesOK() *PostInvoicesOK {
	return &PostInvoicesOK{}
}

/*PostInvoicesOK handles this case with default header values.

Taxnexus Response with an array of Invoice (full) objects
*/
type PostInvoicesOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *ops_models.InvoiceResponse
}

func (o *PostInvoicesOK) Error() string {
	return fmt.Sprintf("[POST /invoices][%d] postInvoicesOK  %+v", 200, o.Payload)
}

func (o *PostInvoicesOK) GetPayload() *ops_models.InvoiceResponse {
	return o.Payload
}

func (o *PostInvoicesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(ops_models.InvoiceResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostInvoicesUnauthorized creates a PostInvoicesUnauthorized with default headers values
func NewPostInvoicesUnauthorized() *PostInvoicesUnauthorized {
	return &PostInvoicesUnauthorized{}
}

/*PostInvoicesUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PostInvoicesUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostInvoicesUnauthorized) Error() string {
	return fmt.Sprintf("[POST /invoices][%d] postInvoicesUnauthorized  %+v", 401, o.Payload)
}

func (o *PostInvoicesUnauthorized) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostInvoicesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostInvoicesForbidden creates a PostInvoicesForbidden with default headers values
func NewPostInvoicesForbidden() *PostInvoicesForbidden {
	return &PostInvoicesForbidden{}
}

/*PostInvoicesForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostInvoicesForbidden struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostInvoicesForbidden) Error() string {
	return fmt.Sprintf("[POST /invoices][%d] postInvoicesForbidden  %+v", 403, o.Payload)
}

func (o *PostInvoicesForbidden) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostInvoicesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostInvoicesNotFound creates a PostInvoicesNotFound with default headers values
func NewPostInvoicesNotFound() *PostInvoicesNotFound {
	return &PostInvoicesNotFound{}
}

/*PostInvoicesNotFound handles this case with default header values.

Resource was not found
*/
type PostInvoicesNotFound struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostInvoicesNotFound) Error() string {
	return fmt.Sprintf("[POST /invoices][%d] postInvoicesNotFound  %+v", 404, o.Payload)
}

func (o *PostInvoicesNotFound) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostInvoicesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostInvoicesUnprocessableEntity creates a PostInvoicesUnprocessableEntity with default headers values
func NewPostInvoicesUnprocessableEntity() *PostInvoicesUnprocessableEntity {
	return &PostInvoicesUnprocessableEntity{}
}

/*PostInvoicesUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostInvoicesUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostInvoicesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /invoices][%d] postInvoicesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostInvoicesUnprocessableEntity) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostInvoicesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostInvoicesInternalServerError creates a PostInvoicesInternalServerError with default headers values
func NewPostInvoicesInternalServerError() *PostInvoicesInternalServerError {
	return &PostInvoicesInternalServerError{}
}

/*PostInvoicesInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostInvoicesInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostInvoicesInternalServerError) Error() string {
	return fmt.Sprintf("[POST /invoices][%d] postInvoicesInternalServerError  %+v", 500, o.Payload)
}

func (o *PostInvoicesInternalServerError) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostInvoicesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
