// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package invoice

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/ops/ops_models"
)

// PutInvoicesReader is a Reader for the PutInvoices structure.
type PutInvoicesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutInvoicesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutInvoicesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutInvoicesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutInvoicesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutInvoicesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutInvoicesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutInvoicesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPutInvoicesOK creates a PutInvoicesOK with default headers values
func NewPutInvoicesOK() *PutInvoicesOK {
	return &PutInvoicesOK{}
}

/*PutInvoicesOK handles this case with default header values.

Taxnexus Response with an array of Message objects in response to a PUT
*/
type PutInvoicesOK struct {
	AccessControlAllowOrigin string

	Payload *ops_models.PutResponse
}

func (o *PutInvoicesOK) Error() string {
	return fmt.Sprintf("[PUT /invoices][%d] putInvoicesOK  %+v", 200, o.Payload)
}

func (o *PutInvoicesOK) GetPayload() *ops_models.PutResponse {
	return o.Payload
}

func (o *PutInvoicesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.PutResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutInvoicesUnauthorized creates a PutInvoicesUnauthorized with default headers values
func NewPutInvoicesUnauthorized() *PutInvoicesUnauthorized {
	return &PutInvoicesUnauthorized{}
}

/*PutInvoicesUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PutInvoicesUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PutInvoicesUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /invoices][%d] putInvoicesUnauthorized  %+v", 401, o.Payload)
}

func (o *PutInvoicesUnauthorized) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PutInvoicesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutInvoicesForbidden creates a PutInvoicesForbidden with default headers values
func NewPutInvoicesForbidden() *PutInvoicesForbidden {
	return &PutInvoicesForbidden{}
}

/*PutInvoicesForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PutInvoicesForbidden struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PutInvoicesForbidden) Error() string {
	return fmt.Sprintf("[PUT /invoices][%d] putInvoicesForbidden  %+v", 403, o.Payload)
}

func (o *PutInvoicesForbidden) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PutInvoicesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutInvoicesNotFound creates a PutInvoicesNotFound with default headers values
func NewPutInvoicesNotFound() *PutInvoicesNotFound {
	return &PutInvoicesNotFound{}
}

/*PutInvoicesNotFound handles this case with default header values.

Resource was not found
*/
type PutInvoicesNotFound struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PutInvoicesNotFound) Error() string {
	return fmt.Sprintf("[PUT /invoices][%d] putInvoicesNotFound  %+v", 404, o.Payload)
}

func (o *PutInvoicesNotFound) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PutInvoicesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutInvoicesUnprocessableEntity creates a PutInvoicesUnprocessableEntity with default headers values
func NewPutInvoicesUnprocessableEntity() *PutInvoicesUnprocessableEntity {
	return &PutInvoicesUnprocessableEntity{}
}

/*PutInvoicesUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutInvoicesUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PutInvoicesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /invoices][%d] putInvoicesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutInvoicesUnprocessableEntity) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PutInvoicesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutInvoicesInternalServerError creates a PutInvoicesInternalServerError with default headers values
func NewPutInvoicesInternalServerError() *PutInvoicesInternalServerError {
	return &PutInvoicesInternalServerError{}
}

/*PutInvoicesInternalServerError handles this case with default header values.

Server Internal Error
*/
type PutInvoicesInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PutInvoicesInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /invoices][%d] putInvoicesInternalServerError  %+v", 500, o.Payload)
}

func (o *PutInvoicesInternalServerError) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PutInvoicesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
