// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package ops_client

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"
	httptransport "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/ops/ops_client/cash_receipt"
	"code.tnxs.net/taxnexus/lib/api/ops/ops_client/charge"
	"code.tnxs.net/taxnexus/lib/api/ops/ops_client/cors"
	"code.tnxs.net/taxnexus/lib/api/ops/ops_client/eft"
	"code.tnxs.net/taxnexus/lib/api/ops/ops_client/invoice"
	"code.tnxs.net/taxnexus/lib/api/ops/ops_client/order"
	"code.tnxs.net/taxnexus/lib/api/ops/ops_client/payment_method"
	"code.tnxs.net/taxnexus/lib/api/ops/ops_client/product"
	"code.tnxs.net/taxnexus/lib/api/ops/ops_client/purchase_order"
	"code.tnxs.net/taxnexus/lib/api/ops/ops_client/quote"
	"code.tnxs.net/taxnexus/lib/api/ops/ops_client/tax"
)

// Default ops HTTP client.
var Default = NewHTTPClient(nil)

const (
	// DefaultHost is the default Host
	// found in Meta (info) section of spec file
	DefaultHost string = "ops.fabric.tnxs.net:8080"
	// DefaultBasePath is the default BasePath
	// found in Meta (info) section of spec file
	DefaultBasePath string = "/v1"
)

// DefaultSchemes are the default schemes found in Meta (info) section of spec file
var DefaultSchemes = []string{"http"}

// NewHTTPClient creates a new ops HTTP client.
func NewHTTPClient(formats strfmt.Registry) *Ops {
	return NewHTTPClientWithConfig(formats, nil)
}

// NewHTTPClientWithConfig creates a new ops HTTP client,
// using a customizable transport config.
func NewHTTPClientWithConfig(formats strfmt.Registry, cfg *TransportConfig) *Ops {
	// ensure nullable parameters have default
	if cfg == nil {
		cfg = DefaultTransportConfig()
	}

	// create transport and client
	transport := httptransport.New(cfg.Host, cfg.BasePath, cfg.Schemes)
	return New(transport, formats)
}

// New creates a new ops client
func New(transport runtime.ClientTransport, formats strfmt.Registry) *Ops {
	// ensure nullable parameters have default
	if formats == nil {
		formats = strfmt.Default
	}

	cli := new(Ops)
	cli.Transport = transport
	cli.CashReceipt = cash_receipt.New(transport, formats)
	cli.Charge = charge.New(transport, formats)
	cli.Cors = cors.New(transport, formats)
	cli.Eft = eft.New(transport, formats)
	cli.Invoice = invoice.New(transport, formats)
	cli.Order = order.New(transport, formats)
	cli.PaymentMethod = payment_method.New(transport, formats)
	cli.Product = product.New(transport, formats)
	cli.PurchaseOrder = purchase_order.New(transport, formats)
	cli.Quote = quote.New(transport, formats)
	cli.Tax = tax.New(transport, formats)
	return cli
}

// DefaultTransportConfig creates a TransportConfig with the
// default settings taken from the meta section of the spec file.
func DefaultTransportConfig() *TransportConfig {
	return &TransportConfig{
		Host:     DefaultHost,
		BasePath: DefaultBasePath,
		Schemes:  DefaultSchemes,
	}
}

// TransportConfig contains the transport related info,
// found in the meta section of the spec file.
type TransportConfig struct {
	Host     string
	BasePath string
	Schemes  []string
}

// WithHost overrides the default host,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithHost(host string) *TransportConfig {
	cfg.Host = host
	return cfg
}

// WithBasePath overrides the default basePath,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithBasePath(basePath string) *TransportConfig {
	cfg.BasePath = basePath
	return cfg
}

// WithSchemes overrides the default schemes,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithSchemes(schemes []string) *TransportConfig {
	cfg.Schemes = schemes
	return cfg
}

// Ops is a client for ops
type Ops struct {
	CashReceipt cash_receipt.ClientService

	Charge charge.ClientService

	Cors cors.ClientService

	Eft eft.ClientService

	Invoice invoice.ClientService

	Order order.ClientService

	PaymentMethod payment_method.ClientService

	Product product.ClientService

	PurchaseOrder purchase_order.ClientService

	Quote quote.ClientService

	Tax tax.ClientService

	Transport runtime.ClientTransport
}

// SetTransport changes the transport on the client and all its subresources
func (c *Ops) SetTransport(transport runtime.ClientTransport) {
	c.Transport = transport
	c.CashReceipt.SetTransport(transport)
	c.Charge.SetTransport(transport)
	c.Cors.SetTransport(transport)
	c.Eft.SetTransport(transport)
	c.Invoice.SetTransport(transport)
	c.Order.SetTransport(transport)
	c.PaymentMethod.SetTransport(transport)
	c.Product.SetTransport(transport)
	c.PurchaseOrder.SetTransport(transport)
	c.Quote.SetTransport(transport)
	c.Tax.SetTransport(transport)
}
