// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package payment_method

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetPaymentMethodsParams creates a new GetPaymentMethodsParams object
// with the default values initialized.
func NewGetPaymentMethodsParams() *GetPaymentMethodsParams {
	var ()
	return &GetPaymentMethodsParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetPaymentMethodsParamsWithTimeout creates a new GetPaymentMethodsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetPaymentMethodsParamsWithTimeout(timeout time.Duration) *GetPaymentMethodsParams {
	var ()
	return &GetPaymentMethodsParams{

		timeout: timeout,
	}
}

// NewGetPaymentMethodsParamsWithContext creates a new GetPaymentMethodsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetPaymentMethodsParamsWithContext(ctx context.Context) *GetPaymentMethodsParams {
	var ()
	return &GetPaymentMethodsParams{

		Context: ctx,
	}
}

// NewGetPaymentMethodsParamsWithHTTPClient creates a new GetPaymentMethodsParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetPaymentMethodsParamsWithHTTPClient(client *http.Client) *GetPaymentMethodsParams {
	var ()
	return &GetPaymentMethodsParams{
		HTTPClient: client,
	}
}

/*GetPaymentMethodsParams contains all the parameters to send to the API endpoint
for the get payment methods operation typically these are written to a http.Request
*/
type GetPaymentMethodsParams struct {

	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64
	/*PaymentMethodID
	  Taxnexus Record Id of a PaymentMethod

	*/
	PaymentMethodID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get payment methods params
func (o *GetPaymentMethodsParams) WithTimeout(timeout time.Duration) *GetPaymentMethodsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get payment methods params
func (o *GetPaymentMethodsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get payment methods params
func (o *GetPaymentMethodsParams) WithContext(ctx context.Context) *GetPaymentMethodsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get payment methods params
func (o *GetPaymentMethodsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get payment methods params
func (o *GetPaymentMethodsParams) WithHTTPClient(client *http.Client) *GetPaymentMethodsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get payment methods params
func (o *GetPaymentMethodsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLimit adds the limit to the get payment methods params
func (o *GetPaymentMethodsParams) WithLimit(limit *int64) *GetPaymentMethodsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get payment methods params
func (o *GetPaymentMethodsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get payment methods params
func (o *GetPaymentMethodsParams) WithOffset(offset *int64) *GetPaymentMethodsParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get payment methods params
func (o *GetPaymentMethodsParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithPaymentMethodID adds the paymentMethodID to the get payment methods params
func (o *GetPaymentMethodsParams) WithPaymentMethodID(paymentMethodID *string) *GetPaymentMethodsParams {
	o.SetPaymentMethodID(paymentMethodID)
	return o
}

// SetPaymentMethodID adds the paymentMethodId to the get payment methods params
func (o *GetPaymentMethodsParams) SetPaymentMethodID(paymentMethodID *string) {
	o.PaymentMethodID = paymentMethodID
}

// WriteToRequest writes these params to a swagger request
func (o *GetPaymentMethodsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if o.PaymentMethodID != nil {

		// query param paymentMethodId
		var qrPaymentMethodID string
		if o.PaymentMethodID != nil {
			qrPaymentMethodID = *o.PaymentMethodID
		}
		qPaymentMethodID := qrPaymentMethodID
		if qPaymentMethodID != "" {
			if err := r.SetQueryParam("paymentMethodId", qPaymentMethodID); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
