// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package purchase_order

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new purchase order API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for purchase order API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	DeletePurchaseOrder(params *DeletePurchaseOrderParams, authInfo runtime.ClientAuthInfoWriter) (*DeletePurchaseOrderOK, error)

	GetPurchaseOrders(params *GetPurchaseOrdersParams, authInfo runtime.ClientAuthInfoWriter) (*GetPurchaseOrdersOK, error)

	PostPurchaseOrders(params *PostPurchaseOrdersParams, authInfo runtime.ClientAuthInfoWriter) (*PostPurchaseOrdersOK, error)

	PutPurchaseOrders(params *PutPurchaseOrdersParams, authInfo runtime.ClientAuthInfoWriter) (*PutPurchaseOrdersOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  DeletePurchaseOrder deletes a p o

  Delete a PO by ID
*/
func (a *Client) DeletePurchaseOrder(params *DeletePurchaseOrderParams, authInfo runtime.ClientAuthInfoWriter) (*DeletePurchaseOrderOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewDeletePurchaseOrderParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "deletePurchaseOrder",
		Method:             "DELETE",
		PathPattern:        "/pos",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &DeletePurchaseOrderReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*DeletePurchaseOrderOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for deletePurchaseOrder: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetPurchaseOrders gets a list of purchase orders

  Return a list of available Purchase Orders
*/
func (a *Client) GetPurchaseOrders(params *GetPurchaseOrdersParams, authInfo runtime.ClientAuthInfoWriter) (*GetPurchaseOrdersOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetPurchaseOrdersParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getPurchaseOrders",
		Method:             "GET",
		PathPattern:        "/pos",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetPurchaseOrdersReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetPurchaseOrdersOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getPurchaseOrders: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostPurchaseOrders creates a new purchase order

  Create New Purchase Order
*/
func (a *Client) PostPurchaseOrders(params *PostPurchaseOrdersParams, authInfo runtime.ClientAuthInfoWriter) (*PostPurchaseOrdersOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostPurchaseOrdersParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postPurchaseOrders",
		Method:             "POST",
		PathPattern:        "/pos",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostPurchaseOrdersReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostPurchaseOrdersOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postPurchaseOrders: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PutPurchaseOrders upserts a list of purchase order

  Upsert a list of Purchase Order
*/
func (a *Client) PutPurchaseOrders(params *PutPurchaseOrdersParams, authInfo runtime.ClientAuthInfoWriter) (*PutPurchaseOrdersOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutPurchaseOrdersParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "putPurchaseOrders",
		Method:             "PUT",
		PathPattern:        "/pos",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutPurchaseOrdersReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutPurchaseOrdersOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putPurchaseOrders: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
