// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package quote

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/ops/ops_models"
)

// DeleteQuoteReader is a Reader for the DeleteQuote structure.
type DeleteQuoteReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteQuoteReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteQuoteOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewDeleteQuoteUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewDeleteQuoteForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewDeleteQuoteNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewDeleteQuoteUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewDeleteQuoteInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewDeleteQuoteOK creates a DeleteQuoteOK with default headers values
func NewDeleteQuoteOK() *DeleteQuoteOK {
	return &DeleteQuoteOK{}
}

/*DeleteQuoteOK handles this case with default header values.

Taxnexus Response with Message Objects with Delete Status
*/
type DeleteQuoteOK struct {
	AccessControlAllowOrigin string

	Payload *ops_models.DeleteResponse
}

func (o *DeleteQuoteOK) Error() string {
	return fmt.Sprintf("[DELETE /quotes][%d] deleteQuoteOK  %+v", 200, o.Payload)
}

func (o *DeleteQuoteOK) GetPayload() *ops_models.DeleteResponse {
	return o.Payload
}

func (o *DeleteQuoteOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.DeleteResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteQuoteUnauthorized creates a DeleteQuoteUnauthorized with default headers values
func NewDeleteQuoteUnauthorized() *DeleteQuoteUnauthorized {
	return &DeleteQuoteUnauthorized{}
}

/*DeleteQuoteUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type DeleteQuoteUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *DeleteQuoteUnauthorized) Error() string {
	return fmt.Sprintf("[DELETE /quotes][%d] deleteQuoteUnauthorized  %+v", 401, o.Payload)
}

func (o *DeleteQuoteUnauthorized) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *DeleteQuoteUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteQuoteForbidden creates a DeleteQuoteForbidden with default headers values
func NewDeleteQuoteForbidden() *DeleteQuoteForbidden {
	return &DeleteQuoteForbidden{}
}

/*DeleteQuoteForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type DeleteQuoteForbidden struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *DeleteQuoteForbidden) Error() string {
	return fmt.Sprintf("[DELETE /quotes][%d] deleteQuoteForbidden  %+v", 403, o.Payload)
}

func (o *DeleteQuoteForbidden) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *DeleteQuoteForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteQuoteNotFound creates a DeleteQuoteNotFound with default headers values
func NewDeleteQuoteNotFound() *DeleteQuoteNotFound {
	return &DeleteQuoteNotFound{}
}

/*DeleteQuoteNotFound handles this case with default header values.

Resource was not found
*/
type DeleteQuoteNotFound struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *DeleteQuoteNotFound) Error() string {
	return fmt.Sprintf("[DELETE /quotes][%d] deleteQuoteNotFound  %+v", 404, o.Payload)
}

func (o *DeleteQuoteNotFound) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *DeleteQuoteNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteQuoteUnprocessableEntity creates a DeleteQuoteUnprocessableEntity with default headers values
func NewDeleteQuoteUnprocessableEntity() *DeleteQuoteUnprocessableEntity {
	return &DeleteQuoteUnprocessableEntity{}
}

/*DeleteQuoteUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type DeleteQuoteUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *DeleteQuoteUnprocessableEntity) Error() string {
	return fmt.Sprintf("[DELETE /quotes][%d] deleteQuoteUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *DeleteQuoteUnprocessableEntity) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *DeleteQuoteUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteQuoteInternalServerError creates a DeleteQuoteInternalServerError with default headers values
func NewDeleteQuoteInternalServerError() *DeleteQuoteInternalServerError {
	return &DeleteQuoteInternalServerError{}
}

/*DeleteQuoteInternalServerError handles this case with default header values.

Server Internal Error
*/
type DeleteQuoteInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *DeleteQuoteInternalServerError) Error() string {
	return fmt.Sprintf("[DELETE /quotes][%d] deleteQuoteInternalServerError  %+v", 500, o.Payload)
}

func (o *DeleteQuoteInternalServerError) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *DeleteQuoteInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
