// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package quote

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetQuotesParams creates a new GetQuotesParams object
// with the default values initialized.
func NewGetQuotesParams() *GetQuotesParams {
	var ()
	return &GetQuotesParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetQuotesParamsWithTimeout creates a new GetQuotesParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetQuotesParamsWithTimeout(timeout time.Duration) *GetQuotesParams {
	var ()
	return &GetQuotesParams{

		timeout: timeout,
	}
}

// NewGetQuotesParamsWithContext creates a new GetQuotesParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetQuotesParamsWithContext(ctx context.Context) *GetQuotesParams {
	var ()
	return &GetQuotesParams{

		Context: ctx,
	}
}

// NewGetQuotesParamsWithHTTPClient creates a new GetQuotesParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetQuotesParamsWithHTTPClient(client *http.Client) *GetQuotesParams {
	var ()
	return &GetQuotesParams{
		HTTPClient: client,
	}
}

/*GetQuotesParams contains all the parameters to send to the API endpoint
for the get quotes operation typically these are written to a http.Request
*/
type GetQuotesParams struct {

	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64
	/*QuoteID
	  Taxnexus Record Id of a Quote

	*/
	QuoteID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get quotes params
func (o *GetQuotesParams) WithTimeout(timeout time.Duration) *GetQuotesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get quotes params
func (o *GetQuotesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get quotes params
func (o *GetQuotesParams) WithContext(ctx context.Context) *GetQuotesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get quotes params
func (o *GetQuotesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get quotes params
func (o *GetQuotesParams) WithHTTPClient(client *http.Client) *GetQuotesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get quotes params
func (o *GetQuotesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLimit adds the limit to the get quotes params
func (o *GetQuotesParams) WithLimit(limit *int64) *GetQuotesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get quotes params
func (o *GetQuotesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get quotes params
func (o *GetQuotesParams) WithOffset(offset *int64) *GetQuotesParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get quotes params
func (o *GetQuotesParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithQuoteID adds the quoteID to the get quotes params
func (o *GetQuotesParams) WithQuoteID(quoteID *string) *GetQuotesParams {
	o.SetQuoteID(quoteID)
	return o
}

// SetQuoteID adds the quoteId to the get quotes params
func (o *GetQuotesParams) SetQuoteID(quoteID *string) {
	o.QuoteID = quoteID
}

// WriteToRequest writes these params to a swagger request
func (o *GetQuotesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if o.QuoteID != nil {

		// query param quoteId
		var qrQuoteID string
		if o.QuoteID != nil {
			qrQuoteID = *o.QuoteID
		}
		qQuoteID := qrQuoteID
		if qQuoteID != "" {
			if err := r.SetQueryParam("quoteId", qQuoteID); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
