// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tax

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/ops/ops_models"
)

// PostTaxesInvoicesReader is a Reader for the PostTaxesInvoices structure.
type PostTaxesInvoicesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostTaxesInvoicesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostTaxesInvoicesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostTaxesInvoicesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostTaxesInvoicesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostTaxesInvoicesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostTaxesInvoicesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostTaxesInvoicesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostTaxesInvoicesOK creates a PostTaxesInvoicesOK with default headers values
func NewPostTaxesInvoicesOK() *PostTaxesInvoicesOK {
	return &PostTaxesInvoicesOK{}
}

/*PostTaxesInvoicesOK handles this case with default header values.

Taxnexus Response with Tax Transaction Objects
*/
type PostTaxesInvoicesOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *ops_models.TaxTransactionResponse
}

func (o *PostTaxesInvoicesOK) Error() string {
	return fmt.Sprintf("[POST /taxes/invoices][%d] postTaxesInvoicesOK  %+v", 200, o.Payload)
}

func (o *PostTaxesInvoicesOK) GetPayload() *ops_models.TaxTransactionResponse {
	return o.Payload
}

func (o *PostTaxesInvoicesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(ops_models.TaxTransactionResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTaxesInvoicesUnauthorized creates a PostTaxesInvoicesUnauthorized with default headers values
func NewPostTaxesInvoicesUnauthorized() *PostTaxesInvoicesUnauthorized {
	return &PostTaxesInvoicesUnauthorized{}
}

/*PostTaxesInvoicesUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PostTaxesInvoicesUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostTaxesInvoicesUnauthorized) Error() string {
	return fmt.Sprintf("[POST /taxes/invoices][%d] postTaxesInvoicesUnauthorized  %+v", 401, o.Payload)
}

func (o *PostTaxesInvoicesUnauthorized) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostTaxesInvoicesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTaxesInvoicesForbidden creates a PostTaxesInvoicesForbidden with default headers values
func NewPostTaxesInvoicesForbidden() *PostTaxesInvoicesForbidden {
	return &PostTaxesInvoicesForbidden{}
}

/*PostTaxesInvoicesForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostTaxesInvoicesForbidden struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostTaxesInvoicesForbidden) Error() string {
	return fmt.Sprintf("[POST /taxes/invoices][%d] postTaxesInvoicesForbidden  %+v", 403, o.Payload)
}

func (o *PostTaxesInvoicesForbidden) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostTaxesInvoicesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTaxesInvoicesNotFound creates a PostTaxesInvoicesNotFound with default headers values
func NewPostTaxesInvoicesNotFound() *PostTaxesInvoicesNotFound {
	return &PostTaxesInvoicesNotFound{}
}

/*PostTaxesInvoicesNotFound handles this case with default header values.

Resource was not found
*/
type PostTaxesInvoicesNotFound struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostTaxesInvoicesNotFound) Error() string {
	return fmt.Sprintf("[POST /taxes/invoices][%d] postTaxesInvoicesNotFound  %+v", 404, o.Payload)
}

func (o *PostTaxesInvoicesNotFound) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostTaxesInvoicesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTaxesInvoicesUnprocessableEntity creates a PostTaxesInvoicesUnprocessableEntity with default headers values
func NewPostTaxesInvoicesUnprocessableEntity() *PostTaxesInvoicesUnprocessableEntity {
	return &PostTaxesInvoicesUnprocessableEntity{}
}

/*PostTaxesInvoicesUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostTaxesInvoicesUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostTaxesInvoicesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /taxes/invoices][%d] postTaxesInvoicesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostTaxesInvoicesUnprocessableEntity) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostTaxesInvoicesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTaxesInvoicesInternalServerError creates a PostTaxesInvoicesInternalServerError with default headers values
func NewPostTaxesInvoicesInternalServerError() *PostTaxesInvoicesInternalServerError {
	return &PostTaxesInvoicesInternalServerError{}
}

/*PostTaxesInvoicesInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostTaxesInvoicesInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostTaxesInvoicesInternalServerError) Error() string {
	return fmt.Sprintf("[POST /taxes/invoices][%d] postTaxesInvoicesInternalServerError  %+v", 500, o.Payload)
}

func (o *PostTaxesInvoicesInternalServerError) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostTaxesInvoicesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
