// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tax

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/ops/ops_models"
)

// PostTaxesPosReader is a Reader for the PostTaxesPos structure.
type PostTaxesPosReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostTaxesPosReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostTaxesPosOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostTaxesPosUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostTaxesPosForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostTaxesPosNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostTaxesPosUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostTaxesPosInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostTaxesPosOK creates a PostTaxesPosOK with default headers values
func NewPostTaxesPosOK() *PostTaxesPosOK {
	return &PostTaxesPosOK{}
}

/*PostTaxesPosOK handles this case with default header values.

Taxnexus Response with Tax Transaction Objects
*/
type PostTaxesPosOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *ops_models.TaxTransactionResponse
}

func (o *PostTaxesPosOK) Error() string {
	return fmt.Sprintf("[POST /taxes/pos][%d] postTaxesPosOK  %+v", 200, o.Payload)
}

func (o *PostTaxesPosOK) GetPayload() *ops_models.TaxTransactionResponse {
	return o.Payload
}

func (o *PostTaxesPosOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(ops_models.TaxTransactionResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTaxesPosUnauthorized creates a PostTaxesPosUnauthorized with default headers values
func NewPostTaxesPosUnauthorized() *PostTaxesPosUnauthorized {
	return &PostTaxesPosUnauthorized{}
}

/*PostTaxesPosUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PostTaxesPosUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostTaxesPosUnauthorized) Error() string {
	return fmt.Sprintf("[POST /taxes/pos][%d] postTaxesPosUnauthorized  %+v", 401, o.Payload)
}

func (o *PostTaxesPosUnauthorized) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostTaxesPosUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTaxesPosForbidden creates a PostTaxesPosForbidden with default headers values
func NewPostTaxesPosForbidden() *PostTaxesPosForbidden {
	return &PostTaxesPosForbidden{}
}

/*PostTaxesPosForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostTaxesPosForbidden struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostTaxesPosForbidden) Error() string {
	return fmt.Sprintf("[POST /taxes/pos][%d] postTaxesPosForbidden  %+v", 403, o.Payload)
}

func (o *PostTaxesPosForbidden) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostTaxesPosForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTaxesPosNotFound creates a PostTaxesPosNotFound with default headers values
func NewPostTaxesPosNotFound() *PostTaxesPosNotFound {
	return &PostTaxesPosNotFound{}
}

/*PostTaxesPosNotFound handles this case with default header values.

Resource was not found
*/
type PostTaxesPosNotFound struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostTaxesPosNotFound) Error() string {
	return fmt.Sprintf("[POST /taxes/pos][%d] postTaxesPosNotFound  %+v", 404, o.Payload)
}

func (o *PostTaxesPosNotFound) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostTaxesPosNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTaxesPosUnprocessableEntity creates a PostTaxesPosUnprocessableEntity with default headers values
func NewPostTaxesPosUnprocessableEntity() *PostTaxesPosUnprocessableEntity {
	return &PostTaxesPosUnprocessableEntity{}
}

/*PostTaxesPosUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostTaxesPosUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostTaxesPosUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /taxes/pos][%d] postTaxesPosUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostTaxesPosUnprocessableEntity) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostTaxesPosUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTaxesPosInternalServerError creates a PostTaxesPosInternalServerError with default headers values
func NewPostTaxesPosInternalServerError() *PostTaxesPosInternalServerError {
	return &PostTaxesPosInternalServerError{}
}

/*PostTaxesPosInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostTaxesPosInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostTaxesPosInternalServerError) Error() string {
	return fmt.Sprintf("[POST /taxes/pos][%d] postTaxesPosInternalServerError  %+v", 500, o.Payload)
}

func (o *PostTaxesPosInternalServerError) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostTaxesPosInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
