// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tax

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new tax API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for tax API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	PostTaxesInvoices(params *PostTaxesInvoicesParams, authInfo runtime.ClientAuthInfoWriter) (*PostTaxesInvoicesOK, error)

	PostTaxesOrders(params *PostTaxesOrdersParams, authInfo runtime.ClientAuthInfoWriter) (*PostTaxesOrdersOK, error)

	PostTaxesPos(params *PostTaxesPosParams, authInfo runtime.ClientAuthInfoWriter) (*PostTaxesPosOK, error)

	PostTaxesQuotes(params *PostTaxesQuotesParams, authInfo runtime.ClientAuthInfoWriter) (*PostTaxesQuotesOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  PostTaxesInvoices rates a list of invoices

  Rate a list of invoices
*/
func (a *Client) PostTaxesInvoices(params *PostTaxesInvoicesParams, authInfo runtime.ClientAuthInfoWriter) (*PostTaxesInvoicesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostTaxesInvoicesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postTaxesInvoices",
		Method:             "POST",
		PathPattern:        "/taxes/invoices",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostTaxesInvoicesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostTaxesInvoicesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postTaxesInvoices: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostTaxesOrders rates a list of orders

  Rate a list of invoices
*/
func (a *Client) PostTaxesOrders(params *PostTaxesOrdersParams, authInfo runtime.ClientAuthInfoWriter) (*PostTaxesOrdersOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostTaxesOrdersParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postTaxesOrders",
		Method:             "POST",
		PathPattern:        "/taxes/orders",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostTaxesOrdersReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostTaxesOrdersOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postTaxesOrders: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostTaxesPos rates a list of purchase orders

  Rate a list of purchase orders
*/
func (a *Client) PostTaxesPos(params *PostTaxesPosParams, authInfo runtime.ClientAuthInfoWriter) (*PostTaxesPosOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostTaxesPosParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postTaxesPos",
		Method:             "POST",
		PathPattern:        "/taxes/pos",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostTaxesPosReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostTaxesPosOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postTaxesPos: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostTaxesQuotes rates a list of quotes

  Rate a list of quotes
*/
func (a *Client) PostTaxesQuotes(params *PostTaxesQuotesParams, authInfo runtime.ClientAuthInfoWriter) (*PostTaxesQuotesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostTaxesQuotesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postTaxesQuotes",
		Method:             "POST",
		PathPattern:        "/taxes/quotes",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostTaxesQuotesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostTaxesQuotesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postTaxesQuotes: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
