// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package backend

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/regs/regs_models"
)

// DeleteBackendReader is a Reader for the DeleteBackend structure.
type DeleteBackendReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteBackendReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteBackendOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewDeleteBackendUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewDeleteBackendForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewDeleteBackendNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewDeleteBackendUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewDeleteBackendInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewDeleteBackendOK creates a DeleteBackendOK with default headers values
func NewDeleteBackendOK() *DeleteBackendOK {
	return &DeleteBackendOK{}
}

/*DeleteBackendOK handles this case with default header values.

Taxnexus Response with Message Objects with Delete Status
*/
type DeleteBackendOK struct {
	AccessControlAllowOrigin string

	Payload *regs_models.DeleteResponse
}

func (o *DeleteBackendOK) Error() string {
	return fmt.Sprintf("[DELETE /backends][%d] deleteBackendOK  %+v", 200, o.Payload)
}

func (o *DeleteBackendOK) GetPayload() *regs_models.DeleteResponse {
	return o.Payload
}

func (o *DeleteBackendOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.DeleteResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteBackendUnauthorized creates a DeleteBackendUnauthorized with default headers values
func NewDeleteBackendUnauthorized() *DeleteBackendUnauthorized {
	return &DeleteBackendUnauthorized{}
}

/*DeleteBackendUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type DeleteBackendUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *DeleteBackendUnauthorized) Error() string {
	return fmt.Sprintf("[DELETE /backends][%d] deleteBackendUnauthorized  %+v", 401, o.Payload)
}

func (o *DeleteBackendUnauthorized) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *DeleteBackendUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteBackendForbidden creates a DeleteBackendForbidden with default headers values
func NewDeleteBackendForbidden() *DeleteBackendForbidden {
	return &DeleteBackendForbidden{}
}

/*DeleteBackendForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type DeleteBackendForbidden struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *DeleteBackendForbidden) Error() string {
	return fmt.Sprintf("[DELETE /backends][%d] deleteBackendForbidden  %+v", 403, o.Payload)
}

func (o *DeleteBackendForbidden) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *DeleteBackendForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteBackendNotFound creates a DeleteBackendNotFound with default headers values
func NewDeleteBackendNotFound() *DeleteBackendNotFound {
	return &DeleteBackendNotFound{}
}

/*DeleteBackendNotFound handles this case with default header values.

Resource was not found
*/
type DeleteBackendNotFound struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *DeleteBackendNotFound) Error() string {
	return fmt.Sprintf("[DELETE /backends][%d] deleteBackendNotFound  %+v", 404, o.Payload)
}

func (o *DeleteBackendNotFound) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *DeleteBackendNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteBackendUnprocessableEntity creates a DeleteBackendUnprocessableEntity with default headers values
func NewDeleteBackendUnprocessableEntity() *DeleteBackendUnprocessableEntity {
	return &DeleteBackendUnprocessableEntity{}
}

/*DeleteBackendUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type DeleteBackendUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *DeleteBackendUnprocessableEntity) Error() string {
	return fmt.Sprintf("[DELETE /backends][%d] deleteBackendUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *DeleteBackendUnprocessableEntity) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *DeleteBackendUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteBackendInternalServerError creates a DeleteBackendInternalServerError with default headers values
func NewDeleteBackendInternalServerError() *DeleteBackendInternalServerError {
	return &DeleteBackendInternalServerError{}
}

/*DeleteBackendInternalServerError handles this case with default header values.

Server Internal Error
*/
type DeleteBackendInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *DeleteBackendInternalServerError) Error() string {
	return fmt.Sprintf("[DELETE /backends][%d] deleteBackendInternalServerError  %+v", 500, o.Payload)
}

func (o *DeleteBackendInternalServerError) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *DeleteBackendInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
