// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package backend

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/regs/regs_models"
)

// PostBackendsReader is a Reader for the PostBackends structure.
type PostBackendsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostBackendsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostBackendsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostBackendsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostBackendsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostBackendsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostBackendsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostBackendsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostBackendsOK creates a PostBackendsOK with default headers values
func NewPostBackendsOK() *PostBackendsOK {
	return &PostBackendsOK{}
}

/*PostBackendsOK handles this case with default header values.

Taxnexus Response with an array of Backend Objects
*/
type PostBackendsOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *regs_models.BackendResponse
}

func (o *PostBackendsOK) Error() string {
	return fmt.Sprintf("[POST /backends][%d] postBackendsOK  %+v", 200, o.Payload)
}

func (o *PostBackendsOK) GetPayload() *regs_models.BackendResponse {
	return o.Payload
}

func (o *PostBackendsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(regs_models.BackendResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostBackendsUnauthorized creates a PostBackendsUnauthorized with default headers values
func NewPostBackendsUnauthorized() *PostBackendsUnauthorized {
	return &PostBackendsUnauthorized{}
}

/*PostBackendsUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostBackendsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostBackendsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /backends][%d] postBackendsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostBackendsUnauthorized) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostBackendsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostBackendsForbidden creates a PostBackendsForbidden with default headers values
func NewPostBackendsForbidden() *PostBackendsForbidden {
	return &PostBackendsForbidden{}
}

/*PostBackendsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostBackendsForbidden struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostBackendsForbidden) Error() string {
	return fmt.Sprintf("[POST /backends][%d] postBackendsForbidden  %+v", 403, o.Payload)
}

func (o *PostBackendsForbidden) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostBackendsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostBackendsNotFound creates a PostBackendsNotFound with default headers values
func NewPostBackendsNotFound() *PostBackendsNotFound {
	return &PostBackendsNotFound{}
}

/*PostBackendsNotFound handles this case with default header values.

Resource was not found
*/
type PostBackendsNotFound struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostBackendsNotFound) Error() string {
	return fmt.Sprintf("[POST /backends][%d] postBackendsNotFound  %+v", 404, o.Payload)
}

func (o *PostBackendsNotFound) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostBackendsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostBackendsUnprocessableEntity creates a PostBackendsUnprocessableEntity with default headers values
func NewPostBackendsUnprocessableEntity() *PostBackendsUnprocessableEntity {
	return &PostBackendsUnprocessableEntity{}
}

/*PostBackendsUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostBackendsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostBackendsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /backends][%d] postBackendsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostBackendsUnprocessableEntity) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostBackendsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostBackendsInternalServerError creates a PostBackendsInternalServerError with default headers values
func NewPostBackendsInternalServerError() *PostBackendsInternalServerError {
	return &PostBackendsInternalServerError{}
}

/*PostBackendsInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostBackendsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostBackendsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /backends][%d] postBackendsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostBackendsInternalServerError) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostBackendsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
