// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package backend

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/regs/regs_models"
)

// PutBackendsReader is a Reader for the PutBackends structure.
type PutBackendsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutBackendsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutBackendsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutBackendsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutBackendsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutBackendsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutBackendsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutBackendsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPutBackendsOK creates a PutBackendsOK with default headers values
func NewPutBackendsOK() *PutBackendsOK {
	return &PutBackendsOK{}
}

/*PutBackendsOK handles this case with default header values.

Taxnexus Response with an array of Backend Objects
*/
type PutBackendsOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *regs_models.BackendResponse
}

func (o *PutBackendsOK) Error() string {
	return fmt.Sprintf("[PUT /backends][%d] putBackendsOK  %+v", 200, o.Payload)
}

func (o *PutBackendsOK) GetPayload() *regs_models.BackendResponse {
	return o.Payload
}

func (o *PutBackendsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(regs_models.BackendResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutBackendsUnauthorized creates a PutBackendsUnauthorized with default headers values
func NewPutBackendsUnauthorized() *PutBackendsUnauthorized {
	return &PutBackendsUnauthorized{}
}

/*PutBackendsUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PutBackendsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutBackendsUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /backends][%d] putBackendsUnauthorized  %+v", 401, o.Payload)
}

func (o *PutBackendsUnauthorized) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutBackendsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutBackendsForbidden creates a PutBackendsForbidden with default headers values
func NewPutBackendsForbidden() *PutBackendsForbidden {
	return &PutBackendsForbidden{}
}

/*PutBackendsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PutBackendsForbidden struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutBackendsForbidden) Error() string {
	return fmt.Sprintf("[PUT /backends][%d] putBackendsForbidden  %+v", 403, o.Payload)
}

func (o *PutBackendsForbidden) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutBackendsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutBackendsNotFound creates a PutBackendsNotFound with default headers values
func NewPutBackendsNotFound() *PutBackendsNotFound {
	return &PutBackendsNotFound{}
}

/*PutBackendsNotFound handles this case with default header values.

Resource was not found
*/
type PutBackendsNotFound struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutBackendsNotFound) Error() string {
	return fmt.Sprintf("[PUT /backends][%d] putBackendsNotFound  %+v", 404, o.Payload)
}

func (o *PutBackendsNotFound) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutBackendsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutBackendsUnprocessableEntity creates a PutBackendsUnprocessableEntity with default headers values
func NewPutBackendsUnprocessableEntity() *PutBackendsUnprocessableEntity {
	return &PutBackendsUnprocessableEntity{}
}

/*PutBackendsUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutBackendsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutBackendsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /backends][%d] putBackendsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutBackendsUnprocessableEntity) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutBackendsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutBackendsInternalServerError creates a PutBackendsInternalServerError with default headers values
func NewPutBackendsInternalServerError() *PutBackendsInternalServerError {
	return &PutBackendsInternalServerError{}
}

/*PutBackendsInternalServerError handles this case with default header values.

Server Internal Error
*/
type PutBackendsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutBackendsInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /backends][%d] putBackendsInternalServerError  %+v", 500, o.Payload)
}

func (o *PutBackendsInternalServerError) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutBackendsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
