// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package filing

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/regs/regs_models"
)

// PostFilingsReader is a Reader for the PostFilings structure.
type PostFilingsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostFilingsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostFilingsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostFilingsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostFilingsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostFilingsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostFilingsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostFilingsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostFilingsOK creates a PostFilingsOK with default headers values
func NewPostFilingsOK() *PostFilingsOK {
	return &PostFilingsOK{}
}

/*PostFilingsOK handles this case with default header values.

Taxnexus Response with an array of Filing objects
*/
type PostFilingsOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *regs_models.FilingResponse
}

func (o *PostFilingsOK) Error() string {
	return fmt.Sprintf("[POST /filings][%d] postFilingsOK  %+v", 200, o.Payload)
}

func (o *PostFilingsOK) GetPayload() *regs_models.FilingResponse {
	return o.Payload
}

func (o *PostFilingsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(regs_models.FilingResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostFilingsUnauthorized creates a PostFilingsUnauthorized with default headers values
func NewPostFilingsUnauthorized() *PostFilingsUnauthorized {
	return &PostFilingsUnauthorized{}
}

/*PostFilingsUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostFilingsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostFilingsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /filings][%d] postFilingsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostFilingsUnauthorized) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostFilingsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostFilingsForbidden creates a PostFilingsForbidden with default headers values
func NewPostFilingsForbidden() *PostFilingsForbidden {
	return &PostFilingsForbidden{}
}

/*PostFilingsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostFilingsForbidden struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostFilingsForbidden) Error() string {
	return fmt.Sprintf("[POST /filings][%d] postFilingsForbidden  %+v", 403, o.Payload)
}

func (o *PostFilingsForbidden) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostFilingsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostFilingsNotFound creates a PostFilingsNotFound with default headers values
func NewPostFilingsNotFound() *PostFilingsNotFound {
	return &PostFilingsNotFound{}
}

/*PostFilingsNotFound handles this case with default header values.

Resource was not found
*/
type PostFilingsNotFound struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostFilingsNotFound) Error() string {
	return fmt.Sprintf("[POST /filings][%d] postFilingsNotFound  %+v", 404, o.Payload)
}

func (o *PostFilingsNotFound) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostFilingsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostFilingsUnprocessableEntity creates a PostFilingsUnprocessableEntity with default headers values
func NewPostFilingsUnprocessableEntity() *PostFilingsUnprocessableEntity {
	return &PostFilingsUnprocessableEntity{}
}

/*PostFilingsUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostFilingsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostFilingsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /filings][%d] postFilingsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostFilingsUnprocessableEntity) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostFilingsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostFilingsInternalServerError creates a PostFilingsInternalServerError with default headers values
func NewPostFilingsInternalServerError() *PostFilingsInternalServerError {
	return &PostFilingsInternalServerError{}
}

/*PostFilingsInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostFilingsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostFilingsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /filings][%d] postFilingsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostFilingsInternalServerError) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostFilingsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
