// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package filing

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/regs/regs_models"
)

// PutFilingsReader is a Reader for the PutFilings structure.
type PutFilingsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutFilingsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutFilingsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutFilingsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutFilingsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutFilingsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutFilingsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutFilingsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPutFilingsOK creates a PutFilingsOK with default headers values
func NewPutFilingsOK() *PutFilingsOK {
	return &PutFilingsOK{}
}

/*PutFilingsOK handles this case with default header values.

Taxnexus Response with an array of Filing objects
*/
type PutFilingsOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *regs_models.FilingResponse
}

func (o *PutFilingsOK) Error() string {
	return fmt.Sprintf("[PUT /filings][%d] putFilingsOK  %+v", 200, o.Payload)
}

func (o *PutFilingsOK) GetPayload() *regs_models.FilingResponse {
	return o.Payload
}

func (o *PutFilingsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(regs_models.FilingResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutFilingsUnauthorized creates a PutFilingsUnauthorized with default headers values
func NewPutFilingsUnauthorized() *PutFilingsUnauthorized {
	return &PutFilingsUnauthorized{}
}

/*PutFilingsUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PutFilingsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutFilingsUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /filings][%d] putFilingsUnauthorized  %+v", 401, o.Payload)
}

func (o *PutFilingsUnauthorized) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutFilingsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutFilingsForbidden creates a PutFilingsForbidden with default headers values
func NewPutFilingsForbidden() *PutFilingsForbidden {
	return &PutFilingsForbidden{}
}

/*PutFilingsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PutFilingsForbidden struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutFilingsForbidden) Error() string {
	return fmt.Sprintf("[PUT /filings][%d] putFilingsForbidden  %+v", 403, o.Payload)
}

func (o *PutFilingsForbidden) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutFilingsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutFilingsNotFound creates a PutFilingsNotFound with default headers values
func NewPutFilingsNotFound() *PutFilingsNotFound {
	return &PutFilingsNotFound{}
}

/*PutFilingsNotFound handles this case with default header values.

Resource was not found
*/
type PutFilingsNotFound struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutFilingsNotFound) Error() string {
	return fmt.Sprintf("[PUT /filings][%d] putFilingsNotFound  %+v", 404, o.Payload)
}

func (o *PutFilingsNotFound) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutFilingsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutFilingsUnprocessableEntity creates a PutFilingsUnprocessableEntity with default headers values
func NewPutFilingsUnprocessableEntity() *PutFilingsUnprocessableEntity {
	return &PutFilingsUnprocessableEntity{}
}

/*PutFilingsUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutFilingsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutFilingsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /filings][%d] putFilingsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutFilingsUnprocessableEntity) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutFilingsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutFilingsInternalServerError creates a PutFilingsInternalServerError with default headers values
func NewPutFilingsInternalServerError() *PutFilingsInternalServerError {
	return &PutFilingsInternalServerError{}
}

/*PutFilingsInternalServerError handles this case with default header values.

Server Internal Error
*/
type PutFilingsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutFilingsInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /filings][%d] putFilingsInternalServerError  %+v", 500, o.Payload)
}

func (o *PutFilingsInternalServerError) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutFilingsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
