// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package notebook

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/regs/regs_models"
)

// PutNotebooksReader is a Reader for the PutNotebooks structure.
type PutNotebooksReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutNotebooksReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutNotebooksOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutNotebooksUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutNotebooksForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutNotebooksNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutNotebooksUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutNotebooksInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPutNotebooksOK creates a PutNotebooksOK with default headers values
func NewPutNotebooksOK() *PutNotebooksOK {
	return &PutNotebooksOK{}
}

/*PutNotebooksOK handles this case with default header values.

Taxnexus Response with Notebook objects
*/
type PutNotebooksOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *regs_models.NotebookResponse
}

func (o *PutNotebooksOK) Error() string {
	return fmt.Sprintf("[PUT /notebooks][%d] putNotebooksOK  %+v", 200, o.Payload)
}

func (o *PutNotebooksOK) GetPayload() *regs_models.NotebookResponse {
	return o.Payload
}

func (o *PutNotebooksOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(regs_models.NotebookResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutNotebooksUnauthorized creates a PutNotebooksUnauthorized with default headers values
func NewPutNotebooksUnauthorized() *PutNotebooksUnauthorized {
	return &PutNotebooksUnauthorized{}
}

/*PutNotebooksUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PutNotebooksUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutNotebooksUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /notebooks][%d] putNotebooksUnauthorized  %+v", 401, o.Payload)
}

func (o *PutNotebooksUnauthorized) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutNotebooksUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutNotebooksForbidden creates a PutNotebooksForbidden with default headers values
func NewPutNotebooksForbidden() *PutNotebooksForbidden {
	return &PutNotebooksForbidden{}
}

/*PutNotebooksForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PutNotebooksForbidden struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutNotebooksForbidden) Error() string {
	return fmt.Sprintf("[PUT /notebooks][%d] putNotebooksForbidden  %+v", 403, o.Payload)
}

func (o *PutNotebooksForbidden) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutNotebooksForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutNotebooksNotFound creates a PutNotebooksNotFound with default headers values
func NewPutNotebooksNotFound() *PutNotebooksNotFound {
	return &PutNotebooksNotFound{}
}

/*PutNotebooksNotFound handles this case with default header values.

Resource was not found
*/
type PutNotebooksNotFound struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutNotebooksNotFound) Error() string {
	return fmt.Sprintf("[PUT /notebooks][%d] putNotebooksNotFound  %+v", 404, o.Payload)
}

func (o *PutNotebooksNotFound) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutNotebooksNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutNotebooksUnprocessableEntity creates a PutNotebooksUnprocessableEntity with default headers values
func NewPutNotebooksUnprocessableEntity() *PutNotebooksUnprocessableEntity {
	return &PutNotebooksUnprocessableEntity{}
}

/*PutNotebooksUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutNotebooksUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutNotebooksUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /notebooks][%d] putNotebooksUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutNotebooksUnprocessableEntity) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutNotebooksUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutNotebooksInternalServerError creates a PutNotebooksInternalServerError with default headers values
func NewPutNotebooksInternalServerError() *PutNotebooksInternalServerError {
	return &PutNotebooksInternalServerError{}
}

/*PutNotebooksInternalServerError handles this case with default header values.

Server Internal Error
*/
type PutNotebooksInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutNotebooksInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /notebooks][%d] putNotebooksInternalServerError  %+v", 500, o.Payload)
}

func (o *PutNotebooksInternalServerError) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutNotebooksInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
