// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package rating_engine

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new rating engine API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for rating engine API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	DeleteRatingEngine(params *DeleteRatingEngineParams, authInfo runtime.ClientAuthInfoWriter) (*DeleteRatingEngineOK, error)

	GetRatingEngines(params *GetRatingEnginesParams, authInfo runtime.ClientAuthInfoWriter) (*GetRatingEnginesOK, error)

	PostRatingEngines(params *PostRatingEnginesParams, authInfo runtime.ClientAuthInfoWriter) (*PostRatingEnginesOK, error)

	PutRatingEngines(params *PutRatingEnginesParams, authInfo runtime.ClientAuthInfoWriter) (*PutRatingEnginesOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  DeleteRatingEngine deletes a rating engine

  Delete Taxnexus Backend record
*/
func (a *Client) DeleteRatingEngine(params *DeleteRatingEngineParams, authInfo runtime.ClientAuthInfoWriter) (*DeleteRatingEngineOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewDeleteRatingEngineParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "deleteRatingEngine",
		Method:             "DELETE",
		PathPattern:        "/ratingengines",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &DeleteRatingEngineReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*DeleteRatingEngineOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for deleteRatingEngine: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetRatingEngines gets a list of rating engines

  Return a list of Rating Engines
*/
func (a *Client) GetRatingEngines(params *GetRatingEnginesParams, authInfo runtime.ClientAuthInfoWriter) (*GetRatingEnginesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetRatingEnginesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getRatingEngines",
		Method:             "GET",
		PathPattern:        "/ratingengines",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetRatingEnginesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetRatingEnginesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getRatingEngines: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostRatingEngines adds rating engine

  Rating Engine records to be added
*/
func (a *Client) PostRatingEngines(params *PostRatingEnginesParams, authInfo runtime.ClientAuthInfoWriter) (*PostRatingEnginesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostRatingEnginesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postRatingEngines",
		Method:             "POST",
		PathPattern:        "/ratingengines",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostRatingEnginesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostRatingEnginesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postRatingEngines: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PutRatingEngines updates rating engine

  Update Rating Engine records
*/
func (a *Client) PutRatingEngines(params *PutRatingEnginesParams, authInfo runtime.ClientAuthInfoWriter) (*PutRatingEnginesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutRatingEnginesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "putRatingEngines",
		Method:             "PUT",
		PathPattern:        "/ratingengines",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutRatingEnginesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutRatingEnginesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putRatingEngines: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
