// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package submission

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new submission API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for submission API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	GetSubmissions(params *GetSubmissionsParams, authInfo runtime.ClientAuthInfoWriter) (*GetSubmissionsOK, error)

	PostSubmissions(params *PostSubmissionsParams, authInfo runtime.ClientAuthInfoWriter) (*PostSubmissionsOK, error)

	PutSubmissions(params *PutSubmissionsParams, authInfo runtime.ClientAuthInfoWriter) (*PutSubmissionsOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetSubmissions gets a list of submissions

  Return a list of available Submissions
*/
func (a *Client) GetSubmissions(params *GetSubmissionsParams, authInfo runtime.ClientAuthInfoWriter) (*GetSubmissionsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetSubmissionsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getSubmissions",
		Method:             "GET",
		PathPattern:        "/submissions",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetSubmissionsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetSubmissionsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getSubmissions: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostSubmissions adds new submissions

  Create new Sumissions
*/
func (a *Client) PostSubmissions(params *PostSubmissionsParams, authInfo runtime.ClientAuthInfoWriter) (*PostSubmissionsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostSubmissionsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postSubmissions",
		Method:             "POST",
		PathPattern:        "/submissions",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostSubmissionsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostSubmissionsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postSubmissions: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PutSubmissions updates a submission

  Update all the fields in a Submission record identified by Taxnexus Id
*/
func (a *Client) PutSubmissions(params *PutSubmissionsParams, authInfo runtime.ClientAuthInfoWriter) (*PutSubmissionsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutSubmissionsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "putSubmissions",
		Method:             "PUT",
		PathPattern:        "/submissions",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutSubmissionsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutSubmissionsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putSubmissions: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
