// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package transaction

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/regs/regs_models"
)

// PostTransactionsReader is a Reader for the PostTransactions structure.
type PostTransactionsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostTransactionsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostTransactionsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostTransactionsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostTransactionsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostTransactionsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostTransactionsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostTransactionsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostTransactionsOK creates a PostTransactionsOK with default headers values
func NewPostTransactionsOK() *PostTransactionsOK {
	return &PostTransactionsOK{}
}

/*PostTransactionsOK handles this case with default header values.

Taxnexus Response with Transaction objects
*/
type PostTransactionsOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *regs_models.TransactionResponse
}

func (o *PostTransactionsOK) Error() string {
	return fmt.Sprintf("[POST /transactions][%d] postTransactionsOK  %+v", 200, o.Payload)
}

func (o *PostTransactionsOK) GetPayload() *regs_models.TransactionResponse {
	return o.Payload
}

func (o *PostTransactionsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(regs_models.TransactionResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTransactionsUnauthorized creates a PostTransactionsUnauthorized with default headers values
func NewPostTransactionsUnauthorized() *PostTransactionsUnauthorized {
	return &PostTransactionsUnauthorized{}
}

/*PostTransactionsUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostTransactionsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostTransactionsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /transactions][%d] postTransactionsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostTransactionsUnauthorized) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostTransactionsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTransactionsForbidden creates a PostTransactionsForbidden with default headers values
func NewPostTransactionsForbidden() *PostTransactionsForbidden {
	return &PostTransactionsForbidden{}
}

/*PostTransactionsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostTransactionsForbidden struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostTransactionsForbidden) Error() string {
	return fmt.Sprintf("[POST /transactions][%d] postTransactionsForbidden  %+v", 403, o.Payload)
}

func (o *PostTransactionsForbidden) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostTransactionsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTransactionsNotFound creates a PostTransactionsNotFound with default headers values
func NewPostTransactionsNotFound() *PostTransactionsNotFound {
	return &PostTransactionsNotFound{}
}

/*PostTransactionsNotFound handles this case with default header values.

Resource was not found
*/
type PostTransactionsNotFound struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostTransactionsNotFound) Error() string {
	return fmt.Sprintf("[POST /transactions][%d] postTransactionsNotFound  %+v", 404, o.Payload)
}

func (o *PostTransactionsNotFound) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostTransactionsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTransactionsUnprocessableEntity creates a PostTransactionsUnprocessableEntity with default headers values
func NewPostTransactionsUnprocessableEntity() *PostTransactionsUnprocessableEntity {
	return &PostTransactionsUnprocessableEntity{}
}

/*PostTransactionsUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostTransactionsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostTransactionsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /transactions][%d] postTransactionsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostTransactionsUnprocessableEntity) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostTransactionsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTransactionsInternalServerError creates a PostTransactionsInternalServerError with default headers values
func NewPostTransactionsInternalServerError() *PostTransactionsInternalServerError {
	return &PostTransactionsInternalServerError{}
}

/*PostTransactionsInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostTransactionsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostTransactionsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /transactions][%d] postTransactionsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostTransactionsInternalServerError) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostTransactionsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
