// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package transaction

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/regs/regs_models"
)

// PutTransactionsReader is a Reader for the PutTransactions structure.
type PutTransactionsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutTransactionsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutTransactionsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutTransactionsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutTransactionsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutTransactionsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutTransactionsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutTransactionsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPutTransactionsOK creates a PutTransactionsOK with default headers values
func NewPutTransactionsOK() *PutTransactionsOK {
	return &PutTransactionsOK{}
}

/*PutTransactionsOK handles this case with default header values.

Taxnexus Response with Transaction objects
*/
type PutTransactionsOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *regs_models.TransactionResponse
}

func (o *PutTransactionsOK) Error() string {
	return fmt.Sprintf("[PUT /transactions][%d] putTransactionsOK  %+v", 200, o.Payload)
}

func (o *PutTransactionsOK) GetPayload() *regs_models.TransactionResponse {
	return o.Payload
}

func (o *PutTransactionsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(regs_models.TransactionResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutTransactionsUnauthorized creates a PutTransactionsUnauthorized with default headers values
func NewPutTransactionsUnauthorized() *PutTransactionsUnauthorized {
	return &PutTransactionsUnauthorized{}
}

/*PutTransactionsUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PutTransactionsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutTransactionsUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /transactions][%d] putTransactionsUnauthorized  %+v", 401, o.Payload)
}

func (o *PutTransactionsUnauthorized) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutTransactionsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutTransactionsForbidden creates a PutTransactionsForbidden with default headers values
func NewPutTransactionsForbidden() *PutTransactionsForbidden {
	return &PutTransactionsForbidden{}
}

/*PutTransactionsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PutTransactionsForbidden struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutTransactionsForbidden) Error() string {
	return fmt.Sprintf("[PUT /transactions][%d] putTransactionsForbidden  %+v", 403, o.Payload)
}

func (o *PutTransactionsForbidden) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutTransactionsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutTransactionsNotFound creates a PutTransactionsNotFound with default headers values
func NewPutTransactionsNotFound() *PutTransactionsNotFound {
	return &PutTransactionsNotFound{}
}

/*PutTransactionsNotFound handles this case with default header values.

Resource was not found
*/
type PutTransactionsNotFound struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutTransactionsNotFound) Error() string {
	return fmt.Sprintf("[PUT /transactions][%d] putTransactionsNotFound  %+v", 404, o.Payload)
}

func (o *PutTransactionsNotFound) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutTransactionsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutTransactionsUnprocessableEntity creates a PutTransactionsUnprocessableEntity with default headers values
func NewPutTransactionsUnprocessableEntity() *PutTransactionsUnprocessableEntity {
	return &PutTransactionsUnprocessableEntity{}
}

/*PutTransactionsUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutTransactionsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutTransactionsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /transactions][%d] putTransactionsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutTransactionsUnprocessableEntity) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutTransactionsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutTransactionsInternalServerError creates a PutTransactionsInternalServerError with default headers values
func NewPutTransactionsInternalServerError() *PutTransactionsInternalServerError {
	return &PutTransactionsInternalServerError{}
}

/*PutTransactionsInternalServerError handles this case with default header values.

Server Internal Error
*/
type PutTransactionsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PutTransactionsInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /transactions][%d] putTransactionsInternalServerError  %+v", 500, o.Payload)
}

func (o *PutTransactionsInternalServerError) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PutTransactionsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
