// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package render_client

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"
	httptransport "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/render/render_client/account"
	"code.tnxs.net/taxnexus/lib/api/render/render_client/cors"
	"code.tnxs.net/taxnexus/lib/api/render/render_client/county"
	"code.tnxs.net/taxnexus/lib/api/render/render_client/ingest"
	"code.tnxs.net/taxnexus/lib/api/render/render_client/invoice"
	"code.tnxs.net/taxnexus/lib/api/render/render_client/report"
	"code.tnxs.net/taxnexus/lib/api/render/render_client/tax"
)

// Default render HTTP client.
var Default = NewHTTPClient(nil)

const (
	// DefaultHost is the default Host
	// found in Meta (info) section of spec file
	DefaultHost string = "render.fabric.tnxs.net:8080"
	// DefaultBasePath is the default BasePath
	// found in Meta (info) section of spec file
	DefaultBasePath string = "/v1"
)

// DefaultSchemes are the default schemes found in Meta (info) section of spec file
var DefaultSchemes = []string{"http"}

// NewHTTPClient creates a new render HTTP client.
func NewHTTPClient(formats strfmt.Registry) *Render {
	return NewHTTPClientWithConfig(formats, nil)
}

// NewHTTPClientWithConfig creates a new render HTTP client,
// using a customizable transport config.
func NewHTTPClientWithConfig(formats strfmt.Registry, cfg *TransportConfig) *Render {
	// ensure nullable parameters have default
	if cfg == nil {
		cfg = DefaultTransportConfig()
	}

	// create transport and client
	transport := httptransport.New(cfg.Host, cfg.BasePath, cfg.Schemes)
	return New(transport, formats)
}

// New creates a new render client
func New(transport runtime.ClientTransport, formats strfmt.Registry) *Render {
	// ensure nullable parameters have default
	if formats == nil {
		formats = strfmt.Default
	}

	cli := new(Render)
	cli.Transport = transport
	cli.Account = account.New(transport, formats)
	cli.Cors = cors.New(transport, formats)
	cli.County = county.New(transport, formats)
	cli.Ingest = ingest.New(transport, formats)
	cli.Invoice = invoice.New(transport, formats)
	cli.Report = report.New(transport, formats)
	cli.Tax = tax.New(transport, formats)
	return cli
}

// DefaultTransportConfig creates a TransportConfig with the
// default settings taken from the meta section of the spec file.
func DefaultTransportConfig() *TransportConfig {
	return &TransportConfig{
		Host:     DefaultHost,
		BasePath: DefaultBasePath,
		Schemes:  DefaultSchemes,
	}
}

// TransportConfig contains the transport related info,
// found in the meta section of the spec file.
type TransportConfig struct {
	Host     string
	BasePath string
	Schemes  []string
}

// WithHost overrides the default host,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithHost(host string) *TransportConfig {
	cfg.Host = host
	return cfg
}

// WithBasePath overrides the default basePath,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithBasePath(basePath string) *TransportConfig {
	cfg.BasePath = basePath
	return cfg
}

// WithSchemes overrides the default schemes,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithSchemes(schemes []string) *TransportConfig {
	cfg.Schemes = schemes
	return cfg
}

// Render is a client for render
type Render struct {
	Account account.ClientService

	Cors cors.ClientService

	County county.ClientService

	Ingest ingest.ClientService

	Invoice invoice.ClientService

	Report report.ClientService

	Tax tax.ClientService

	Transport runtime.ClientTransport
}

// SetTransport changes the transport on the client and all its subresources
func (c *Render) SetTransport(transport runtime.ClientTransport) {
	c.Transport = transport
	c.Account.SetTransport(transport)
	c.Cors.SetTransport(transport)
	c.County.SetTransport(transport)
	c.Ingest.SetTransport(transport)
	c.Invoice.SetTransport(transport)
	c.Report.SetTransport(transport)
	c.Tax.SetTransport(transport)
}
