// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package report

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetRenderReportsParams creates a new GetRenderReportsParams object
// with the default values initialized.
func NewGetRenderReportsParams() *GetRenderReportsParams {
	var ()
	return &GetRenderReportsParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetRenderReportsParamsWithTimeout creates a new GetRenderReportsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetRenderReportsParamsWithTimeout(timeout time.Duration) *GetRenderReportsParams {
	var ()
	return &GetRenderReportsParams{

		timeout: timeout,
	}
}

// NewGetRenderReportsParamsWithContext creates a new GetRenderReportsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetRenderReportsParamsWithContext(ctx context.Context) *GetRenderReportsParams {
	var ()
	return &GetRenderReportsParams{

		Context: ctx,
	}
}

// NewGetRenderReportsParamsWithHTTPClient creates a new GetRenderReportsParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetRenderReportsParamsWithHTTPClient(client *http.Client) *GetRenderReportsParams {
	var ()
	return &GetRenderReportsParams{
		HTTPClient: client,
	}
}

/*GetRenderReportsParams contains all the parameters to send to the API endpoint
for the get render reports operation typically these are written to a http.Request
*/
type GetRenderReportsParams struct {

	/*AccountID
	  Taxnexus Id of the Account to be used a record retrieval

	*/
	AccountID string
	/*Month
	  The Month Number (1,2, ..., 12) of the report

	*/
	Month *int64
	/*Quarter
	  The Quarter Number (1,2,3,4) of the report

	*/
	Quarter *int64
	/*Year
	  The year of the report

	*/
	Year *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get render reports params
func (o *GetRenderReportsParams) WithTimeout(timeout time.Duration) *GetRenderReportsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get render reports params
func (o *GetRenderReportsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get render reports params
func (o *GetRenderReportsParams) WithContext(ctx context.Context) *GetRenderReportsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get render reports params
func (o *GetRenderReportsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get render reports params
func (o *GetRenderReportsParams) WithHTTPClient(client *http.Client) *GetRenderReportsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get render reports params
func (o *GetRenderReportsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the get render reports params
func (o *GetRenderReportsParams) WithAccountID(accountID string) *GetRenderReportsParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the get render reports params
func (o *GetRenderReportsParams) SetAccountID(accountID string) {
	o.AccountID = accountID
}

// WithMonth adds the month to the get render reports params
func (o *GetRenderReportsParams) WithMonth(month *int64) *GetRenderReportsParams {
	o.SetMonth(month)
	return o
}

// SetMonth adds the month to the get render reports params
func (o *GetRenderReportsParams) SetMonth(month *int64) {
	o.Month = month
}

// WithQuarter adds the quarter to the get render reports params
func (o *GetRenderReportsParams) WithQuarter(quarter *int64) *GetRenderReportsParams {
	o.SetQuarter(quarter)
	return o
}

// SetQuarter adds the quarter to the get render reports params
func (o *GetRenderReportsParams) SetQuarter(quarter *int64) {
	o.Quarter = quarter
}

// WithYear adds the year to the get render reports params
func (o *GetRenderReportsParams) WithYear(year *int64) *GetRenderReportsParams {
	o.SetYear(year)
	return o
}

// SetYear adds the year to the get render reports params
func (o *GetRenderReportsParams) SetYear(year *int64) {
	o.Year = year
}

// WriteToRequest writes these params to a swagger request
func (o *GetRenderReportsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// query param accountId
	qrAccountID := o.AccountID
	qAccountID := qrAccountID
	if qAccountID != "" {
		if err := r.SetQueryParam("accountId", qAccountID); err != nil {
			return err
		}
	}

	if o.Month != nil {

		// query param month
		var qrMonth int64
		if o.Month != nil {
			qrMonth = *o.Month
		}
		qMonth := swag.FormatInt64(qrMonth)
		if qMonth != "" {
			if err := r.SetQueryParam("month", qMonth); err != nil {
				return err
			}
		}

	}

	if o.Quarter != nil {

		// query param quarter
		var qrQuarter int64
		if o.Quarter != nil {
			qrQuarter = *o.Quarter
		}
		qQuarter := swag.FormatInt64(qrQuarter)
		if qQuarter != "" {
			if err := r.SetQueryParam("quarter", qQuarter); err != nil {
				return err
			}
		}

	}

	if o.Year != nil {

		// query param year
		var qrYear int64
		if o.Year != nil {
			qrYear = *o.Year
		}
		qYear := swag.FormatInt64(qrYear)
		if qYear != "" {
			if err := r.SetQueryParam("year", qYear); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
