// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package backends

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetBackendsParams creates a new GetBackendsParams object
// with the default values initialized.
func NewGetBackendsParams() *GetBackendsParams {
	var ()
	return &GetBackendsParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetBackendsParamsWithTimeout creates a new GetBackendsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetBackendsParamsWithTimeout(timeout time.Duration) *GetBackendsParams {
	var ()
	return &GetBackendsParams{

		timeout: timeout,
	}
}

// NewGetBackendsParamsWithContext creates a new GetBackendsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetBackendsParamsWithContext(ctx context.Context) *GetBackendsParams {
	var ()
	return &GetBackendsParams{

		Context: ctx,
	}
}

// NewGetBackendsParamsWithHTTPClient creates a new GetBackendsParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetBackendsParamsWithHTTPClient(client *http.Client) *GetBackendsParams {
	var ()
	return &GetBackendsParams{
		HTTPClient: client,
	}
}

/*GetBackendsParams contains all the parameters to send to the API endpoint
for the get backends operation typically these are written to a http.Request
*/
type GetBackendsParams struct {

	/*BackendID
	  Taxnexus Id of the Backend to be retrieved

	*/
	BackendID *string
	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get backends params
func (o *GetBackendsParams) WithTimeout(timeout time.Duration) *GetBackendsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get backends params
func (o *GetBackendsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get backends params
func (o *GetBackendsParams) WithContext(ctx context.Context) *GetBackendsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get backends params
func (o *GetBackendsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get backends params
func (o *GetBackendsParams) WithHTTPClient(client *http.Client) *GetBackendsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get backends params
func (o *GetBackendsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBackendID adds the backendID to the get backends params
func (o *GetBackendsParams) WithBackendID(backendID *string) *GetBackendsParams {
	o.SetBackendID(backendID)
	return o
}

// SetBackendID adds the backendId to the get backends params
func (o *GetBackendsParams) SetBackendID(backendID *string) {
	o.BackendID = backendID
}

// WithLimit adds the limit to the get backends params
func (o *GetBackendsParams) WithLimit(limit *int64) *GetBackendsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get backends params
func (o *GetBackendsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get backends params
func (o *GetBackendsParams) WithOffset(offset *int64) *GetBackendsParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get backends params
func (o *GetBackendsParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetBackendsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.BackendID != nil {

		// query param backendId
		var qrBackendID string
		if o.BackendID != nil {
			qrBackendID = *o.BackendID
		}
		qBackendID := qrBackendID
		if qBackendID != "" {
			if err := r.SetQueryParam("backendId", qBackendID); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
