// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package clusters

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetClustersParams creates a new GetClustersParams object
// with the default values initialized.
func NewGetClustersParams() *GetClustersParams {
	var ()
	return &GetClustersParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetClustersParamsWithTimeout creates a new GetClustersParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetClustersParamsWithTimeout(timeout time.Duration) *GetClustersParams {
	var ()
	return &GetClustersParams{

		timeout: timeout,
	}
}

// NewGetClustersParamsWithContext creates a new GetClustersParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetClustersParamsWithContext(ctx context.Context) *GetClustersParams {
	var ()
	return &GetClustersParams{

		Context: ctx,
	}
}

// NewGetClustersParamsWithHTTPClient creates a new GetClustersParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetClustersParamsWithHTTPClient(client *http.Client) *GetClustersParams {
	var ()
	return &GetClustersParams{
		HTTPClient: client,
	}
}

/*GetClustersParams contains all the parameters to send to the API endpoint
for the get clusters operation typically these are written to a http.Request
*/
type GetClustersParams struct {

	/*ClusterID
	  Taxnexus Record Id of a Cluster

	*/
	ClusterID *string
	/*CompanyID
	  Taxnexus Id of the Company to be retrieved

	*/
	CompanyID *string
	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get clusters params
func (o *GetClustersParams) WithTimeout(timeout time.Duration) *GetClustersParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get clusters params
func (o *GetClustersParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get clusters params
func (o *GetClustersParams) WithContext(ctx context.Context) *GetClustersParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get clusters params
func (o *GetClustersParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get clusters params
func (o *GetClustersParams) WithHTTPClient(client *http.Client) *GetClustersParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get clusters params
func (o *GetClustersParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithClusterID adds the clusterID to the get clusters params
func (o *GetClustersParams) WithClusterID(clusterID *string) *GetClustersParams {
	o.SetClusterID(clusterID)
	return o
}

// SetClusterID adds the clusterId to the get clusters params
func (o *GetClustersParams) SetClusterID(clusterID *string) {
	o.ClusterID = clusterID
}

// WithCompanyID adds the companyID to the get clusters params
func (o *GetClustersParams) WithCompanyID(companyID *string) *GetClustersParams {
	o.SetCompanyID(companyID)
	return o
}

// SetCompanyID adds the companyId to the get clusters params
func (o *GetClustersParams) SetCompanyID(companyID *string) {
	o.CompanyID = companyID
}

// WithLimit adds the limit to the get clusters params
func (o *GetClustersParams) WithLimit(limit *int64) *GetClustersParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get clusters params
func (o *GetClustersParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get clusters params
func (o *GetClustersParams) WithOffset(offset *int64) *GetClustersParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get clusters params
func (o *GetClustersParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetClustersParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.ClusterID != nil {

		// query param clusterId
		var qrClusterID string
		if o.ClusterID != nil {
			qrClusterID = *o.ClusterID
		}
		qClusterID := qrClusterID
		if qClusterID != "" {
			if err := r.SetQueryParam("clusterId", qClusterID); err != nil {
				return err
			}
		}

	}

	if o.CompanyID != nil {

		// query param companyId
		var qrCompanyID string
		if o.CompanyID != nil {
			qrCompanyID = *o.CompanyID
		}
		qCompanyID := qrCompanyID
		if qCompanyID != "" {
			if err := r.SetQueryParam("companyId", qCompanyID); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
