// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package clusters

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/sf-gate/sf_gate_models"
)

// PutClustersReader is a Reader for the PutClusters structure.
type PutClustersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutClustersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutClustersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutClustersUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutClustersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutClustersNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutClustersUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutClustersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPutClustersOK creates a PutClustersOK with default headers values
func NewPutClustersOK() *PutClustersOK {
	return &PutClustersOK{}
}

/*PutClustersOK handles this case with default header values.

Taxnexus Response with Cluster objects
*/
type PutClustersOK struct {
	Payload *sf_gate_models.ClusterResponse
}

func (o *PutClustersOK) Error() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersOK  %+v", 200, o.Payload)
}

func (o *PutClustersOK) GetPayload() *sf_gate_models.ClusterResponse {
	return o.Payload
}

func (o *PutClustersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.ClusterResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutClustersUnauthorized creates a PutClustersUnauthorized with default headers values
func NewPutClustersUnauthorized() *PutClustersUnauthorized {
	return &PutClustersUnauthorized{}
}

/*PutClustersUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PutClustersUnauthorized struct {
	Payload *sf_gate_models.Error
}

func (o *PutClustersUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersUnauthorized  %+v", 401, o.Payload)
}

func (o *PutClustersUnauthorized) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutClustersUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutClustersForbidden creates a PutClustersForbidden with default headers values
func NewPutClustersForbidden() *PutClustersForbidden {
	return &PutClustersForbidden{}
}

/*PutClustersForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PutClustersForbidden struct {
	Payload *sf_gate_models.Error
}

func (o *PutClustersForbidden) Error() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersForbidden  %+v", 403, o.Payload)
}

func (o *PutClustersForbidden) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutClustersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutClustersNotFound creates a PutClustersNotFound with default headers values
func NewPutClustersNotFound() *PutClustersNotFound {
	return &PutClustersNotFound{}
}

/*PutClustersNotFound handles this case with default header values.

Resource was not found
*/
type PutClustersNotFound struct {
	Payload *sf_gate_models.Error
}

func (o *PutClustersNotFound) Error() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersNotFound  %+v", 404, o.Payload)
}

func (o *PutClustersNotFound) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutClustersNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutClustersUnprocessableEntity creates a PutClustersUnprocessableEntity with default headers values
func NewPutClustersUnprocessableEntity() *PutClustersUnprocessableEntity {
	return &PutClustersUnprocessableEntity{}
}

/*PutClustersUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutClustersUnprocessableEntity struct {
	Payload *sf_gate_models.Error
}

func (o *PutClustersUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutClustersUnprocessableEntity) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutClustersUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutClustersInternalServerError creates a PutClustersInternalServerError with default headers values
func NewPutClustersInternalServerError() *PutClustersInternalServerError {
	return &PutClustersInternalServerError{}
}

/*PutClustersInternalServerError handles this case with default header values.

Server Internal Error
*/
type PutClustersInternalServerError struct {
	Payload *sf_gate_models.Error
}

func (o *PutClustersInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /clusters][%d] putClustersInternalServerError  %+v", 500, o.Payload)
}

func (o *PutClustersInternalServerError) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutClustersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
