// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"code.tnxs.net/taxnexus/lib/api/sf-gate/sf_gate_models"
)

// DeleteContactReader is a Reader for the DeleteContact structure.
type DeleteContactReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteContactReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteContactOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewDeleteContactUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewDeleteContactForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewDeleteContactNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewDeleteContactInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewDeleteContactOK creates a DeleteContactOK with default headers values
func NewDeleteContactOK() *DeleteContactOK {
	return &DeleteContactOK{}
}

/*DeleteContactOK handles this case with default header values.

An array of Message Objects with Delete Status
*/
type DeleteContactOK struct {
	Payload *DeleteContactOKBody
}

func (o *DeleteContactOK) Error() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactOK  %+v", 200, o.Payload)
}

func (o *DeleteContactOK) GetPayload() *DeleteContactOKBody {
	return o.Payload
}

func (o *DeleteContactOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(DeleteContactOKBody)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteContactUnauthorized creates a DeleteContactUnauthorized with default headers values
func NewDeleteContactUnauthorized() *DeleteContactUnauthorized {
	return &DeleteContactUnauthorized{}
}

/*DeleteContactUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type DeleteContactUnauthorized struct {
	Payload *sf_gate_models.Error
}

func (o *DeleteContactUnauthorized) Error() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactUnauthorized  %+v", 401, o.Payload)
}

func (o *DeleteContactUnauthorized) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *DeleteContactUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteContactForbidden creates a DeleteContactForbidden with default headers values
func NewDeleteContactForbidden() *DeleteContactForbidden {
	return &DeleteContactForbidden{}
}

/*DeleteContactForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type DeleteContactForbidden struct {
	Payload *sf_gate_models.Error
}

func (o *DeleteContactForbidden) Error() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactForbidden  %+v", 403, o.Payload)
}

func (o *DeleteContactForbidden) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *DeleteContactForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteContactNotFound creates a DeleteContactNotFound with default headers values
func NewDeleteContactNotFound() *DeleteContactNotFound {
	return &DeleteContactNotFound{}
}

/*DeleteContactNotFound handles this case with default header values.

Resource was not found
*/
type DeleteContactNotFound struct {
	Payload *sf_gate_models.Error
}

func (o *DeleteContactNotFound) Error() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactNotFound  %+v", 404, o.Payload)
}

func (o *DeleteContactNotFound) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *DeleteContactNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteContactInternalServerError creates a DeleteContactInternalServerError with default headers values
func NewDeleteContactInternalServerError() *DeleteContactInternalServerError {
	return &DeleteContactInternalServerError{}
}

/*DeleteContactInternalServerError handles this case with default header values.

Server Internal Error
*/
type DeleteContactInternalServerError struct {
	Payload *sf_gate_models.Error
}

func (o *DeleteContactInternalServerError) Error() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactInternalServerError  %+v", 500, o.Payload)
}

func (o *DeleteContactInternalServerError) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *DeleteContactInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*DeleteContactOKBody delete contact o k body
swagger:model DeleteContactOKBody
*/
type DeleteContactOKBody struct {

	// data
	Data []*sf_gate_models.Message `json:"data"`

	// meta
	Meta *sf_gate_models.ResponseMeta `json:"meta,omitempty"`
}

// Validate validates this delete contact o k body
func (o *DeleteContactOKBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateData(formats); err != nil {
		res = append(res, err)
	}

	if err := o.validateMeta(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *DeleteContactOKBody) validateData(formats strfmt.Registry) error {

	if swag.IsZero(o.Data) { // not required
		return nil
	}

	for i := 0; i < len(o.Data); i++ {
		if swag.IsZero(o.Data[i]) { // not required
			continue
		}

		if o.Data[i] != nil {
			if err := o.Data[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("deleteContactOK" + "." + "data" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (o *DeleteContactOKBody) validateMeta(formats strfmt.Registry) error {

	if swag.IsZero(o.Meta) { // not required
		return nil
	}

	if o.Meta != nil {
		if err := o.Meta.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("deleteContactOK" + "." + "meta")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (o *DeleteContactOKBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *DeleteContactOKBody) UnmarshalBinary(b []byte) error {
	var res DeleteContactOKBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
