// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package counties

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetCountiesParams creates a new GetCountiesParams object
// with the default values initialized.
func NewGetCountiesParams() *GetCountiesParams {
	var ()
	return &GetCountiesParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetCountiesParamsWithTimeout creates a new GetCountiesParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetCountiesParamsWithTimeout(timeout time.Duration) *GetCountiesParams {
	var ()
	return &GetCountiesParams{

		timeout: timeout,
	}
}

// NewGetCountiesParamsWithContext creates a new GetCountiesParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetCountiesParamsWithContext(ctx context.Context) *GetCountiesParams {
	var ()
	return &GetCountiesParams{

		Context: ctx,
	}
}

// NewGetCountiesParamsWithHTTPClient creates a new GetCountiesParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetCountiesParamsWithHTTPClient(client *http.Client) *GetCountiesParams {
	var ()
	return &GetCountiesParams{
		HTTPClient: client,
	}
}

/*GetCountiesParams contains all the parameters to send to the API endpoint
for the get counties operation typically these are written to a http.Request
*/
type GetCountiesParams struct {

	/*CountyID
	  The County Taxnexus ID

	*/
	CountyID *string
	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64
	/*State
	  The State or Province abbreviation (2 char)

	*/
	State *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get counties params
func (o *GetCountiesParams) WithTimeout(timeout time.Duration) *GetCountiesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get counties params
func (o *GetCountiesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get counties params
func (o *GetCountiesParams) WithContext(ctx context.Context) *GetCountiesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get counties params
func (o *GetCountiesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get counties params
func (o *GetCountiesParams) WithHTTPClient(client *http.Client) *GetCountiesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get counties params
func (o *GetCountiesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCountyID adds the countyID to the get counties params
func (o *GetCountiesParams) WithCountyID(countyID *string) *GetCountiesParams {
	o.SetCountyID(countyID)
	return o
}

// SetCountyID adds the countyId to the get counties params
func (o *GetCountiesParams) SetCountyID(countyID *string) {
	o.CountyID = countyID
}

// WithLimit adds the limit to the get counties params
func (o *GetCountiesParams) WithLimit(limit *int64) *GetCountiesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get counties params
func (o *GetCountiesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get counties params
func (o *GetCountiesParams) WithOffset(offset *int64) *GetCountiesParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get counties params
func (o *GetCountiesParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithState adds the state to the get counties params
func (o *GetCountiesParams) WithState(state *string) *GetCountiesParams {
	o.SetState(state)
	return o
}

// SetState adds the state to the get counties params
func (o *GetCountiesParams) SetState(state *string) {
	o.State = state
}

// WriteToRequest writes these params to a swagger request
func (o *GetCountiesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.CountyID != nil {

		// query param countyId
		var qrCountyID string
		if o.CountyID != nil {
			qrCountyID = *o.CountyID
		}
		qCountyID := qrCountyID
		if qCountyID != "" {
			if err := r.SetQueryParam("countyId", qCountyID); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if o.State != nil {

		// query param state
		var qrState string
		if o.State != nil {
			qrState = *o.State
		}
		qState := qrState
		if qState != "" {
			if err := r.SetQueryParam("state", qState); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
