// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package databases

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/sf-gate/sf_gate_models"
)

// GetDatabasesReader is a Reader for the GetDatabases structure.
type GetDatabasesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDatabasesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDatabasesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetDatabasesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetDatabasesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetDatabasesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetDatabasesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetDatabasesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetDatabasesOK creates a GetDatabasesOK with default headers values
func NewGetDatabasesOK() *GetDatabasesOK {
	return &GetDatabasesOK{}
}

/*GetDatabasesOK handles this case with default header values.

Taxnexus Response with Database objects
*/
type GetDatabasesOK struct {
	Payload *sf_gate_models.DatabaseResponse
}

func (o *GetDatabasesOK) Error() string {
	return fmt.Sprintf("[GET /databases][%d] getDatabasesOK  %+v", 200, o.Payload)
}

func (o *GetDatabasesOK) GetPayload() *sf_gate_models.DatabaseResponse {
	return o.Payload
}

func (o *GetDatabasesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.DatabaseResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabasesUnauthorized creates a GetDatabasesUnauthorized with default headers values
func NewGetDatabasesUnauthorized() *GetDatabasesUnauthorized {
	return &GetDatabasesUnauthorized{}
}

/*GetDatabasesUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetDatabasesUnauthorized struct {
	Payload *sf_gate_models.Error
}

func (o *GetDatabasesUnauthorized) Error() string {
	return fmt.Sprintf("[GET /databases][%d] getDatabasesUnauthorized  %+v", 401, o.Payload)
}

func (o *GetDatabasesUnauthorized) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *GetDatabasesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabasesForbidden creates a GetDatabasesForbidden with default headers values
func NewGetDatabasesForbidden() *GetDatabasesForbidden {
	return &GetDatabasesForbidden{}
}

/*GetDatabasesForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetDatabasesForbidden struct {
	Payload *sf_gate_models.Error
}

func (o *GetDatabasesForbidden) Error() string {
	return fmt.Sprintf("[GET /databases][%d] getDatabasesForbidden  %+v", 403, o.Payload)
}

func (o *GetDatabasesForbidden) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *GetDatabasesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabasesNotFound creates a GetDatabasesNotFound with default headers values
func NewGetDatabasesNotFound() *GetDatabasesNotFound {
	return &GetDatabasesNotFound{}
}

/*GetDatabasesNotFound handles this case with default header values.

Resource was not found
*/
type GetDatabasesNotFound struct {
	Payload *sf_gate_models.Error
}

func (o *GetDatabasesNotFound) Error() string {
	return fmt.Sprintf("[GET /databases][%d] getDatabasesNotFound  %+v", 404, o.Payload)
}

func (o *GetDatabasesNotFound) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *GetDatabasesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabasesUnprocessableEntity creates a GetDatabasesUnprocessableEntity with default headers values
func NewGetDatabasesUnprocessableEntity() *GetDatabasesUnprocessableEntity {
	return &GetDatabasesUnprocessableEntity{}
}

/*GetDatabasesUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetDatabasesUnprocessableEntity struct {
	Payload *sf_gate_models.Error
}

func (o *GetDatabasesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /databases][%d] getDatabasesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetDatabasesUnprocessableEntity) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *GetDatabasesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabasesInternalServerError creates a GetDatabasesInternalServerError with default headers values
func NewGetDatabasesInternalServerError() *GetDatabasesInternalServerError {
	return &GetDatabasesInternalServerError{}
}

/*GetDatabasesInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetDatabasesInternalServerError struct {
	Payload *sf_gate_models.Error
}

func (o *GetDatabasesInternalServerError) Error() string {
	return fmt.Sprintf("[GET /databases][%d] getDatabasesInternalServerError  %+v", 500, o.Payload)
}

func (o *GetDatabasesInternalServerError) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *GetDatabasesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
