// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package ingests

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetIngestsParams creates a new GetIngestsParams object
// with the default values initialized.
func NewGetIngestsParams() *GetIngestsParams {
	var ()
	return &GetIngestsParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetIngestsParamsWithTimeout creates a new GetIngestsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetIngestsParamsWithTimeout(timeout time.Duration) *GetIngestsParams {
	var ()
	return &GetIngestsParams{

		timeout: timeout,
	}
}

// NewGetIngestsParamsWithContext creates a new GetIngestsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetIngestsParamsWithContext(ctx context.Context) *GetIngestsParams {
	var ()
	return &GetIngestsParams{

		Context: ctx,
	}
}

// NewGetIngestsParamsWithHTTPClient creates a new GetIngestsParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetIngestsParamsWithHTTPClient(client *http.Client) *GetIngestsParams {
	var ()
	return &GetIngestsParams{
		HTTPClient: client,
	}
}

/*GetIngestsParams contains all the parameters to send to the API endpoint
for the get ingests operation typically these are written to a http.Request
*/
type GetIngestsParams struct {

	/*AccountID
	  Taxnexus Id of the Account to be used a record retrieval

	*/
	AccountID *string
	/*AccountNumber
	  The Taxnexus Account Number of the Account to be used a record retrieval

	*/
	AccountNumber *string
	/*Active
	  Retrieve only active records?

	*/
	Active *bool
	/*CompanyID
	  Taxnexus Id of the Company to be retrieved

	*/
	CompanyID *string
	/*IngestID
	  Taxnexus Record Id of an Ingest

	*/
	IngestID *string
	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get ingests params
func (o *GetIngestsParams) WithTimeout(timeout time.Duration) *GetIngestsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get ingests params
func (o *GetIngestsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get ingests params
func (o *GetIngestsParams) WithContext(ctx context.Context) *GetIngestsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get ingests params
func (o *GetIngestsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get ingests params
func (o *GetIngestsParams) WithHTTPClient(client *http.Client) *GetIngestsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get ingests params
func (o *GetIngestsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the get ingests params
func (o *GetIngestsParams) WithAccountID(accountID *string) *GetIngestsParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the get ingests params
func (o *GetIngestsParams) SetAccountID(accountID *string) {
	o.AccountID = accountID
}

// WithAccountNumber adds the accountNumber to the get ingests params
func (o *GetIngestsParams) WithAccountNumber(accountNumber *string) *GetIngestsParams {
	o.SetAccountNumber(accountNumber)
	return o
}

// SetAccountNumber adds the accountNumber to the get ingests params
func (o *GetIngestsParams) SetAccountNumber(accountNumber *string) {
	o.AccountNumber = accountNumber
}

// WithActive adds the active to the get ingests params
func (o *GetIngestsParams) WithActive(active *bool) *GetIngestsParams {
	o.SetActive(active)
	return o
}

// SetActive adds the active to the get ingests params
func (o *GetIngestsParams) SetActive(active *bool) {
	o.Active = active
}

// WithCompanyID adds the companyID to the get ingests params
func (o *GetIngestsParams) WithCompanyID(companyID *string) *GetIngestsParams {
	o.SetCompanyID(companyID)
	return o
}

// SetCompanyID adds the companyId to the get ingests params
func (o *GetIngestsParams) SetCompanyID(companyID *string) {
	o.CompanyID = companyID
}

// WithIngestID adds the ingestID to the get ingests params
func (o *GetIngestsParams) WithIngestID(ingestID *string) *GetIngestsParams {
	o.SetIngestID(ingestID)
	return o
}

// SetIngestID adds the ingestId to the get ingests params
func (o *GetIngestsParams) SetIngestID(ingestID *string) {
	o.IngestID = ingestID
}

// WithLimit adds the limit to the get ingests params
func (o *GetIngestsParams) WithLimit(limit *int64) *GetIngestsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get ingests params
func (o *GetIngestsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get ingests params
func (o *GetIngestsParams) WithOffset(offset *int64) *GetIngestsParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get ingests params
func (o *GetIngestsParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetIngestsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccountID != nil {

		// query param accountId
		var qrAccountID string
		if o.AccountID != nil {
			qrAccountID = *o.AccountID
		}
		qAccountID := qrAccountID
		if qAccountID != "" {
			if err := r.SetQueryParam("accountId", qAccountID); err != nil {
				return err
			}
		}

	}

	if o.AccountNumber != nil {

		// query param accountNumber
		var qrAccountNumber string
		if o.AccountNumber != nil {
			qrAccountNumber = *o.AccountNumber
		}
		qAccountNumber := qrAccountNumber
		if qAccountNumber != "" {
			if err := r.SetQueryParam("accountNumber", qAccountNumber); err != nil {
				return err
			}
		}

	}

	if o.Active != nil {

		// query param active
		var qrActive bool
		if o.Active != nil {
			qrActive = *o.Active
		}
		qActive := swag.FormatBool(qrActive)
		if qActive != "" {
			if err := r.SetQueryParam("active", qActive); err != nil {
				return err
			}
		}

	}

	if o.CompanyID != nil {

		// query param companyId
		var qrCompanyID string
		if o.CompanyID != nil {
			qrCompanyID = *o.CompanyID
		}
		qCompanyID := qrCompanyID
		if qCompanyID != "" {
			if err := r.SetQueryParam("companyId", qCompanyID); err != nil {
				return err
			}
		}

	}

	if o.IngestID != nil {

		// query param ingestId
		var qrIngestID string
		if o.IngestID != nil {
			qrIngestID = *o.IngestID
		}
		qIngestID := qrIngestID
		if qIngestID != "" {
			if err := r.SetQueryParam("ingestId", qIngestID); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
