// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package ingests

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/sf-gate/sf_gate_models"
)

// PutIngestsReader is a Reader for the PutIngests structure.
type PutIngestsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutIngestsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutIngestsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutIngestsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutIngestsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutIngestsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutIngestsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutIngestsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPutIngestsOK creates a PutIngestsOK with default headers values
func NewPutIngestsOK() *PutIngestsOK {
	return &PutIngestsOK{}
}

/*PutIngestsOK handles this case with default header values.

Taxnexus Response with Ingest objects
*/
type PutIngestsOK struct {
	Payload *sf_gate_models.IngestResponse
}

func (o *PutIngestsOK) Error() string {
	return fmt.Sprintf("[PUT /ingests][%d] putIngestsOK  %+v", 200, o.Payload)
}

func (o *PutIngestsOK) GetPayload() *sf_gate_models.IngestResponse {
	return o.Payload
}

func (o *PutIngestsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.IngestResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutIngestsUnauthorized creates a PutIngestsUnauthorized with default headers values
func NewPutIngestsUnauthorized() *PutIngestsUnauthorized {
	return &PutIngestsUnauthorized{}
}

/*PutIngestsUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PutIngestsUnauthorized struct {
	Payload *sf_gate_models.Error
}

func (o *PutIngestsUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /ingests][%d] putIngestsUnauthorized  %+v", 401, o.Payload)
}

func (o *PutIngestsUnauthorized) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutIngestsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutIngestsForbidden creates a PutIngestsForbidden with default headers values
func NewPutIngestsForbidden() *PutIngestsForbidden {
	return &PutIngestsForbidden{}
}

/*PutIngestsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PutIngestsForbidden struct {
	Payload *sf_gate_models.Error
}

func (o *PutIngestsForbidden) Error() string {
	return fmt.Sprintf("[PUT /ingests][%d] putIngestsForbidden  %+v", 403, o.Payload)
}

func (o *PutIngestsForbidden) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutIngestsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutIngestsNotFound creates a PutIngestsNotFound with default headers values
func NewPutIngestsNotFound() *PutIngestsNotFound {
	return &PutIngestsNotFound{}
}

/*PutIngestsNotFound handles this case with default header values.

Resource was not found
*/
type PutIngestsNotFound struct {
	Payload *sf_gate_models.Error
}

func (o *PutIngestsNotFound) Error() string {
	return fmt.Sprintf("[PUT /ingests][%d] putIngestsNotFound  %+v", 404, o.Payload)
}

func (o *PutIngestsNotFound) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutIngestsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutIngestsUnprocessableEntity creates a PutIngestsUnprocessableEntity with default headers values
func NewPutIngestsUnprocessableEntity() *PutIngestsUnprocessableEntity {
	return &PutIngestsUnprocessableEntity{}
}

/*PutIngestsUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutIngestsUnprocessableEntity struct {
	Payload *sf_gate_models.Error
}

func (o *PutIngestsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /ingests][%d] putIngestsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutIngestsUnprocessableEntity) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutIngestsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutIngestsInternalServerError creates a PutIngestsInternalServerError with default headers values
func NewPutIngestsInternalServerError() *PutIngestsInternalServerError {
	return &PutIngestsInternalServerError{}
}

/*PutIngestsInternalServerError handles this case with default header values.

Server Internal Error
*/
type PutIngestsInternalServerError struct {
	Payload *sf_gate_models.Error
}

func (o *PutIngestsInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /ingests][%d] putIngestsInternalServerError  %+v", 500, o.Payload)
}

func (o *PutIngestsInternalServerError) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutIngestsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
