// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package jobs

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetJobsParams creates a new GetJobsParams object
// with the default values initialized.
func NewGetJobsParams() *GetJobsParams {
	var ()
	return &GetJobsParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetJobsParamsWithTimeout creates a new GetJobsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetJobsParamsWithTimeout(timeout time.Duration) *GetJobsParams {
	var ()
	return &GetJobsParams{

		timeout: timeout,
	}
}

// NewGetJobsParamsWithContext creates a new GetJobsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetJobsParamsWithContext(ctx context.Context) *GetJobsParams {
	var ()
	return &GetJobsParams{

		Context: ctx,
	}
}

// NewGetJobsParamsWithHTTPClient creates a new GetJobsParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetJobsParamsWithHTTPClient(client *http.Client) *GetJobsParams {
	var ()
	return &GetJobsParams{
		HTTPClient: client,
	}
}

/*GetJobsParams contains all the parameters to send to the API endpoint
for the get jobs operation typically these are written to a http.Request
*/
type GetJobsParams struct {

	/*AccountID
	  Taxnexus Id of the Account to be used a record retrieval

	*/
	AccountID *string
	/*AccountNumber
	  The Taxnexus Account Number of the Account to be used a record retrieval

	*/
	AccountNumber *string
	/*CompanyID
	  Taxnexus Id of the Company to be retrieved

	*/
	CompanyID *string
	/*JobID
	  Taxnexus Record Id of a Job record

	*/
	JobID *string
	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get jobs params
func (o *GetJobsParams) WithTimeout(timeout time.Duration) *GetJobsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get jobs params
func (o *GetJobsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get jobs params
func (o *GetJobsParams) WithContext(ctx context.Context) *GetJobsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get jobs params
func (o *GetJobsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get jobs params
func (o *GetJobsParams) WithHTTPClient(client *http.Client) *GetJobsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get jobs params
func (o *GetJobsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the get jobs params
func (o *GetJobsParams) WithAccountID(accountID *string) *GetJobsParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the get jobs params
func (o *GetJobsParams) SetAccountID(accountID *string) {
	o.AccountID = accountID
}

// WithAccountNumber adds the accountNumber to the get jobs params
func (o *GetJobsParams) WithAccountNumber(accountNumber *string) *GetJobsParams {
	o.SetAccountNumber(accountNumber)
	return o
}

// SetAccountNumber adds the accountNumber to the get jobs params
func (o *GetJobsParams) SetAccountNumber(accountNumber *string) {
	o.AccountNumber = accountNumber
}

// WithCompanyID adds the companyID to the get jobs params
func (o *GetJobsParams) WithCompanyID(companyID *string) *GetJobsParams {
	o.SetCompanyID(companyID)
	return o
}

// SetCompanyID adds the companyId to the get jobs params
func (o *GetJobsParams) SetCompanyID(companyID *string) {
	o.CompanyID = companyID
}

// WithJobID adds the jobID to the get jobs params
func (o *GetJobsParams) WithJobID(jobID *string) *GetJobsParams {
	o.SetJobID(jobID)
	return o
}

// SetJobID adds the jobId to the get jobs params
func (o *GetJobsParams) SetJobID(jobID *string) {
	o.JobID = jobID
}

// WithLimit adds the limit to the get jobs params
func (o *GetJobsParams) WithLimit(limit *int64) *GetJobsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get jobs params
func (o *GetJobsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get jobs params
func (o *GetJobsParams) WithOffset(offset *int64) *GetJobsParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get jobs params
func (o *GetJobsParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetJobsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccountID != nil {

		// query param accountId
		var qrAccountID string
		if o.AccountID != nil {
			qrAccountID = *o.AccountID
		}
		qAccountID := qrAccountID
		if qAccountID != "" {
			if err := r.SetQueryParam("accountId", qAccountID); err != nil {
				return err
			}
		}

	}

	if o.AccountNumber != nil {

		// query param accountNumber
		var qrAccountNumber string
		if o.AccountNumber != nil {
			qrAccountNumber = *o.AccountNumber
		}
		qAccountNumber := qrAccountNumber
		if qAccountNumber != "" {
			if err := r.SetQueryParam("accountNumber", qAccountNumber); err != nil {
				return err
			}
		}

	}

	if o.CompanyID != nil {

		// query param companyId
		var qrCompanyID string
		if o.CompanyID != nil {
			qrCompanyID = *o.CompanyID
		}
		qCompanyID := qrCompanyID
		if qCompanyID != "" {
			if err := r.SetQueryParam("companyId", qCompanyID); err != nil {
				return err
			}
		}

	}

	if o.JobID != nil {

		// query param jobId
		var qrJobID string
		if o.JobID != nil {
			qrJobID = *o.JobID
		}
		qJobID := qrJobID
		if qJobID != "" {
			if err := r.SetQueryParam("jobId", qJobID); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
