// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package licenses

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetLicensesParams creates a new GetLicensesParams object
// with the default values initialized.
func NewGetLicensesParams() *GetLicensesParams {
	var ()
	return &GetLicensesParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetLicensesParamsWithTimeout creates a new GetLicensesParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetLicensesParamsWithTimeout(timeout time.Duration) *GetLicensesParams {
	var ()
	return &GetLicensesParams{

		timeout: timeout,
	}
}

// NewGetLicensesParamsWithContext creates a new GetLicensesParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetLicensesParamsWithContext(ctx context.Context) *GetLicensesParams {
	var ()
	return &GetLicensesParams{

		Context: ctx,
	}
}

// NewGetLicensesParamsWithHTTPClient creates a new GetLicensesParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetLicensesParamsWithHTTPClient(client *http.Client) *GetLicensesParams {
	var ()
	return &GetLicensesParams{
		HTTPClient: client,
	}
}

/*GetLicensesParams contains all the parameters to send to the API endpoint
for the get licenses operation typically these are written to a http.Request
*/
type GetLicensesParams struct {

	/*AccountID
	  Taxnexus Id of the Account to be used a record retrieval

	*/
	AccountID *string
	/*Active
	  Retrieve only active records?

	*/
	Active *bool
	/*CompanyID
	  Taxnexus Id of the Company to be retrieved

	*/
	CompanyID *string
	/*LicenseID
	  Taxnexus Id of the License to be retrieved

	*/
	LicenseID *string
	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get licenses params
func (o *GetLicensesParams) WithTimeout(timeout time.Duration) *GetLicensesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get licenses params
func (o *GetLicensesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get licenses params
func (o *GetLicensesParams) WithContext(ctx context.Context) *GetLicensesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get licenses params
func (o *GetLicensesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get licenses params
func (o *GetLicensesParams) WithHTTPClient(client *http.Client) *GetLicensesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get licenses params
func (o *GetLicensesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the get licenses params
func (o *GetLicensesParams) WithAccountID(accountID *string) *GetLicensesParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the get licenses params
func (o *GetLicensesParams) SetAccountID(accountID *string) {
	o.AccountID = accountID
}

// WithActive adds the active to the get licenses params
func (o *GetLicensesParams) WithActive(active *bool) *GetLicensesParams {
	o.SetActive(active)
	return o
}

// SetActive adds the active to the get licenses params
func (o *GetLicensesParams) SetActive(active *bool) {
	o.Active = active
}

// WithCompanyID adds the companyID to the get licenses params
func (o *GetLicensesParams) WithCompanyID(companyID *string) *GetLicensesParams {
	o.SetCompanyID(companyID)
	return o
}

// SetCompanyID adds the companyId to the get licenses params
func (o *GetLicensesParams) SetCompanyID(companyID *string) {
	o.CompanyID = companyID
}

// WithLicenseID adds the licenseID to the get licenses params
func (o *GetLicensesParams) WithLicenseID(licenseID *string) *GetLicensesParams {
	o.SetLicenseID(licenseID)
	return o
}

// SetLicenseID adds the licenseId to the get licenses params
func (o *GetLicensesParams) SetLicenseID(licenseID *string) {
	o.LicenseID = licenseID
}

// WithLimit adds the limit to the get licenses params
func (o *GetLicensesParams) WithLimit(limit *int64) *GetLicensesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get licenses params
func (o *GetLicensesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get licenses params
func (o *GetLicensesParams) WithOffset(offset *int64) *GetLicensesParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get licenses params
func (o *GetLicensesParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetLicensesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccountID != nil {

		// query param accountId
		var qrAccountID string
		if o.AccountID != nil {
			qrAccountID = *o.AccountID
		}
		qAccountID := qrAccountID
		if qAccountID != "" {
			if err := r.SetQueryParam("accountId", qAccountID); err != nil {
				return err
			}
		}

	}

	if o.Active != nil {

		// query param active
		var qrActive bool
		if o.Active != nil {
			qrActive = *o.Active
		}
		qActive := swag.FormatBool(qrActive)
		if qActive != "" {
			if err := r.SetQueryParam("active", qActive); err != nil {
				return err
			}
		}

	}

	if o.CompanyID != nil {

		// query param companyId
		var qrCompanyID string
		if o.CompanyID != nil {
			qrCompanyID = *o.CompanyID
		}
		qCompanyID := qrCompanyID
		if qCompanyID != "" {
			if err := r.SetQueryParam("companyId", qCompanyID); err != nil {
				return err
			}
		}

	}

	if o.LicenseID != nil {

		// query param licenseId
		var qrLicenseID string
		if o.LicenseID != nil {
			qrLicenseID = *o.LicenseID
		}
		qLicenseID := qrLicenseID
		if qLicenseID != "" {
			if err := r.SetQueryParam("licenseId", qLicenseID); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
