// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package orders

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetOrdersParams creates a new GetOrdersParams object
// with the default values initialized.
func NewGetOrdersParams() *GetOrdersParams {
	var ()
	return &GetOrdersParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetOrdersParamsWithTimeout creates a new GetOrdersParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetOrdersParamsWithTimeout(timeout time.Duration) *GetOrdersParams {
	var ()
	return &GetOrdersParams{

		timeout: timeout,
	}
}

// NewGetOrdersParamsWithContext creates a new GetOrdersParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetOrdersParamsWithContext(ctx context.Context) *GetOrdersParams {
	var ()
	return &GetOrdersParams{

		Context: ctx,
	}
}

// NewGetOrdersParamsWithHTTPClient creates a new GetOrdersParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetOrdersParamsWithHTTPClient(client *http.Client) *GetOrdersParams {
	var ()
	return &GetOrdersParams{
		HTTPClient: client,
	}
}

/*GetOrdersParams contains all the parameters to send to the API endpoint
for the get orders operation typically these are written to a http.Request
*/
type GetOrdersParams struct {

	/*AccountID
	  Taxnexus Id of the Account to be used a record retrieval

	*/
	AccountID *string
	/*AccountNumber
	  The Taxnexus Account Number of the Account to be used a record retrieval

	*/
	AccountNumber *string
	/*Active
	  Retrieve only active records?

	*/
	Active *bool
	/*CompanyID
	  Taxnexus Id of the Company to be retrieved

	*/
	CompanyID *string
	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64
	/*OrderID
	  Taxnexus Id of the Company to be retrieved

	*/
	OrderID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get orders params
func (o *GetOrdersParams) WithTimeout(timeout time.Duration) *GetOrdersParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get orders params
func (o *GetOrdersParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get orders params
func (o *GetOrdersParams) WithContext(ctx context.Context) *GetOrdersParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get orders params
func (o *GetOrdersParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get orders params
func (o *GetOrdersParams) WithHTTPClient(client *http.Client) *GetOrdersParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get orders params
func (o *GetOrdersParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the get orders params
func (o *GetOrdersParams) WithAccountID(accountID *string) *GetOrdersParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the get orders params
func (o *GetOrdersParams) SetAccountID(accountID *string) {
	o.AccountID = accountID
}

// WithAccountNumber adds the accountNumber to the get orders params
func (o *GetOrdersParams) WithAccountNumber(accountNumber *string) *GetOrdersParams {
	o.SetAccountNumber(accountNumber)
	return o
}

// SetAccountNumber adds the accountNumber to the get orders params
func (o *GetOrdersParams) SetAccountNumber(accountNumber *string) {
	o.AccountNumber = accountNumber
}

// WithActive adds the active to the get orders params
func (o *GetOrdersParams) WithActive(active *bool) *GetOrdersParams {
	o.SetActive(active)
	return o
}

// SetActive adds the active to the get orders params
func (o *GetOrdersParams) SetActive(active *bool) {
	o.Active = active
}

// WithCompanyID adds the companyID to the get orders params
func (o *GetOrdersParams) WithCompanyID(companyID *string) *GetOrdersParams {
	o.SetCompanyID(companyID)
	return o
}

// SetCompanyID adds the companyId to the get orders params
func (o *GetOrdersParams) SetCompanyID(companyID *string) {
	o.CompanyID = companyID
}

// WithLimit adds the limit to the get orders params
func (o *GetOrdersParams) WithLimit(limit *int64) *GetOrdersParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get orders params
func (o *GetOrdersParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get orders params
func (o *GetOrdersParams) WithOffset(offset *int64) *GetOrdersParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get orders params
func (o *GetOrdersParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithOrderID adds the orderID to the get orders params
func (o *GetOrdersParams) WithOrderID(orderID *string) *GetOrdersParams {
	o.SetOrderID(orderID)
	return o
}

// SetOrderID adds the orderId to the get orders params
func (o *GetOrdersParams) SetOrderID(orderID *string) {
	o.OrderID = orderID
}

// WriteToRequest writes these params to a swagger request
func (o *GetOrdersParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccountID != nil {

		// query param accountId
		var qrAccountID string
		if o.AccountID != nil {
			qrAccountID = *o.AccountID
		}
		qAccountID := qrAccountID
		if qAccountID != "" {
			if err := r.SetQueryParam("accountId", qAccountID); err != nil {
				return err
			}
		}

	}

	if o.AccountNumber != nil {

		// query param accountNumber
		var qrAccountNumber string
		if o.AccountNumber != nil {
			qrAccountNumber = *o.AccountNumber
		}
		qAccountNumber := qrAccountNumber
		if qAccountNumber != "" {
			if err := r.SetQueryParam("accountNumber", qAccountNumber); err != nil {
				return err
			}
		}

	}

	if o.Active != nil {

		// query param active
		var qrActive bool
		if o.Active != nil {
			qrActive = *o.Active
		}
		qActive := swag.FormatBool(qrActive)
		if qActive != "" {
			if err := r.SetQueryParam("active", qActive); err != nil {
				return err
			}
		}

	}

	if o.CompanyID != nil {

		// query param companyId
		var qrCompanyID string
		if o.CompanyID != nil {
			qrCompanyID = *o.CompanyID
		}
		qCompanyID := qrCompanyID
		if qCompanyID != "" {
			if err := r.SetQueryParam("companyId", qCompanyID); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if o.OrderID != nil {

		// query param orderId
		var qrOrderID string
		if o.OrderID != nil {
			qrOrderID = *o.OrderID
		}
		qOrderID := qrOrderID
		if qOrderID != "" {
			if err := r.SetQueryParam("orderId", qOrderID); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
