// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package periods

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetPeriodsParams creates a new GetPeriodsParams object
// with the default values initialized.
func NewGetPeriodsParams() *GetPeriodsParams {
	var ()
	return &GetPeriodsParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetPeriodsParamsWithTimeout creates a new GetPeriodsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetPeriodsParamsWithTimeout(timeout time.Duration) *GetPeriodsParams {
	var ()
	return &GetPeriodsParams{

		timeout: timeout,
	}
}

// NewGetPeriodsParamsWithContext creates a new GetPeriodsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetPeriodsParamsWithContext(ctx context.Context) *GetPeriodsParams {
	var ()
	return &GetPeriodsParams{

		Context: ctx,
	}
}

// NewGetPeriodsParamsWithHTTPClient creates a new GetPeriodsParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetPeriodsParamsWithHTTPClient(client *http.Client) *GetPeriodsParams {
	var ()
	return &GetPeriodsParams{
		HTTPClient: client,
	}
}

/*GetPeriodsParams contains all the parameters to send to the API endpoint
for the get periods operation typically these are written to a http.Request
*/
type GetPeriodsParams struct {

	/*AccountID
	  Taxnexus Id of the Account to be used a record retrieval

	*/
	AccountID *string
	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64
	/*PeriodID
	  Taxnexus Id of the Period to be used a record retrieval

	*/
	PeriodID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get periods params
func (o *GetPeriodsParams) WithTimeout(timeout time.Duration) *GetPeriodsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get periods params
func (o *GetPeriodsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get periods params
func (o *GetPeriodsParams) WithContext(ctx context.Context) *GetPeriodsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get periods params
func (o *GetPeriodsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get periods params
func (o *GetPeriodsParams) WithHTTPClient(client *http.Client) *GetPeriodsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get periods params
func (o *GetPeriodsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the get periods params
func (o *GetPeriodsParams) WithAccountID(accountID *string) *GetPeriodsParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the get periods params
func (o *GetPeriodsParams) SetAccountID(accountID *string) {
	o.AccountID = accountID
}

// WithLimit adds the limit to the get periods params
func (o *GetPeriodsParams) WithLimit(limit *int64) *GetPeriodsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get periods params
func (o *GetPeriodsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get periods params
func (o *GetPeriodsParams) WithOffset(offset *int64) *GetPeriodsParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get periods params
func (o *GetPeriodsParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithPeriodID adds the periodID to the get periods params
func (o *GetPeriodsParams) WithPeriodID(periodID *string) *GetPeriodsParams {
	o.SetPeriodID(periodID)
	return o
}

// SetPeriodID adds the periodId to the get periods params
func (o *GetPeriodsParams) SetPeriodID(periodID *string) {
	o.PeriodID = periodID
}

// WriteToRequest writes these params to a swagger request
func (o *GetPeriodsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccountID != nil {

		// query param accountId
		var qrAccountID string
		if o.AccountID != nil {
			qrAccountID = *o.AccountID
		}
		qAccountID := qrAccountID
		if qAccountID != "" {
			if err := r.SetQueryParam("accountId", qAccountID); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if o.PeriodID != nil {

		// query param periodId
		var qrPeriodID string
		if o.PeriodID != nil {
			qrPeriodID = *o.PeriodID
		}
		qPeriodID := qrPeriodID
		if qPeriodID != "" {
			if err := r.SetQueryParam("periodId", qPeriodID); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
