// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package purchase_orders

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new purchase orders API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for purchase orders API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	GetPos(params *GetPosParams, authInfo runtime.ClientAuthInfoWriter) (*GetPosOK, error)

	PostPos(params *PostPosParams, authInfo runtime.ClientAuthInfoWriter) (*PostPosOK, error)

	PutPos(params *PutPosParams, authInfo runtime.ClientAuthInfoWriter) (*PutPosOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetPos gets a list of purchase orders

  Return a list of available Purchase Orders
*/
func (a *Client) GetPos(params *GetPosParams, authInfo runtime.ClientAuthInfoWriter) (*GetPosOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetPosParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getPos",
		Method:             "GET",
		PathPattern:        "/pos",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetPosReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetPosOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getPos: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostPos creates a new purchase order

  Create New Purchase Order
*/
func (a *Client) PostPos(params *PostPosParams, authInfo runtime.ClientAuthInfoWriter) (*PostPosOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostPosParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postPos",
		Method:             "POST",
		PathPattern:        "/pos",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostPosReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostPosOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postPos: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PutPos upserts a list of purchase order

  Upsert a list of Purchase Order
*/
func (a *Client) PutPos(params *PutPosParams, authInfo runtime.ClientAuthInfoWriter) (*PutPosOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutPosParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "putPos",
		Method:             "PUT",
		PathPattern:        "/pos",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutPosReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutPosOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putPos: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
