// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package quotes

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/sf-gate/sf_gate_models"
)

// PostQuotesReader is a Reader for the PostQuotes structure.
type PostQuotesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostQuotesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostQuotesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostQuotesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostQuotesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostQuotesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostQuotesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostQuotesOK creates a PostQuotesOK with default headers values
func NewPostQuotesOK() *PostQuotesOK {
	return &PostQuotesOK{}
}

/*PostQuotesOK handles this case with default header values.

An array of Quote objects
*/
type PostQuotesOK struct {
	Payload *sf_gate_models.QuoteResponse
}

func (o *PostQuotesOK) Error() string {
	return fmt.Sprintf("[POST /quotes][%d] postQuotesOK  %+v", 200, o.Payload)
}

func (o *PostQuotesOK) GetPayload() *sf_gate_models.QuoteResponse {
	return o.Payload
}

func (o *PostQuotesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.QuoteResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostQuotesUnauthorized creates a PostQuotesUnauthorized with default headers values
func NewPostQuotesUnauthorized() *PostQuotesUnauthorized {
	return &PostQuotesUnauthorized{}
}

/*PostQuotesUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PostQuotesUnauthorized struct {
	Payload *sf_gate_models.Error
}

func (o *PostQuotesUnauthorized) Error() string {
	return fmt.Sprintf("[POST /quotes][%d] postQuotesUnauthorized  %+v", 401, o.Payload)
}

func (o *PostQuotesUnauthorized) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PostQuotesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostQuotesForbidden creates a PostQuotesForbidden with default headers values
func NewPostQuotesForbidden() *PostQuotesForbidden {
	return &PostQuotesForbidden{}
}

/*PostQuotesForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostQuotesForbidden struct {
	Payload *sf_gate_models.Error
}

func (o *PostQuotesForbidden) Error() string {
	return fmt.Sprintf("[POST /quotes][%d] postQuotesForbidden  %+v", 403, o.Payload)
}

func (o *PostQuotesForbidden) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PostQuotesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostQuotesNotFound creates a PostQuotesNotFound with default headers values
func NewPostQuotesNotFound() *PostQuotesNotFound {
	return &PostQuotesNotFound{}
}

/*PostQuotesNotFound handles this case with default header values.

Resource was not found
*/
type PostQuotesNotFound struct {
	Payload *sf_gate_models.Error
}

func (o *PostQuotesNotFound) Error() string {
	return fmt.Sprintf("[POST /quotes][%d] postQuotesNotFound  %+v", 404, o.Payload)
}

func (o *PostQuotesNotFound) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PostQuotesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostQuotesInternalServerError creates a PostQuotesInternalServerError with default headers values
func NewPostQuotesInternalServerError() *PostQuotesInternalServerError {
	return &PostQuotesInternalServerError{}
}

/*PostQuotesInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostQuotesInternalServerError struct {
	Payload *sf_gate_models.Error
}

func (o *PostQuotesInternalServerError) Error() string {
	return fmt.Sprintf("[POST /quotes][%d] postQuotesInternalServerError  %+v", 500, o.Payload)
}

func (o *PostQuotesInternalServerError) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PostQuotesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
