// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/sf-gate/sf_gate_models"
)

// GetServicesReader is a Reader for the GetServices structure.
type GetServicesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetServicesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetServicesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetServicesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetServicesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetServicesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetServicesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetServicesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetServicesOK creates a GetServicesOK with default headers values
func NewGetServicesOK() *GetServicesOK {
	return &GetServicesOK{}
}

/*GetServicesOK handles this case with default header values.

Taxnexus Response with Service objects
*/
type GetServicesOK struct {
	Payload *sf_gate_models.ServiceResponse
}

func (o *GetServicesOK) Error() string {
	return fmt.Sprintf("[GET /services][%d] getServicesOK  %+v", 200, o.Payload)
}

func (o *GetServicesOK) GetPayload() *sf_gate_models.ServiceResponse {
	return o.Payload
}

func (o *GetServicesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.ServiceResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetServicesUnauthorized creates a GetServicesUnauthorized with default headers values
func NewGetServicesUnauthorized() *GetServicesUnauthorized {
	return &GetServicesUnauthorized{}
}

/*GetServicesUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetServicesUnauthorized struct {
	Payload *sf_gate_models.Error
}

func (o *GetServicesUnauthorized) Error() string {
	return fmt.Sprintf("[GET /services][%d] getServicesUnauthorized  %+v", 401, o.Payload)
}

func (o *GetServicesUnauthorized) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *GetServicesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetServicesForbidden creates a GetServicesForbidden with default headers values
func NewGetServicesForbidden() *GetServicesForbidden {
	return &GetServicesForbidden{}
}

/*GetServicesForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetServicesForbidden struct {
	Payload *sf_gate_models.Error
}

func (o *GetServicesForbidden) Error() string {
	return fmt.Sprintf("[GET /services][%d] getServicesForbidden  %+v", 403, o.Payload)
}

func (o *GetServicesForbidden) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *GetServicesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetServicesNotFound creates a GetServicesNotFound with default headers values
func NewGetServicesNotFound() *GetServicesNotFound {
	return &GetServicesNotFound{}
}

/*GetServicesNotFound handles this case with default header values.

Resource was not found
*/
type GetServicesNotFound struct {
	Payload *sf_gate_models.Error
}

func (o *GetServicesNotFound) Error() string {
	return fmt.Sprintf("[GET /services][%d] getServicesNotFound  %+v", 404, o.Payload)
}

func (o *GetServicesNotFound) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *GetServicesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetServicesUnprocessableEntity creates a GetServicesUnprocessableEntity with default headers values
func NewGetServicesUnprocessableEntity() *GetServicesUnprocessableEntity {
	return &GetServicesUnprocessableEntity{}
}

/*GetServicesUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetServicesUnprocessableEntity struct {
	Payload *sf_gate_models.Error
}

func (o *GetServicesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /services][%d] getServicesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetServicesUnprocessableEntity) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *GetServicesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetServicesInternalServerError creates a GetServicesInternalServerError with default headers values
func NewGetServicesInternalServerError() *GetServicesInternalServerError {
	return &GetServicesInternalServerError{}
}

/*GetServicesInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetServicesInternalServerError struct {
	Payload *sf_gate_models.Error
}

func (o *GetServicesInternalServerError) Error() string {
	return fmt.Sprintf("[GET /services][%d] getServicesInternalServerError  %+v", 500, o.Payload)
}

func (o *GetServicesInternalServerError) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *GetServicesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
