// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package statements

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetStatementsParams creates a new GetStatementsParams object
// with the default values initialized.
func NewGetStatementsParams() *GetStatementsParams {
	var ()
	return &GetStatementsParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetStatementsParamsWithTimeout creates a new GetStatementsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetStatementsParamsWithTimeout(timeout time.Duration) *GetStatementsParams {
	var ()
	return &GetStatementsParams{

		timeout: timeout,
	}
}

// NewGetStatementsParamsWithContext creates a new GetStatementsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetStatementsParamsWithContext(ctx context.Context) *GetStatementsParams {
	var ()
	return &GetStatementsParams{

		Context: ctx,
	}
}

// NewGetStatementsParamsWithHTTPClient creates a new GetStatementsParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetStatementsParamsWithHTTPClient(client *http.Client) *GetStatementsParams {
	var ()
	return &GetStatementsParams{
		HTTPClient: client,
	}
}

/*GetStatementsParams contains all the parameters to send to the API endpoint
for the get statements operation typically these are written to a http.Request
*/
type GetStatementsParams struct {

	/*AccountID
	  Taxnexus Id of the Account to be used a record retrieval

	*/
	AccountID *string
	/*AccountNumber
	  The Taxnexus Account Number of the Account to be used a record retrieval

	*/
	AccountNumber *string
	/*CompanyID
	  Taxnexus Id of the Company to be retrieved

	*/
	CompanyID *string
	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64
	/*StatementID
	  Taxnexus Id of the Company to be retrieved

	*/
	StatementID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get statements params
func (o *GetStatementsParams) WithTimeout(timeout time.Duration) *GetStatementsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get statements params
func (o *GetStatementsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get statements params
func (o *GetStatementsParams) WithContext(ctx context.Context) *GetStatementsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get statements params
func (o *GetStatementsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get statements params
func (o *GetStatementsParams) WithHTTPClient(client *http.Client) *GetStatementsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get statements params
func (o *GetStatementsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the get statements params
func (o *GetStatementsParams) WithAccountID(accountID *string) *GetStatementsParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the get statements params
func (o *GetStatementsParams) SetAccountID(accountID *string) {
	o.AccountID = accountID
}

// WithAccountNumber adds the accountNumber to the get statements params
func (o *GetStatementsParams) WithAccountNumber(accountNumber *string) *GetStatementsParams {
	o.SetAccountNumber(accountNumber)
	return o
}

// SetAccountNumber adds the accountNumber to the get statements params
func (o *GetStatementsParams) SetAccountNumber(accountNumber *string) {
	o.AccountNumber = accountNumber
}

// WithCompanyID adds the companyID to the get statements params
func (o *GetStatementsParams) WithCompanyID(companyID *string) *GetStatementsParams {
	o.SetCompanyID(companyID)
	return o
}

// SetCompanyID adds the companyId to the get statements params
func (o *GetStatementsParams) SetCompanyID(companyID *string) {
	o.CompanyID = companyID
}

// WithLimit adds the limit to the get statements params
func (o *GetStatementsParams) WithLimit(limit *int64) *GetStatementsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get statements params
func (o *GetStatementsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get statements params
func (o *GetStatementsParams) WithOffset(offset *int64) *GetStatementsParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get statements params
func (o *GetStatementsParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithStatementID adds the statementID to the get statements params
func (o *GetStatementsParams) WithStatementID(statementID *string) *GetStatementsParams {
	o.SetStatementID(statementID)
	return o
}

// SetStatementID adds the statementId to the get statements params
func (o *GetStatementsParams) SetStatementID(statementID *string) {
	o.StatementID = statementID
}

// WriteToRequest writes these params to a swagger request
func (o *GetStatementsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccountID != nil {

		// query param accountId
		var qrAccountID string
		if o.AccountID != nil {
			qrAccountID = *o.AccountID
		}
		qAccountID := qrAccountID
		if qAccountID != "" {
			if err := r.SetQueryParam("accountId", qAccountID); err != nil {
				return err
			}
		}

	}

	if o.AccountNumber != nil {

		// query param accountNumber
		var qrAccountNumber string
		if o.AccountNumber != nil {
			qrAccountNumber = *o.AccountNumber
		}
		qAccountNumber := qrAccountNumber
		if qAccountNumber != "" {
			if err := r.SetQueryParam("accountNumber", qAccountNumber); err != nil {
				return err
			}
		}

	}

	if o.CompanyID != nil {

		// query param companyId
		var qrCompanyID string
		if o.CompanyID != nil {
			qrCompanyID = *o.CompanyID
		}
		qCompanyID := qrCompanyID
		if qCompanyID != "" {
			if err := r.SetQueryParam("companyId", qCompanyID); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if o.StatementID != nil {

		// query param statementId
		var qrStatementID string
		if o.StatementID != nil {
			qrStatementID = *o.StatementID
		}
		qStatementID := qrStatementID
		if qStatementID != "" {
			if err := r.SetQueryParam("statementId", qStatementID); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
