// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package statements

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/sf-gate/sf_gate_models"
)

// GetStatementsReader is a Reader for the GetStatements structure.
type GetStatementsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetStatementsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetStatementsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetStatementsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetStatementsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetStatementsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetStatementsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetStatementsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetStatementsOK creates a GetStatementsOK with default headers values
func NewGetStatementsOK() *GetStatementsOK {
	return &GetStatementsOK{}
}

/*GetStatementsOK handles this case with default header values.

An array of Statement objects
*/
type GetStatementsOK struct {
	Payload *sf_gate_models.StatementResponse
}

func (o *GetStatementsOK) Error() string {
	return fmt.Sprintf("[GET /statements][%d] getStatementsOK  %+v", 200, o.Payload)
}

func (o *GetStatementsOK) GetPayload() *sf_gate_models.StatementResponse {
	return o.Payload
}

func (o *GetStatementsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.StatementResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetStatementsUnauthorized creates a GetStatementsUnauthorized with default headers values
func NewGetStatementsUnauthorized() *GetStatementsUnauthorized {
	return &GetStatementsUnauthorized{}
}

/*GetStatementsUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetStatementsUnauthorized struct {
	Payload *sf_gate_models.Error
}

func (o *GetStatementsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /statements][%d] getStatementsUnauthorized  %+v", 401, o.Payload)
}

func (o *GetStatementsUnauthorized) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *GetStatementsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetStatementsForbidden creates a GetStatementsForbidden with default headers values
func NewGetStatementsForbidden() *GetStatementsForbidden {
	return &GetStatementsForbidden{}
}

/*GetStatementsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetStatementsForbidden struct {
	Payload *sf_gate_models.Error
}

func (o *GetStatementsForbidden) Error() string {
	return fmt.Sprintf("[GET /statements][%d] getStatementsForbidden  %+v", 403, o.Payload)
}

func (o *GetStatementsForbidden) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *GetStatementsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetStatementsNotFound creates a GetStatementsNotFound with default headers values
func NewGetStatementsNotFound() *GetStatementsNotFound {
	return &GetStatementsNotFound{}
}

/*GetStatementsNotFound handles this case with default header values.

Resource was not found
*/
type GetStatementsNotFound struct {
	Payload *sf_gate_models.Error
}

func (o *GetStatementsNotFound) Error() string {
	return fmt.Sprintf("[GET /statements][%d] getStatementsNotFound  %+v", 404, o.Payload)
}

func (o *GetStatementsNotFound) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *GetStatementsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetStatementsUnprocessableEntity creates a GetStatementsUnprocessableEntity with default headers values
func NewGetStatementsUnprocessableEntity() *GetStatementsUnprocessableEntity {
	return &GetStatementsUnprocessableEntity{}
}

/*GetStatementsUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetStatementsUnprocessableEntity struct {
	Payload *sf_gate_models.Error
}

func (o *GetStatementsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /statements][%d] getStatementsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetStatementsUnprocessableEntity) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *GetStatementsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetStatementsInternalServerError creates a GetStatementsInternalServerError with default headers values
func NewGetStatementsInternalServerError() *GetStatementsInternalServerError {
	return &GetStatementsInternalServerError{}
}

/*GetStatementsInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetStatementsInternalServerError struct {
	Payload *sf_gate_models.Error
}

func (o *GetStatementsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /statements][%d] getStatementsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetStatementsInternalServerError) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *GetStatementsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
