// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package statements

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new statements API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for statements API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	GetStatements(params *GetStatementsParams, authInfo runtime.ClientAuthInfoWriter) (*GetStatementsOK, error)

	PostStatements(params *PostStatementsParams, authInfo runtime.ClientAuthInfoWriter) (*PostStatementsOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetStatements gets a list of statements

  Return a list of all available Statements
*/
func (a *Client) GetStatements(params *GetStatementsParams, authInfo runtime.ClientAuthInfoWriter) (*GetStatementsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetStatementsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getStatements",
		Method:             "GET",
		PathPattern:        "/statements",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetStatementsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetStatementsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getStatements: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostStatements creates new statements

  Create a new Statement for a particular Account with a Date Range
*/
func (a *Client) PostStatements(params *PostStatementsParams, authInfo runtime.ClientAuthInfoWriter) (*PostStatementsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostStatementsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postStatements",
		Method:             "POST",
		PathPattern:        "/statements",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostStatementsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostStatementsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postStatements: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
