// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package states

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetStatesParams creates a new GetStatesParams object
// with the default values initialized.
func NewGetStatesParams() *GetStatesParams {
	var ()
	return &GetStatesParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetStatesParamsWithTimeout creates a new GetStatesParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetStatesParamsWithTimeout(timeout time.Duration) *GetStatesParams {
	var ()
	return &GetStatesParams{

		timeout: timeout,
	}
}

// NewGetStatesParamsWithContext creates a new GetStatesParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetStatesParamsWithContext(ctx context.Context) *GetStatesParams {
	var ()
	return &GetStatesParams{

		Context: ctx,
	}
}

// NewGetStatesParamsWithHTTPClient creates a new GetStatesParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetStatesParamsWithHTTPClient(client *http.Client) *GetStatesParams {
	var ()
	return &GetStatesParams{
		HTTPClient: client,
	}
}

/*GetStatesParams contains all the parameters to send to the API endpoint
for the get states operation typically these are written to a http.Request
*/
type GetStatesParams struct {

	/*Country
	  The Country abbreviation (2 char)

	*/
	Country *string
	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64
	/*StateID
	  The State or Province abbreviation (2 char)

	*/
	StateID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get states params
func (o *GetStatesParams) WithTimeout(timeout time.Duration) *GetStatesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get states params
func (o *GetStatesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get states params
func (o *GetStatesParams) WithContext(ctx context.Context) *GetStatesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get states params
func (o *GetStatesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get states params
func (o *GetStatesParams) WithHTTPClient(client *http.Client) *GetStatesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get states params
func (o *GetStatesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCountry adds the country to the get states params
func (o *GetStatesParams) WithCountry(country *string) *GetStatesParams {
	o.SetCountry(country)
	return o
}

// SetCountry adds the country to the get states params
func (o *GetStatesParams) SetCountry(country *string) {
	o.Country = country
}

// WithLimit adds the limit to the get states params
func (o *GetStatesParams) WithLimit(limit *int64) *GetStatesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get states params
func (o *GetStatesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get states params
func (o *GetStatesParams) WithOffset(offset *int64) *GetStatesParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get states params
func (o *GetStatesParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithStateID adds the stateID to the get states params
func (o *GetStatesParams) WithStateID(stateID *string) *GetStatesParams {
	o.SetStateID(stateID)
	return o
}

// SetStateID adds the stateId to the get states params
func (o *GetStatesParams) SetStateID(stateID *string) {
	o.StateID = stateID
}

// WriteToRequest writes these params to a swagger request
func (o *GetStatesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Country != nil {

		// query param country
		var qrCountry string
		if o.Country != nil {
			qrCountry = *o.Country
		}
		qCountry := qrCountry
		if qCountry != "" {
			if err := r.SetQueryParam("country", qCountry); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if o.StateID != nil {

		// query param stateId
		var qrStateID string
		if o.StateID != nil {
			qrStateID = *o.StateID
		}
		qStateID := qrStateID
		if qStateID != "" {
			if err := r.SetQueryParam("stateId", qStateID); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
