// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package submissions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetSubmissionsParams creates a new GetSubmissionsParams object
// with the default values initialized.
func NewGetSubmissionsParams() *GetSubmissionsParams {
	var ()
	return &GetSubmissionsParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetSubmissionsParamsWithTimeout creates a new GetSubmissionsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetSubmissionsParamsWithTimeout(timeout time.Duration) *GetSubmissionsParams {
	var ()
	return &GetSubmissionsParams{

		timeout: timeout,
	}
}

// NewGetSubmissionsParamsWithContext creates a new GetSubmissionsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetSubmissionsParamsWithContext(ctx context.Context) *GetSubmissionsParams {
	var ()
	return &GetSubmissionsParams{

		Context: ctx,
	}
}

// NewGetSubmissionsParamsWithHTTPClient creates a new GetSubmissionsParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetSubmissionsParamsWithHTTPClient(client *http.Client) *GetSubmissionsParams {
	var ()
	return &GetSubmissionsParams{
		HTTPClient: client,
	}
}

/*GetSubmissionsParams contains all the parameters to send to the API endpoint
for the get submissions operation typically these are written to a http.Request
*/
type GetSubmissionsParams struct {

	/*AccountID
	  Taxnexus Id of the Account to be used a record retrieval

	*/
	AccountID *string
	/*Active
	  Retrieve only active records?

	*/
	Active *bool
	/*CompanyID
	  Taxnexus Id of the Company to be retrieved

	*/
	CompanyID *string
	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64
	/*SubmissionID
	  Taxnexus Id of the Submisssion to be retrieved

	*/
	SubmissionID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get submissions params
func (o *GetSubmissionsParams) WithTimeout(timeout time.Duration) *GetSubmissionsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get submissions params
func (o *GetSubmissionsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get submissions params
func (o *GetSubmissionsParams) WithContext(ctx context.Context) *GetSubmissionsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get submissions params
func (o *GetSubmissionsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get submissions params
func (o *GetSubmissionsParams) WithHTTPClient(client *http.Client) *GetSubmissionsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get submissions params
func (o *GetSubmissionsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the get submissions params
func (o *GetSubmissionsParams) WithAccountID(accountID *string) *GetSubmissionsParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the get submissions params
func (o *GetSubmissionsParams) SetAccountID(accountID *string) {
	o.AccountID = accountID
}

// WithActive adds the active to the get submissions params
func (o *GetSubmissionsParams) WithActive(active *bool) *GetSubmissionsParams {
	o.SetActive(active)
	return o
}

// SetActive adds the active to the get submissions params
func (o *GetSubmissionsParams) SetActive(active *bool) {
	o.Active = active
}

// WithCompanyID adds the companyID to the get submissions params
func (o *GetSubmissionsParams) WithCompanyID(companyID *string) *GetSubmissionsParams {
	o.SetCompanyID(companyID)
	return o
}

// SetCompanyID adds the companyId to the get submissions params
func (o *GetSubmissionsParams) SetCompanyID(companyID *string) {
	o.CompanyID = companyID
}

// WithLimit adds the limit to the get submissions params
func (o *GetSubmissionsParams) WithLimit(limit *int64) *GetSubmissionsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get submissions params
func (o *GetSubmissionsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get submissions params
func (o *GetSubmissionsParams) WithOffset(offset *int64) *GetSubmissionsParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get submissions params
func (o *GetSubmissionsParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithSubmissionID adds the submissionID to the get submissions params
func (o *GetSubmissionsParams) WithSubmissionID(submissionID *string) *GetSubmissionsParams {
	o.SetSubmissionID(submissionID)
	return o
}

// SetSubmissionID adds the submissionId to the get submissions params
func (o *GetSubmissionsParams) SetSubmissionID(submissionID *string) {
	o.SubmissionID = submissionID
}

// WriteToRequest writes these params to a swagger request
func (o *GetSubmissionsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccountID != nil {

		// query param accountId
		var qrAccountID string
		if o.AccountID != nil {
			qrAccountID = *o.AccountID
		}
		qAccountID := qrAccountID
		if qAccountID != "" {
			if err := r.SetQueryParam("accountId", qAccountID); err != nil {
				return err
			}
		}

	}

	if o.Active != nil {

		// query param active
		var qrActive bool
		if o.Active != nil {
			qrActive = *o.Active
		}
		qActive := swag.FormatBool(qrActive)
		if qActive != "" {
			if err := r.SetQueryParam("active", qActive); err != nil {
				return err
			}
		}

	}

	if o.CompanyID != nil {

		// query param companyId
		var qrCompanyID string
		if o.CompanyID != nil {
			qrCompanyID = *o.CompanyID
		}
		qCompanyID := qrCompanyID
		if qCompanyID != "" {
			if err := r.SetQueryParam("companyId", qCompanyID); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if o.SubmissionID != nil {

		// query param submissionId
		var qrSubmissionID string
		if o.SubmissionID != nil {
			qrSubmissionID = *o.SubmissionID
		}
		qSubmissionID := qrSubmissionID
		if qSubmissionID != "" {
			if err := r.SetQueryParam("submissionId", qSubmissionID); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
