// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package submissions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/sf-gate/sf_gate_models"
)

// PutSubmissionsReader is a Reader for the PutSubmissions structure.
type PutSubmissionsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutSubmissionsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutSubmissionsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutSubmissionsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutSubmissionsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutSubmissionsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutSubmissionsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPutSubmissionsOK creates a PutSubmissionsOK with default headers values
func NewPutSubmissionsOK() *PutSubmissionsOK {
	return &PutSubmissionsOK{}
}

/*PutSubmissionsOK handles this case with default header values.

Taxnexus Response with Submission objects
*/
type PutSubmissionsOK struct {
	Payload *sf_gate_models.SubmissionResponse
}

func (o *PutSubmissionsOK) Error() string {
	return fmt.Sprintf("[PUT /submissions][%d] putSubmissionsOK  %+v", 200, o.Payload)
}

func (o *PutSubmissionsOK) GetPayload() *sf_gate_models.SubmissionResponse {
	return o.Payload
}

func (o *PutSubmissionsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.SubmissionResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutSubmissionsUnauthorized creates a PutSubmissionsUnauthorized with default headers values
func NewPutSubmissionsUnauthorized() *PutSubmissionsUnauthorized {
	return &PutSubmissionsUnauthorized{}
}

/*PutSubmissionsUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PutSubmissionsUnauthorized struct {
	Payload *sf_gate_models.Error
}

func (o *PutSubmissionsUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /submissions][%d] putSubmissionsUnauthorized  %+v", 401, o.Payload)
}

func (o *PutSubmissionsUnauthorized) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutSubmissionsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutSubmissionsForbidden creates a PutSubmissionsForbidden with default headers values
func NewPutSubmissionsForbidden() *PutSubmissionsForbidden {
	return &PutSubmissionsForbidden{}
}

/*PutSubmissionsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PutSubmissionsForbidden struct {
	Payload *sf_gate_models.Error
}

func (o *PutSubmissionsForbidden) Error() string {
	return fmt.Sprintf("[PUT /submissions][%d] putSubmissionsForbidden  %+v", 403, o.Payload)
}

func (o *PutSubmissionsForbidden) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutSubmissionsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutSubmissionsNotFound creates a PutSubmissionsNotFound with default headers values
func NewPutSubmissionsNotFound() *PutSubmissionsNotFound {
	return &PutSubmissionsNotFound{}
}

/*PutSubmissionsNotFound handles this case with default header values.

Resource was not found
*/
type PutSubmissionsNotFound struct {
	Payload *sf_gate_models.Error
}

func (o *PutSubmissionsNotFound) Error() string {
	return fmt.Sprintf("[PUT /submissions][%d] putSubmissionsNotFound  %+v", 404, o.Payload)
}

func (o *PutSubmissionsNotFound) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutSubmissionsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutSubmissionsInternalServerError creates a PutSubmissionsInternalServerError with default headers values
func NewPutSubmissionsInternalServerError() *PutSubmissionsInternalServerError {
	return &PutSubmissionsInternalServerError{}
}

/*PutSubmissionsInternalServerError handles this case with default header values.

Server Internal Error
*/
type PutSubmissionsInternalServerError struct {
	Payload *sf_gate_models.Error
}

func (o *PutSubmissionsInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /submissions][%d] putSubmissionsInternalServerError  %+v", 500, o.Payload)
}

func (o *PutSubmissionsInternalServerError) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutSubmissionsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
