// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package subscriptions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetSubscriptionsParams creates a new GetSubscriptionsParams object
// with the default values initialized.
func NewGetSubscriptionsParams() *GetSubscriptionsParams {
	var ()
	return &GetSubscriptionsParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetSubscriptionsParamsWithTimeout creates a new GetSubscriptionsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetSubscriptionsParamsWithTimeout(timeout time.Duration) *GetSubscriptionsParams {
	var ()
	return &GetSubscriptionsParams{

		timeout: timeout,
	}
}

// NewGetSubscriptionsParamsWithContext creates a new GetSubscriptionsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetSubscriptionsParamsWithContext(ctx context.Context) *GetSubscriptionsParams {
	var ()
	return &GetSubscriptionsParams{

		Context: ctx,
	}
}

// NewGetSubscriptionsParamsWithHTTPClient creates a new GetSubscriptionsParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetSubscriptionsParamsWithHTTPClient(client *http.Client) *GetSubscriptionsParams {
	var ()
	return &GetSubscriptionsParams{
		HTTPClient: client,
	}
}

/*GetSubscriptionsParams contains all the parameters to send to the API endpoint
for the get subscriptions operation typically these are written to a http.Request
*/
type GetSubscriptionsParams struct {

	/*AccountID
	  Taxnexus Id of the Account to be used a record retrieval

	*/
	AccountID *string
	/*Active
	  Retrieve only active records?

	*/
	Active *bool
	/*CompanyID
	  Taxnexus Id of the Company to be retrieved

	*/
	CompanyID *string
	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64
	/*SubscriptionID
	  Taxnexus Id of the Subscription to be retrieved

	*/
	SubscriptionID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get subscriptions params
func (o *GetSubscriptionsParams) WithTimeout(timeout time.Duration) *GetSubscriptionsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get subscriptions params
func (o *GetSubscriptionsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get subscriptions params
func (o *GetSubscriptionsParams) WithContext(ctx context.Context) *GetSubscriptionsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get subscriptions params
func (o *GetSubscriptionsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get subscriptions params
func (o *GetSubscriptionsParams) WithHTTPClient(client *http.Client) *GetSubscriptionsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get subscriptions params
func (o *GetSubscriptionsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the get subscriptions params
func (o *GetSubscriptionsParams) WithAccountID(accountID *string) *GetSubscriptionsParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the get subscriptions params
func (o *GetSubscriptionsParams) SetAccountID(accountID *string) {
	o.AccountID = accountID
}

// WithActive adds the active to the get subscriptions params
func (o *GetSubscriptionsParams) WithActive(active *bool) *GetSubscriptionsParams {
	o.SetActive(active)
	return o
}

// SetActive adds the active to the get subscriptions params
func (o *GetSubscriptionsParams) SetActive(active *bool) {
	o.Active = active
}

// WithCompanyID adds the companyID to the get subscriptions params
func (o *GetSubscriptionsParams) WithCompanyID(companyID *string) *GetSubscriptionsParams {
	o.SetCompanyID(companyID)
	return o
}

// SetCompanyID adds the companyId to the get subscriptions params
func (o *GetSubscriptionsParams) SetCompanyID(companyID *string) {
	o.CompanyID = companyID
}

// WithLimit adds the limit to the get subscriptions params
func (o *GetSubscriptionsParams) WithLimit(limit *int64) *GetSubscriptionsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get subscriptions params
func (o *GetSubscriptionsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get subscriptions params
func (o *GetSubscriptionsParams) WithOffset(offset *int64) *GetSubscriptionsParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get subscriptions params
func (o *GetSubscriptionsParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithSubscriptionID adds the subscriptionID to the get subscriptions params
func (o *GetSubscriptionsParams) WithSubscriptionID(subscriptionID *string) *GetSubscriptionsParams {
	o.SetSubscriptionID(subscriptionID)
	return o
}

// SetSubscriptionID adds the subscriptionId to the get subscriptions params
func (o *GetSubscriptionsParams) SetSubscriptionID(subscriptionID *string) {
	o.SubscriptionID = subscriptionID
}

// WriteToRequest writes these params to a swagger request
func (o *GetSubscriptionsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccountID != nil {

		// query param accountId
		var qrAccountID string
		if o.AccountID != nil {
			qrAccountID = *o.AccountID
		}
		qAccountID := qrAccountID
		if qAccountID != "" {
			if err := r.SetQueryParam("accountId", qAccountID); err != nil {
				return err
			}
		}

	}

	if o.Active != nil {

		// query param active
		var qrActive bool
		if o.Active != nil {
			qrActive = *o.Active
		}
		qActive := swag.FormatBool(qrActive)
		if qActive != "" {
			if err := r.SetQueryParam("active", qActive); err != nil {
				return err
			}
		}

	}

	if o.CompanyID != nil {

		// query param companyId
		var qrCompanyID string
		if o.CompanyID != nil {
			qrCompanyID = *o.CompanyID
		}
		qCompanyID := qrCompanyID
		if qCompanyID != "" {
			if err := r.SetQueryParam("companyId", qCompanyID); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if o.SubscriptionID != nil {

		// query param subscriptionId
		var qrSubscriptionID string
		if o.SubscriptionID != nil {
			qrSubscriptionID = *o.SubscriptionID
		}
		qSubscriptionID := qrSubscriptionID
		if qSubscriptionID != "" {
			if err := r.SetQueryParam("subscriptionId", qSubscriptionID); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
