// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package subscriptions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/sf-gate/sf_gate_models"
)

// PostSubscriptionsReader is a Reader for the PostSubscriptions structure.
type PostSubscriptionsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostSubscriptionsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostSubscriptionsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostSubscriptionsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostSubscriptionsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostSubscriptionsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostSubscriptionsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostSubscriptionsOK creates a PostSubscriptionsOK with default headers values
func NewPostSubscriptionsOK() *PostSubscriptionsOK {
	return &PostSubscriptionsOK{}
}

/*PostSubscriptionsOK handles this case with default header values.

An array of Subscription Objects
*/
type PostSubscriptionsOK struct {
	Payload *sf_gate_models.SubscriptionResponse
}

func (o *PostSubscriptionsOK) Error() string {
	return fmt.Sprintf("[POST /subscriptions][%d] postSubscriptionsOK  %+v", 200, o.Payload)
}

func (o *PostSubscriptionsOK) GetPayload() *sf_gate_models.SubscriptionResponse {
	return o.Payload
}

func (o *PostSubscriptionsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.SubscriptionResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostSubscriptionsUnauthorized creates a PostSubscriptionsUnauthorized with default headers values
func NewPostSubscriptionsUnauthorized() *PostSubscriptionsUnauthorized {
	return &PostSubscriptionsUnauthorized{}
}

/*PostSubscriptionsUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PostSubscriptionsUnauthorized struct {
	Payload *sf_gate_models.Error
}

func (o *PostSubscriptionsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /subscriptions][%d] postSubscriptionsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostSubscriptionsUnauthorized) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PostSubscriptionsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostSubscriptionsForbidden creates a PostSubscriptionsForbidden with default headers values
func NewPostSubscriptionsForbidden() *PostSubscriptionsForbidden {
	return &PostSubscriptionsForbidden{}
}

/*PostSubscriptionsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostSubscriptionsForbidden struct {
	Payload *sf_gate_models.Error
}

func (o *PostSubscriptionsForbidden) Error() string {
	return fmt.Sprintf("[POST /subscriptions][%d] postSubscriptionsForbidden  %+v", 403, o.Payload)
}

func (o *PostSubscriptionsForbidden) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PostSubscriptionsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostSubscriptionsNotFound creates a PostSubscriptionsNotFound with default headers values
func NewPostSubscriptionsNotFound() *PostSubscriptionsNotFound {
	return &PostSubscriptionsNotFound{}
}

/*PostSubscriptionsNotFound handles this case with default header values.

Resource was not found
*/
type PostSubscriptionsNotFound struct {
	Payload *sf_gate_models.Error
}

func (o *PostSubscriptionsNotFound) Error() string {
	return fmt.Sprintf("[POST /subscriptions][%d] postSubscriptionsNotFound  %+v", 404, o.Payload)
}

func (o *PostSubscriptionsNotFound) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PostSubscriptionsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostSubscriptionsInternalServerError creates a PostSubscriptionsInternalServerError with default headers values
func NewPostSubscriptionsInternalServerError() *PostSubscriptionsInternalServerError {
	return &PostSubscriptionsInternalServerError{}
}

/*PostSubscriptionsInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostSubscriptionsInternalServerError struct {
	Payload *sf_gate_models.Error
}

func (o *PostSubscriptionsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /subscriptions][%d] postSubscriptionsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostSubscriptionsInternalServerError) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PostSubscriptionsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
