// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package workflow_client

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"
	httptransport "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/workflow/workflow_client/app_log"
	"code.tnxs.net/taxnexus/lib/api/workflow/workflow_client/cors"
	"code.tnxs.net/taxnexus/lib/api/workflow/workflow_client/email_message"
	"code.tnxs.net/taxnexus/lib/api/workflow/workflow_client/outgoing_email_message"
)

// Default workflow HTTP client.
var Default = NewHTTPClient(nil)

const (
	// DefaultHost is the default Host
	// found in Meta (info) section of spec file
	DefaultHost string = "workflow.fabric.tnxs.net:8080"
	// DefaultBasePath is the default BasePath
	// found in Meta (info) section of spec file
	DefaultBasePath string = "/v1"
)

// DefaultSchemes are the default schemes found in Meta (info) section of spec file
var DefaultSchemes = []string{"http"}

// NewHTTPClient creates a new workflow HTTP client.
func NewHTTPClient(formats strfmt.Registry) *Workflow {
	return NewHTTPClientWithConfig(formats, nil)
}

// NewHTTPClientWithConfig creates a new workflow HTTP client,
// using a customizable transport config.
func NewHTTPClientWithConfig(formats strfmt.Registry, cfg *TransportConfig) *Workflow {
	// ensure nullable parameters have default
	if cfg == nil {
		cfg = DefaultTransportConfig()
	}

	// create transport and client
	transport := httptransport.New(cfg.Host, cfg.BasePath, cfg.Schemes)
	return New(transport, formats)
}

// New creates a new workflow client
func New(transport runtime.ClientTransport, formats strfmt.Registry) *Workflow {
	// ensure nullable parameters have default
	if formats == nil {
		formats = strfmt.Default
	}

	cli := new(Workflow)
	cli.Transport = transport
	cli.AppLog = app_log.New(transport, formats)
	cli.Cors = cors.New(transport, formats)
	cli.EmailMessage = email_message.New(transport, formats)
	cli.OutgoingEmailMessage = outgoing_email_message.New(transport, formats)
	return cli
}

// DefaultTransportConfig creates a TransportConfig with the
// default settings taken from the meta section of the spec file.
func DefaultTransportConfig() *TransportConfig {
	return &TransportConfig{
		Host:     DefaultHost,
		BasePath: DefaultBasePath,
		Schemes:  DefaultSchemes,
	}
}

// TransportConfig contains the transport related info,
// found in the meta section of the spec file.
type TransportConfig struct {
	Host     string
	BasePath string
	Schemes  []string
}

// WithHost overrides the default host,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithHost(host string) *TransportConfig {
	cfg.Host = host
	return cfg
}

// WithBasePath overrides the default basePath,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithBasePath(basePath string) *TransportConfig {
	cfg.BasePath = basePath
	return cfg
}

// WithSchemes overrides the default schemes,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithSchemes(schemes []string) *TransportConfig {
	cfg.Schemes = schemes
	return cfg
}

// Workflow is a client for workflow
type Workflow struct {
	AppLog app_log.ClientService

	Cors cors.ClientService

	EmailMessage email_message.ClientService

	OutgoingEmailMessage outgoing_email_message.ClientService

	Transport runtime.ClientTransport
}

// SetTransport changes the transport on the client and all its subresources
func (c *Workflow) SetTransport(transport runtime.ClientTransport) {
	c.Transport = transport
	c.AppLog.SetTransport(transport)
	c.Cors.SetTransport(transport)
	c.EmailMessage.SetTransport(transport)
	c.OutgoingEmailMessage.SetTransport(transport)
}
