package app

import (
	"database/sql"

	"code.tnxs.net/taxnexus/lib/api/ledger/ledger_models"
)

// AccountingRuleActivityWrapper wraps the object with workflow params
type AccountingRuleActivityWrapper struct {
	Obj      ledger_models.AccountingRule
	APIKey   string
	SagaID   string
	SagaType string
}

// AccountingRule is a first class object type
type AccountingRule struct {
	ID                   string
	AccountID            string
	Code                 string
	COGSaccountID        string
	COGSaccountName      string
	CreatedByID          string
	CreatedDate          sql.NullTime
	CreditAccountID      string
	CreditAccountName    string
	DebitAccountID       string
	DebitAccountName     string
	Description          string
	InventoryAccountID   string
	InventoryAccountName string
	IsDeferred           bool
	LastModifiedByID     string
	LastModifiedDate     sql.NullTime
	ParentFK             string
	Proportion           float64
	TenantID             string
}
