package app

import (
	"database/sql"

	"code.tnxs.net/taxnexus/lib/api/ledger/ledger_models"
)

// AccountingRulesetActivityWrapper wraps the object with workflow params
type AccountingRulesetActivityWrapper struct {
	Obj      ledger_models.AccountingRuleset
	APIKey   string
	SagaID   string
	SagaType string
}

// AccountingRuleset is exported
type AccountingRuleset struct {
	ID               string
	Items            []*AccountingRulesetItem
	AccountID        string
	Code             string
	CreatedByID      string
	CreatedDate      sql.NullTime
	Description      string
	LastModifiedByID string
	LastModifiedDate sql.NullTime
	ParentFK         string
	RuleCount        int64
	TenantID         string
}
