package app

import (
	"database/sql"

	"code.tnxs.net/taxnexus/lib/api/regs/regs_models"
)

// BackendActivityWrapper wraps the object with workflow params
type BackendActivityWrapper struct {
	Obj      regs_models.Backend
	APIKey   string
	SagaID   string
	SagaType string
}

// Backend is a first class object type
type Backend struct {
	ID                  string
	AccountID           string
	Active              bool
	APIKey              string
	ApplicationName     string
	AuthType            string
	BackendName         string
	BaseURL             string
	CallbackURL         string
	ClientID            string
	ClientSecret        string
	CreatedByID         string
	CreatedDate         sql.NullTime
	CompanyID           string
	Description         string
	LastModifiedByID    string
	LastModifiedDate    sql.NullTime
	LoginURL            string
	ManagementPassword  string
	ManagementURL       string
	ManagementUsername  string
	MetrcLicense        string
	MetrcState          string
	OwnerID             string
	Password            string
	ProjectID           string
	ProviderCredentials string
	Realm               string
	Ref                 string
	ResellerBackendID   string
	SecurityToken       string
	TenantID            string
	Timeout             int64
	TokenURI            string
	Type                string
	Username            string
	Vendor              string
}
