package app

import (
	"database/sql"

	"code.tnxs.net/taxnexus/lib/api/ops/ops_models"
)

// ChargeActivityWrapper wraps the object with workflow params
type ChargeActivityWrapper struct {
	Obj      ops_models.Charge
	APIKey   string
	SagaID   string
	SagaType string
}

// Charge is a first class object type
type Charge struct {
	ID                    string
	AccountID             string
	AccountingRulesetCode string
	Amount                float64
	BillingContactID      string
	BillingEmail          string
	BillingRunID          string
	ContractHourlyRate    float64
	ContractID            string
	CreatedByID           string
	CreatedDate           sql.NullTime
	Description           string
	EmailMessage          string
	JournalDate           sql.NullTime
	LastModifiedByID      string
	LastModifiedDate      sql.NullTime
	PartnerAccountID      string
	PaymentTerms          string
	PeriodID              string
	Posted                bool
	ProductID             string
	Quantity              float64
	Ref                   string
	TemplateID            string
	TenantID              string
	Type                  string
	UnitPrice             float64
}
