package app

import (
	"database/sql"

	"code.tnxs.net/taxnexus/lib/api/devops/devops_models"
)

// ClusterActivityWrapper wraps the object with workflow params
type ClusterActivityWrapper struct {
	Obj      devops_models.Cluster
	APIKey   string
	SagaID   string
	SagaType string
}

// Cluster is a first class object type
type Cluster struct {
	ID               string
	CreatedByID      string
	CreatedDate      sql.NullTime
	Description      string
	Environment      string
	Gateway          string
	IPAddress        string
	LastModifiedByID string
	LastModifiedDate sql.NullTime
	Name             string
	OwnerID          string
	Ref              string
	Status           string
	Subnet           string
	TenantID         string
	Type             string
	Zone             string
}
