package app

import (
	"database/sql"

	"code.tnxs.net/taxnexus/lib/api/geo/geo_models"
)

// CountryActivityWrapper wraps the object with workflow params
type CountryActivityWrapper struct {
	Obj      geo_models.Country
	APIKey   string
	SagaID   string
	SagaType string
}

// Country is a first class object type
type Country struct {
	ID                  string
	AccountID           string
	Amount              float64
	Code                string
	ContactID           string
	CreatedByID         string
	CreatedDate         sql.NullTime
	EnrollmentStatus    string
	Interest            float64
	LastModifiedByID    string
	LastModifiedDate    sql.NullTime
	Longitude           float64
	Latitude            float64
	Name                string
	OwnerID             string
	Penalty             float64
	Ref                 string
	ReportedAdjustments float64
	ReportedDeductions  float64
	ReportedNetRevenue  float64
	ReportedRate        float64
	ReportedRevenue     float64
	RevenueBase         float64
	RevenueNet          float64
	RevenueNotTaxable   float64
	Status              string
	Subtotal            float64
	TaxInstances        []*TaxInstance
	TemplateID          string
	TotalAmount         float64
	UnitBase            float64
}
