package app

import (
	"database/sql"

	"code.tnxs.net/taxnexus/lib/api/devops/devops_models"
)

// DatabaseActivityWrapper wraps the object with workflow params
type DatabaseActivityWrapper struct {
	Obj      devops_models.Database
	APIKey   string
	SagaID   string
	SagaType string
}

// Database is a first-class object type
type Database struct {
	ID               string
	Active           bool
	ClusterID        string
	CreatedByID      string
	CreatedDate      sql.NullTime
	DatabaseName     string
	DSN              string
	LastModifiedByID string
	LastModifiedDate sql.NullTime
	Microservices    string
	Status           string
	TenantID         string
	Type             string
}
