package app

import (
	"database/sql"

	"code.tnxs.net/taxnexus/lib/api/ops/ops_models"
)

// EftActivityWrapper wraps the object with workflow params
type EftActivityWrapper struct {
	Obj      ops_models.Eft
	APIKey   string
	SagaID   string
	SagaType string
}

// Eft is a first class object type
type Eft struct {
	ID               string
	AccountID        string
	Amount           float64
	AttemptNumber    float64
	BackendID        string
	BillingRunID     string
	CashReceiptID    string
	CreatedByID      string
	CreatedDate      sql.NullTime
	Executed         sql.NullTime
	Fee              float64
	Gateway          string
	GatewayKey       string
	GatewayMessage   string
	JournalDate      sql.NullTime
	LastModifiedByID string
	LastModifiedDate sql.NullTime
	ParentFK         string
	PaymentMethodID  string
	Ref              string
	Status           string
	TenantID         string
	TransactionID    string
	Items            []*EftItem
}
