package app

import (
	"database/sql"

	"code.tnxs.net/taxnexus/lib/api/regs/regs_models"
)

// FilingTypeActivityWrapper wraps the object with workflow params
type FilingTypeActivityWrapper struct {
	Obj      regs_models.FilingType
	APIKey   string
	SagaID   string
	SagaType string
}

// FilingType is a first class object type
type FilingType struct {
	AccountID              string
	ContactID              string
	CreatedByID            string
	CreatedDate            sql.NullTime
	DueDates               []*FilingScheduleItem
	FilingCity             string
	FilingCountry          string
	FilingPostalCode       string
	FilingState            string
	FilingStreet           string
	FormName               string
	FormVersion            string
	Frequency              string
	FullName               string
	ID                     string
	Instances              []*FilingTypeInstance
	LastModifiedByID       string
	LastModifiedDate       sql.NullTime
	Level                  string
	Name                   string
	OwnerID                string
	SagaType               string
	SubmissionMethod       string
	TemplateInstructionsID string
	TemplateReturnID       string
}
