package app

import (
	"database/sql"

	"code.tnxs.net/taxnexus/lib/api/ledger/ledger_models"
)

// GlBalanceActivityWrapper wraps the object with workflow params
type GlBalanceActivityWrapper struct {
	Obj      ledger_models.GlBalance
	APIKey   string
	SagaID   string
	SagaType string
}

// GlBalance is a first class object type
type GlBalance struct {
	ID               string
	AccountName      string
	Amount           float64
	CloseDate        sql.NullTime
	CreatedByID      string
	CreatedDate      sql.NullTime
	Credits          float64
	Debits           float64
	Description      string
	GlAccountID      string
	GlAccountDisplay string
	LastModifiedByID string
	LastModifiedDate sql.NullTime
	PeriodID         string
	Ref              string
	RollupCredits    float64
	RollupDebits     float64
	Status           string
	TenantID         string
}
