package app

import (
	"database/sql"

	"code.tnxs.net/taxnexus/lib/api/ledger/ledger_models"
)

// JournalEntryActivityWrapper wraps the object with workflow params
type JournalEntryActivityWrapper struct {
	Obj      ledger_models.JournalEntry
	APIKey   string
	SagaID   string
	SagaType string
}

// JournalEntry is a first class object type
type JournalEntry struct {
	ID               string
	AccountID        string
	Balanced         bool
	CreatedByID      string
	CreatedDate      sql.NullTime
	Credits          float64
	Debits           float64
	Description      string
	IngestID         string
	Items            []*JournalItem
	JournalDate      sql.NullTime
	LastModifiedByID string
	LastModifiedDate sql.NullTime
	ParentFK         string
	PeriodID         string
	Posted           bool
	Ref              string
	SalesRegulation  string
	Status           string
	TenantID         string
}
