package app

import (
	"database/sql"

	"code.tnxs.net/taxnexus/lib/api/regs/regs_models"
)

// LicenseActivityWrapper wraps the object with workflow params
type LicenseActivityWrapper struct {
	Obj      regs_models.License
	APIKey   string
	SagaID   string
	SagaType string
}

// License is a first class object type
type License struct {
	ID               string
	AccountID        string
	BackendID        string
	ContactID        string
	CreatedByID      string
	CreatedDate      sql.NullTime
	DateIssued       sql.NullTime
	Designation      string
	ExpirationDate   sql.NullTime
	IsCanceled       bool
	IsRevoked        bool
	LastModifiedByID string
	LastModifiedDate sql.NullTime
	LicenseNumber    string
	LicenseTypeID    string
	OwnerID          string
	ParentFK         string
	Ref              string
	Status           string
	TenantID         string
}
