package app

import (
	"database/sql"

	"code.tnxs.net/taxnexus/lib/api/regs/regs_models"
)

// NotebookActivityWrapper wraps the object with workflow params
type NotebookActivityWrapper struct {
	Obj      regs_models.Notebook
	APIKey   string
	SagaID   string
	SagaType string
}

// Notebook is a first class object type
type Notebook struct {
	ID               string
	AccountID        string
	ContactID        string
	CreatedByID      string
	CreatedDate      sql.NullTime
	Date             sql.NullTime
	DateEnd          sql.NullTime
	DateStart        sql.NullTime
	Description      string
	LastModifiedByID string
	LastModifiedDate sql.NullTime
	PeriodEndID      string
	PeriodStartID    string
	PreparerID       string
	Title            string
	Items            []*NotebookItem
	TenantID         string
}
