package app

import (
	"database/sql"
)

// PaymentMethodActivityWrapper wraps the object with workflow params
type PaymentMethodActivityWrapper struct {
	APIKey   string
	SagaID   string
	SagaType string
	//
	AccountID        string
	AchAccountType   string
	AchBankAccount   string
	AchRouting       string
	Active           bool
	Autopay          bool
	BankName         string
	BillingContactID string
	CCnumber         string
	CCtype           string
	ContractID       string
	Default          bool
	ExpirationMonth  string
	ExpirationYear   string
	Gateway          string
	GatewayKey       string
	Nickname         string
	RecordType       string
	Ref              string
	TenantID         string
}

// PaymentMethod is a first class object type
type PaymentMethod struct {
	ID               string
	AccountID        string
	AchAccountType   string
	AchBankAccount   string
	AchRouting       string
	Active           bool
	Autopay          bool
	BankName         string
	BillingContactID string
	CCnumber         string
	CCtype           string
	CompanyID        string
	ContractID       string
	CreatedByID      string
	CreatedDate      sql.NullTime
	Default          bool
	ExpirationDate   sql.NullTime
	ExpirationMonth  string
	ExpirationYear   string
	Gateway          string
	GatewayKey       string
	LastModifiedByID string
	LastModifiedDate sql.NullTime
	Nickname         string
	RecordType       string
	Ref              string
	TenantID         string
}
