package app

import (
	"database/sql"

	"code.tnxs.net/taxnexus/lib/api/ops/ops_models"
)

// PurchaseOrderItemActivityWrapper wraps the object with workflow params
type PurchaseOrderItemActivityWrapper struct {
	Obj      ops_models.PurchaseOrderItem
	APIKey   string
	SagaID   string
	SagaType string
}

// PurchaseOrderItem is a first class object type
type PurchaseOrderItem struct {
	ID                  string
	CreatedByID         string
	CreatedDate         sql.NullTime
	Description         string
	DueDate             sql.NullTime
	Family              string
	LastModifiedByID    string
	LastModifiedDate    sql.NullTime
	LocationID          string
	MRCInterval         int64
	OrderItemID         string
	ParentFK            string
	PurchaseOrderID     string
	ProductCode         string
	ProductID           string
	ProductName         string
	Quantity            float64
	QuoteItemID         string
	ReceivedQuantity    float64
	Ref                 string
	RejectedQuantity    float64
	ShippmentItemID     string
	ShippingHandling    float64
	Status              string
	StockedQuantity     float64
	Subtotal            float64
	TaxnexusCodeDisplay string
	TaxnexusCodeID      string
	TenantID            string
	UnitPrice           float64
	Units               string
}
