package app

import (
	"database/sql"

	"code.tnxs.net/taxnexus/lib/api/ops/ops_models"
)

// ProductActivityWrapper wraps the object with workflow params
type ProductActivityWrapper struct {
	Obj      ops_models.Product
	APIKey   string
	SagaID   string
	SagaType string
}

// Product is a first class object type
type Product struct {
	ID                      string
	AccountID               string
	AgencyType              string
	AssetTracking           bool
	CreatedByID             string
	CreatedDate             sql.NullTime
	Description             string
	DescriptionSKU          string
	DisplayURL              string
	Family                  string
	Image500                string
	ImageFull               string
	InventoryTracking       bool
	IsActive                bool
	IsGeneric               bool
	LastModifiedByID        string
	LastModifiedDate        sql.NullTime
	Manufacturer            string
	ManufacturerProductCode string
	MRCInterval             int64
	MSRP                    float64
	Name                    string
	ProductCode             string
	Prorateable             bool
	Publish                 bool
	PublishUPC              string
	QuantityUnitOfMeasure   string
	Refundable              bool
	ShippingWeight          float64
	SKU                     string
	Specifications          string
	TaxnexusCode            string
	TaxnexusCodeID          string
	TenantID                string
	Units                   string
	VendorID                string
	VendorName              string
	VendorPartNumber        string
	VendorPrice             float64
}
