package app

import (
	"database/sql"

	"code.tnxs.net/taxnexus/lib/api/ops/ops_models"
)

// QuoteItemActivityWrapper wraps the object with workflow params
type QuoteItemActivityWrapper struct {
	Obj      ops_models.QuoteItem
	APIKey   string
	SagaID   string
	SagaType string
}

// QuoteItem is a first class object type
type QuoteItem struct {
	ID                  string
	COGS                float64
	CreatedByID         string
	CreatedDate         sql.NullTime
	Description         string
	Discount            float64
	DiscountAmount      float64
	Family              string
	LastModifiedByID    string
	LastModifiedDate    sql.NullTime
	ListPrice           float64
	LocationID          string
	MRCInterval         int64
	ParentFK            string
	ProductCode         string
	ProductID           string
	ProductName         string
	Quantity            float64
	QuoteID             string
	Ref                 string
	ServiceDate         sql.NullTime
	ShippingHandling    float64
	Subtotal            float64
	SupplierID          string
	TaxnexusCodeDisplay string
	TaxnexusCodeID      string
	TenantID            string
	TotalPrice          float64
	UnitPrice           float64
	Units               string
}
