package app

import (
	"database/sql"

	"code.tnxs.net/taxnexus/lib/api/devops/devops_models"
)

// ServiceActivityWrapper wraps the object with workflow params
type ServiceActivityWrapper struct {
	Obj      devops_models.Service
	APIKey   string
	SagaID   string
	SagaType string
}

// Service is a first class object type
type Service struct {
	ID               string
	Active           bool
	ClusterID        string
	ClusterIP        string
	ClusterURL       string
	CreatedByID      string
	CreatedDate      sql.NullTime
	Environment      string
	ExternalURL      string
	GELFAddress      string
	LastModifiedByID string
	LastModifiedDate sql.NullTime
	NetworkAlias     string
	OpenAPIVersion   string
	OwnerID          string
	PortExternal     string
	PortTest         string
	ProxyType        string
	Replicas         int64
	RepoURL          string
	ServiceName      string
	TenantID         string
	Version          string
}
