package app

import (
	"database/sql"

	"code.tnxs.net/taxnexus/lib/api/regs/regs_models"
)

// SubmissionActivityWrapper wraps the object with workflow params
type SubmissionActivityWrapper struct {
	Obj      regs_models.Submission
	APIKey   string
	SagaID   string
	SagaType string
}

// Submission is a first class object type
type Submission struct {
	ID                  string
	CompanyID           string
	ContactID           string
	CreatedByID         string
	CreatedDate         sql.NullTime
	LastModifiedByID    string
	LastModifiedDate    sql.NullTime
	Notes               string
	Penalty             float64
	ParentFK            string
	Ref                 string
	ReportedAdjustments float64
	ReportedDeductions  float64
	ReportedNetRevenue  float64
	ReportedRate        float64
	ReportedRevenue     float64
	RevenueBase         float64
	RevenueNet          float64
	RevenueNotTaxable   float64
	Status              string
	Subtotal            float64
	SubmissionDate      sql.NullTime
	SubmissionNumber    string
	TaxTypeID           string
	TotalAmount         float64
	TenantID            string
}
