package app

import (
	"database/sql"

	"code.tnxs.net/taxnexus/lib/api/geo/geo_models"
)

// TaxnexusCodeActivityWrapper wraps the object with workflow params
type TaxnexusCodeActivityWrapper struct {
	Obj      geo_models.TaxnexusCode
	APIKey   string
	SagaID   string
	SagaType string
}

// TaxnexusCode is a first class object type
type TaxnexusCode struct {
	ID                    string
	Active                bool
	Code                  string
	CreatedByID           string
	CreatedDate           sql.NullTime
	Description           string
	DomainID              string
	DomainName            string
	LastModifiedByID      string
	LastModifiedDate      sql.NullTime
	Level                 string
	OwnerID               string
	Part1                 string
	Part2                 string
	Part3                 string
	Part4                 string
	Part5                 string
	PurchasingRulesetID   string
	PurchasingRulesetCode string
	Ref                   string
	RevenueRulesetID      string
	RevenueRulesetCode    string
}
