package app

import (
	"database/sql"

	"code.tnxs.net/taxnexus/lib/api/ops/ops_models"
)

// TaxTransactionActivityWrapper wraps the object with workflow params
type TaxTransactionActivityWrapper struct {
	Obj      ops_models.TaxTransaction
	APIKey   string
	SagaID   string
	SagaType string
}

// TaxTransaction is the in-memory struct for a Taxnexus Tax Transaction
type TaxTransaction struct {
	ID                  string
	AccountID           string
	AccountingRuleCode  string
	Amount              float64
	CoordinateID        string
	CreatedByID         string
	CreatedDate         sql.NullTime
	CustomerID          string
	DisplayName         string
	EffectiveRate       float64
	FilingID            string
	IngestID            string
	InvoiceID           string
	InvoiceItemID       string
	IsSummary           bool
	IsUseTax            bool
	JobID               string
	JournalDate         sql.NullTime
	JournalItemID       string
	LastModifiedByID    string
	LastModifiedDate    sql.NullTime
	OrderID             string
	OrderItemID         string
	ParentRef           string
	PercentTaxable      float64
	PeriodID            string
	PlaceGeoCode        string
	PlaceID             string
	PoID                string
	PoItemID            string
	Posted              bool
	QuoteID             string
	QuoteItemID         string
	RatingType          string
	Ref                 string
	RevenueBase         float64
	RevenueNet          float64
	RevenueNotTaxable   float64
	SalesRegulation     string
	TaxexemptRevenue    float64
	TaxnexusCodeDisplay string
	TaxnexusCodeID      string
	TaxOnTax            float64
	TaxRate             float64
	TaxTypeAccountID    string
	TaxTypeID           string
	TenantID            string
	UnitBase            float64
	UnitFeeRate         float64
}
