package app

import (
	"database/sql"
)

// TenantActivityWrapper wraps the object with workflow params
type TenantActivityWrapper struct {
	APIKey   string
	SagaID   string
	SagaType string
	//
	AccountID   string
	Active      bool
	Databases   []Database
	Roles       []Role
	Status      string
	TenantName  string
	TenantUsers []TenantUser
	Type        string
	Version     string
}

// Tenant is a first class object type
type Tenant struct {
	ID               string
	AccountID        string
	Active           bool
	CreatedByID      string
	CreatedDate      sql.NullTime
	Databases        []*Database
	LastModifiedByID string
	LastModifiedDate sql.NullTime
	Roles            []*Role
	Status           string
	TenantName       string
	TenantUsers      []*TenantUser
	Type             string
	Version          string
}
