package app

import "code.tnxs.net/taxnexus/lib/api/devops/devops_models"

// UnMarshalTenantUser encodes first class object
func UnMarshalTenantUser(s *devops_models.TenantUser) *TenantUser {
	return &TenantUser{
		AccessLevel:     s.AccessLevel,
		AccountID:       s.AccountID,
		CompanyName:     s.CompanyName,
		TenantActive:    s.TenantActive,
		TenantID:        s.TenantID,
		TenantName:      s.TenantName,
		TenantStatus:    s.TenantStatus,
		TenantType:      s.TenantType,
		TenantVersion:   s.TenantVersion,
		UserID:          s.UserID,
		Auth0UserID:     s.Auth0UserID,
		ContactID:       s.ContactID,
		TaxnexusAccount: s.TaxnexusAccount,
		UserEmail:       s.UserEmail,
		UserFullName:    s.UserFullName,
		Username:        s.Username,
	}
}

// MarshalToSwagger encodes first class object
func (obj *TenantUser) MarshalToSwagger() *devops_models.TenantUser {
	return &devops_models.TenantUser{
		AccessLevel:     obj.AccessLevel,
		AccountID:       obj.AccountID,
		Auth0UserID:     obj.Auth0UserID,
		CompanyName:     obj.CompanyName,
		ContactID:       obj.ContactID,
		TaxnexusAccount: obj.TaxnexusAccount,
		TenantActive:    obj.TenantActive,
		TenantID:        obj.TenantID,
		TenantName:      obj.TenantName,
		TenantStatus:    obj.TenantStatus,
		TenantType:      obj.TenantType,
		TenantVersion:   obj.TenantVersion,
		UserEmail:       obj.UserEmail,
		UserFullName:    obj.UserFullName,
		UserID:          obj.UserID,
		Username:        obj.Username,
	}
}
