package app

import (
	"database/sql"

	"code.tnxs.net/taxnexus/lib/api/regs/regs_models"
)

// TransactionItemActivityWrapper wraps the object with workflow params
type TransactionItemActivityWrapper struct {
	Obj      regs_models.Transaction
	APIKey   string
	SagaID   string
	SagaType string
}

// Transaction is a first class object type
type Transaction struct {
	ID               string
	AccountID        string
	CreatedByID      string
	CreatedDate      sql.NullTime
	LastModifiedByID string
	LastModifiedDate sql.NullTime
	TaxTypeID        string
	TaxTransactionID string
	TenantID         string
	Valid            bool
}
