package app

import (
	"code.tnxs.net/taxnexus/lib/api/devops/devops_models"
	"github.com/go-openapi/runtime"
)

// UserActivityWrapper wraps the object with workflow params
type UserActivityWrapper struct {
	Obj      devops_models.User
	APIKey   string
	SagaID   string
	SagaType string
}

// User is a first class object type
type User struct {
	ID                      string
	AboutMe                 string
	AccountID               string
	Address                 *Address
	Alias                   string
	APIKey                  string
	Auth                    runtime.ClientAuthInfoWriter
	Auth0UserID             string
	CommunityNickname       string
	CompanyName             string
	ContactID               string
	CreatedByID             string
	CreatedDate             string
	DelegatedApproverID     string
	Department              string
	Division                string
	Email                   string
	EmployeeNumber          string
	EndOfDay                string
	Environment             string
	Extension               string
	FabricAPIKey            string
	Fax                     string
	FirstName               string
	ForecastEnabled         bool
	FullPhotoURL            string
	IsActive                bool
	IsPortalEnabled         bool
	IsProfilePhotoActive    bool
	IsSystemControlled      bool
	LastIP                  string
	LastLogin               string
	LastModifiedByID        string
	LastModifiedDate        string
	LastName                string
	LoginCount              int64
	ManagerID               string
	MobilePhone             string
	Name                    string
	OutOfOfficeMessage      string
	Phone                   string
	PortalRole              string
	ProfileID               string
	ReceivesAdminEmails     bool
	ReceivesAdminInfoEmails bool
	ReceivesInfoEmails      bool
	SenderEmail             string
	SenderName              string
	Signature               string
	SmallPhotoURL           string
	StartOfDay              string
	TaxnexusAccount         string
	TenantID                string
	TenantUsers             []*TenantUser
	TimeZone                string
	Title                   string
	Username                string
	UserRoles               []*UserRole
	UserRoleID              string
	UserType                string
}
